'From Squeak 2.3 of January 14, 1999 on 23 April 1999 at 12:15:45 pm'!
"Change Set:		wnld-cleanup-jsp
Date:			23 April 1999
Author:			Jeff Pierce

A fix to Wonderland to clean up UniClasses completely."!


!Wonderland methodsFor: 'initialize-reset-release' stamp: 'jsp 4/23/1999 12:11'!
release
	"This method cleans up the Wonderland."

	cameraList do: [:camera | camera release].

	scriptEditor delete.

	"Clean up any uniclasses we created"
	actorClassList do: [:aClass | aClass removeFromSystem ].
! !

!Wonderland methodsFor: 'initialize-reset-release' stamp: 'jsp 4/23/1999 12:13'!
reset
	"Reset this Wonderland"

	| ground |

	"Reset the scheduler"
	myScheduler reset.

	"Reset the shared mesh and texture directories"
	sharedMeshDict _ Dictionary new.
	sharedTextureDict _ Dictionary new.

	"Reset the list of actor uniclasses"
	actorClassList do: [:aClass | aClass removeFromSystem ].
	actorClassList _ OrderedCollection new.

	"Initialize this Wonderland's shared namespace"
	myNamespace _ WonderlandConstants copy.

	"Rebuild the namespace"
	myNamespace at: 'scheduler' put: myScheduler.
	myNamespace at: 'w' put: self.

	"Create a new scene"
	sceneObject _ WonderlandScene newFor: self.
	myNamespace at: 'scene' put: sceneObject.

	"Recreate the default objects"
	ground _ self makeActor.
	ground setMesh: (WonderlandConstants at: 'groundMesh').
	ground setTexturePointer: (WonderlandConstants at: 'groundTexture').
	ground becomePart.
	ground setName: 'ground'.
	ground setColor: {0.2902. 0.8000. 0.0000} duration: rightNow.
	myNamespace at: 'ground' put: ground.

	"Re-initialize the light list and create a default light"
	lightList _ OrderedCollection new.
	lightList addLast: (B3DAmbientLight color: Color white).

	"Wipe out the existing cameras"
	cameraList do: [:camera | camera release].
	
	"Recreate the default camera"
	cameraList _ OrderedCollection new.
	defaultCamera _ WonderlandCamera createFor: self.
	cameraList addLast: defaultCamera.
	myNamespace at: 'camera' put: defaultCamera.
	myNamespace at: 'cameraWindow' put: (defaultCamera getMorph).
	defaultCamera setName: 'camera'.

	"Reset the script editor's namespace"
	scriptEditor resetNamespace.

	"Update the actor browser"
	scriptEditor updateActorBrowser.

	"Reset the undo stack"
	myUndoStack reset.


! !


!Wonderland class methodsFor: 'actor prototype mgmt' stamp: 'jsp 4/23/1999 12:11'!
removeActorPrototypesFromSystem
	"Clean out all the actor prototypes - this involves removing those classes from the Smalltalk dictionary"

	ActorPrototypeClasses do: [:aClass | aClass removeFromSystem ].

	ActorPrototypeClasses _ Dictionary new.
! !


