'From Squeak 2.4b of April 23, 1999 on 28 April 1999 at 1:40:06 pm'!
"Change Set:		aFewFixes-sw
Date:			28 April 1999
Author:			Scott Wallace

(1)	Fixes ChangeSorter class-side method #highestNumberedChangeSet so that it returns nil rather than failing if there are NO numbered changesets.

(2)	Restores the availability of the JoystickMorph in the 'new morph' menu.

(3)	Removes the problem wherein multiple copies of the same player could get into a presenter's playerlist, resulting in multiple firings of its scripts each tick.

(4)	Take down the 'initializing the network drivers...' message after the init is complete, while updates are being loaded -- fixing an annoyance when updating from server within a morphic project.
"!


!ChangeSorter class methodsFor: 'as yet unclassified' stamp: 'sw 4/21/1999 17:04'!
highestNumberedChangeSet
	"ChangeSorter highestNumberedChangeSet"
	| aList |
	aList _ (self allChangeSetNames select: [:aString | aString startsWithDigit] thenCollect:
		[:aString | aString initialInteger]).
	^ (aList size > 0)
		ifTrue:
			[aList max]
		ifFalse:
			[nil]
! !


!JoystickMorph class methodsFor: 'as yet unclassified' stamp: 'sw 4/26/1999 16:02'!
includeInNewMorphMenu
	^ true! !


!NetNameResolver class methodsFor: 'network initialization' stamp: 'sw 4/28/1999 13:36'!
initializeNetworkIfFail: errorBlock
	"Initialize the network drivers and record the semaphore to be used by the resolver. Do nothing if the network is already initialized. Evaluate the given block if network initialization fails."
	"NetNameResolver initializeNetworkIfFail: [self error: 'network initialization failed']"

	| semaIndex result |
	self primNameResolverStatus = ResolverUninitialized
		ifFalse: [
			LastContact _ Time totalSeconds.  HaveNetwork _ true.
			^ self].  "network is already initialized"

	LastContact _ Time totalSeconds.  HaveNetwork _ false.	"in case abort"
	ResolverSemaphore _ Semaphore new.
	semaIndex _ Smalltalk registerExternalObject: ResolverSemaphore.

	Utilities informUser:
'Initializing the network drivers; this may
take up to 30 seconds and can''t be interrupted'
		during: [result _ self primInitializeNetwork: semaIndex].
	Smalltalk isMorphic ifTrue: [World displayWorld].  "take the informer down"

	"result is nil if network initialization failed, self if it succeeds"
	result ifNil: [errorBlock value]
		ifNotNil: [HaveNetwork _ true].
! !


!Presenter methodsFor: 'playerList' stamp: 'sw 4/21/1999 10:47'!
allExtantPlayers
	"The initial intent here was to produce a list of Player objects associated with any Morph in the tree beneath the receiver's associatedMorph.  whether it is the submorph tree or perhaps off on unseen bookPages.  We have for the moment moved away from that initial intent, and in the current version we only deliver up players associated with the submorph tree only.

Call #flushPlayerListCache to force recomputation."

	playerList ifNotNil:
		[^ playerList].

	^ playerList _ (associatedMorph allMorphs select: 
		[:m | m player ~~ nil] thenCollect: [:m | m player]) asSet asArray! !


