'From Squeak 2.0 of May 22, 1998 on 23 June 1998 at 9:51:11 am'!
"Change Set:		BigSleep-di
Date:			23 June 1998
Author:			Dan Ingalls

Defines WorldMorph>>sleep, and calls it prior to project switches.  The sleep process recursively releases all cached state in all morphs of the world, and compresses all image forms.
"!


!Project methodsFor: 'menu messages' stamp: 'di 6/23/1998 09:36'!
saveState
	"Save the current state in me prior to leaving this project"

	changeSet _ Smalltalk changes.
	world isMorph
		ifTrue: [world _ World.
				self dependents do:
					[:d | (d isKindOf: SystemWindow)
						ifTrue: [d label ~= changeSet name ifTrue: [self changed: #relabel]]].
				world sleep "Release all space possible in old world"]
		ifFalse: [world _ ScheduledControllers.
				ScheduledControllers unCacheWindows.
				self dependents do:
					[:d | (d isKindOf: StandardSystemView)
						ifTrue: [d label ~= changeSet name ifTrue: [self changed: #relabel]]]].
	transcript _ Transcript.
	displayDepth _ Display depth.
	activeProcess _ nil
! !


!WorldMorph methodsFor: 'install / exit' stamp: 'di 6/23/1998 09:28'!
exit

	self sleep.
	Project current exit.
! !

!WorldMorph methodsFor: 'install / exit' stamp: 'di 6/23/1998 09:28'!
goBack

	self sleep.
	Project returnToPreviousProject.
! !

!WorldMorph methodsFor: 'install / exit' stamp: 'di 6/23/1998 09:27'!
sleep

	Cursor normal show.	"restore the normal cursor"
	self canvas: nil.		"free my canvas to save space"
	self fullReleaseCachedState.
! !


"Postscript:
Release all cached state in this image."
WorldMorph allInstancesDo: [:w | w sleep].
!

