'From Squeak 2.4b of April 23, 1999 on 29 June 1999 at 1:31:33 am'!
"Change Set:		WnldStillCamera
Date:			29 June 1999
Author:			Jeff Pierce

Implements a still camera for Wonderlands (for use in the Actor Info tab)."!

WonderlandCamera subclass: #WonderlandStillCamera
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wonderland-Objects'!
WonderlandCameraMorph subclass: #WonderlandStillCameraMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wonderland-Morphs'!

!WonderlandStillCamera methodsFor: 'initialize-release' stamp: 'jsp 6/29/1999 01:01'!
initializeFor: aWonderland
	"Initializes the camera."

	super initializeFor: aWonderland.
	
	"Set the camera initial position"
	composite translation: (B3DVector3 x: -1.5 y: 0.5 z: 2.6).
	self turnTo: #(180 -30 180) duration: #rightNow.

	"Initialize the camera viewing parameters"
	perspective _ B3DCameraPerspective new.
	self setFieldOfView: 40.0.
	self setAspectRatio: 1.0.
	self setNearClippingPlane: 0.1.
	self setFarClippingPlane: 10000.0.

	viewMatrix _ B3DMatrix4x4 new.

	"Create a WonderlandCameraMorph for the camera to render into"
	myMorph _ WonderlandStillCameraMorph new.
	myMorph initializeWithCamera: self.

	"Initially don't draw the scene background"
	drawSceneBackground _ false.
! !


!WonderlandStillCameraMorph methodsFor: 'stepping' stamp: 'jsp 6/29/1999 01:07'!
wantsSteps

	^ false.
! !

!WonderlandStillCameraMorph methodsFor: 'controls' stamp: 'jsp 6/29/1999 01:20'!
hideCameraControls
	"Override our parent method to do nothing."



! !

!WonderlandStillCameraMorph methodsFor: 'controls' stamp: 'jsp 6/29/1999 01:20'!
showCameraControls
	"Override the parent method to do nothing."

! !

!WonderlandStillCameraMorph methodsFor: 'event handling' stamp: 'jsp 6/29/1999 01:08'!
handlesMouseDown: evt
	"We don't want to handle mouse up and down events, so return false"

	^ false.
! !

!WonderlandStillCameraMorph methodsFor: 'event handling' stamp: 'jsp 6/29/1999 01:08'!
handlesMouseOver: evt
	"We don't want to handle mouse enter/leave events, so return false."

	^ false.

! !


