'From Squeak 2.4c of May 10, 1999 on 6 July 1999 at 10:17:08 am'!
"Change Set:		flapFixes-sw
Date:			6 July 1999
Author:			Scott Wallace

Preserve tab color upon switching back to textual form.

Constrain tab to fit on screen when user tries to drag it out of view in its orthogonal direction."!


!FlapTab methodsFor: 'positioning' stamp: 'sw 7/6/1999 09:57'!
fitOnScreen
	| constrainer |
	constrainer _ owner ifNil: [self].
	self orientation == #vertical
			ifTrue:
				[self top: ((self top min: (constrainer bottom- self height)) max: 0)]
			ifFalse:
				[self left: ((self left min: (constrainer right - self width)) max: 0)]! !

!FlapTab methodsFor: 'positioning' stamp: 'sw 7/6/1999 10:08'!
mouseMove: evt
	| aPosition newReferentThickness adjustedPosition thick |

	dragged ifFalse: [(thick _ self referentThickness) > 0
			ifTrue: [lastReferentThickness _ thick]].
	((self containsPoint: (aPosition _ evt cursorPoint)) and: [dragged not])
		ifFalse:
			[flapShowing ifFalse: [self showFlap].
			adjustedPosition _ aPosition - evt hand targetOffset.
			(edgeToAdhereTo == #bottom)
				ifTrue:
					[newReferentThickness _ inboard
						ifTrue:
							[self world height - adjustedPosition y]
						ifFalse:
							[self world height - adjustedPosition y - self height]].

			(edgeToAdhereTo == #left)
					ifTrue:
						[newReferentThickness _
							inboard
								ifTrue:
									[adjustedPosition x + self width]
								ifFalse:
									[adjustedPosition x]].

			(edgeToAdhereTo == #right)
					ifTrue:
						[newReferentThickness _
							inboard
								ifTrue:
									[self world width - adjustedPosition x]
								ifFalse:
									[self world width - adjustedPosition x - self width]].

			(edgeToAdhereTo == #top)
					ifTrue:
						[newReferentThickness _
							inboard
								ifTrue:
									[adjustedPosition y + self height]
								ifFalse:
									[adjustedPosition y]].
		
			self isCurrentlySolid ifFalse:
				[(#(left right) includes: edgeToAdhereTo)
					ifFalse:
						[self left: adjustedPosition x]
					ifTrue:
						[self top: adjustedPosition y]].

			self applyThickness: newReferentThickness.

			dragged _ true.

		self fitOnScreen]! !

!FlapTab methodsFor: 'positioning' stamp: 'sw 7/6/1999 08:54'!
mouseUp: evt
	super mouseUp: evt.
	self referentThickness <= 0 ifTrue: [flapShowing _ false].
	dragged _ false.
	self fitOnScreen.! !

!FlapTab methodsFor: 'textual tabs' stamp: 'sw 7/6/1999 09:54'!
useTextualTab
	| stringToUse colorToUse |
	self preserveDetails.
	colorToUse _ self valueOfProperty: #priorColor ifAbsent: [Color green muchLighter].
	submorphs size > 0 ifTrue: [self removeAllMorphs].
	stringToUse _ self valueOfProperty: #priorWording ifAbsent: ['Unnamed Flap'].
	self assumeString: stringToUse font: ScriptingSystem fontForScriptorButtons orientation: self orientation color: colorToUse.
! !


