'From Squeak 2.4b of April 23, 1999 on 8 July 1999 at 11:20:35 pm'!
"Change Set:		WnldChanges
Date:			8 July 1999
Author:			Jeff Pierce

This change set primarily makes the ActorViewer update its information every second. It also changes the way WonderlandCameras and WonderlandStillCameras determine change logging so that I can start using protoclasses for Cameras."!

Morph subclass: #WonderlandActorViewer
	instanceVariableNames: 'thumbnailMorph thumbnailCamera selectedActor dataMorph updatingIsOn updatingAction '
	classVariableNames: ''
	poolDictionaries: 'WonderlandConstants '
	category: 'Wonderland-Morphs'!

!WonderlandActor methodsFor: 'accessing' stamp: 'jsp 7/8/1999 23:20'!
hasParts
	"Return true if the receiver has any children that are parts"

	self partsDo: [:child | ^ true ].

	^ false.
! !


!WonderlandActorViewer methodsFor: 'initialization' stamp: 'jsp 7/8/1999 21:56'!
initialize
	"Initialize this morph"

	super initialize.

	updatingIsOn _ false.

	self name: 'Actor Info'.
	self extent: 500@350.
	self color: (Color r: 0.815 g: 0.972 b: 0.878).

	dataMorph _ WonderlandActorData new.
	self addMorph: dataMorph.
	dataMorph topLeft: 200@10.
! !

!WonderlandActorViewer methodsFor: 'updating' stamp: 'jsp 7/8/1999 22:49'!
setSelectedActor: anActor
	"Update the actor viewer to reflect the information for this actor"

	selectedActor _ anActor.

	thumbnailCamera setFocusObject: anActor.
	dataMorph setActor: anActor.


! !

!WonderlandActorViewer methodsFor: 'updating' stamp: 'jsp 7/8/1999 22:49'!
turnUpdatingOff
	"Set the actor viewer to stop updating the selected actor's data."

	updatingIsOn _ false.
! !

!WonderlandActorViewer methodsFor: 'updating' stamp: 'jsp 7/8/1999 22:49'!
turnUpdatingOn
	"Set the actor viewer to constantly update the selected actor's data."

	updatingIsOn _ true.

! !

!WonderlandActorViewer methodsFor: 'stepping' stamp: 'jsp 7/8/1999 23:08'!
step

	(updatingIsOn and: [ selectedActor notNil ] )
		ifTrue: [
				dataMorph setActor: selectedActor.
				thumbnailCamera setFocusObject: selectedActor.
				].

! !

!WonderlandActorViewer methodsFor: 'stepping' stamp: 'jsp 7/8/1999 22:52'!
stepTime

	^ 1000.
! !

!WonderlandActorViewer methodsFor: 'stepping' stamp: 'jsp 7/8/1999 22:52'!
wantsSteps

	^ true.
! !


!WonderlandCamera class methodsFor: 'change logging' stamp: 'jsp 7/8/1999 23:12'!
acceptsLoggingOfCompilation
	^ (self == WonderlandCamera).
! !

!WonderlandCamera class methodsFor: 'change logging' stamp: 'jsp 7/8/1999 23:12'!
wantsChangeSetLogging
	^ (self == WonderlandCamera).
! !


!WonderlandEditorTabs methodsFor: 'user-interface' stamp: 'jsp 7/8/1999 22:26'!
selectTab: aTab
	"In addition to setting the tab, if it's the actor viewer let that tab know that it's open"

	super selectTab: aTab.

	(aTab morphToInstall isKindOf: WonderlandActorViewer)
		ifTrue: [ myActorViewer turnUpdatingOn ]
		ifFalse: [ myActorViewer ifNotNil: [ myActorViewer turnUpdatingOff ] ].

! !


!WonderlandStillCamera class methodsFor: 'change logging' stamp: 'jsp 7/8/1999 23:11'!
acceptsLoggingOfCompilation
	^ (self == WonderlandStillCamera).
! !

!WonderlandStillCamera class methodsFor: 'change logging' stamp: 'jsp 7/8/1999 23:15'!
wantsChangeSetLogging
	^ (self == WonderlandStillCamera).
! !


