'From Squeak 2.4b of April 23, 1999 on 15 July 1999 at 11:36:18 am'!
"Change Set:		DrawFixes-ar
Date:			15 July 1999
Author:			Andreas Raab

Fixes FormCanvas to honor shadowDrawing in certain cases."!


!FormCanvas methodsFor: 'drawing-rectangles' stamp: 'ar 7/15/1999 11:33'!
fillRectangle: aRectangle fillStyle: aFillStyle
	"Fill the given rectangle."
	| pattern |
	(aFillStyle isSolidFill or:[shadowDrawing]) 
		ifTrue:[^self fillRectangle: aRectangle color: aFillStyle asColor].
	"We have a very special case for filling with infinite forms"
	(aFillStyle isBitmapFill and:[aFillStyle origin = (0@0)]) ifTrue:[
		pattern _ aFillStyle form.
		(aFillStyle direction = (pattern width @ 0) 
			and:[aFillStyle normal = (0@pattern height)]) ifTrue:[
				"Can use an InfiniteForm"
				^self fillRectangle: aRectangle color: (InfiniteForm with: pattern)].
	].
	"Use a BalloonCanvas instead"
	self asBalloonCanvas fillRectangle: aRectangle fillStyle: aFillStyle.! !

!FormCanvas methodsFor: 'drawing-ovals' stamp: 'ar 7/15/1999 11:34'!
fillOval: aRectangle fillStyle: aFillStyle borderWidth: bw borderColor: bc
	"Fill the given oval."
	(aFillStyle isSolidFill or:[shadowDrawing]) ifTrue:[
		^self fillOval: aRectangle color: aFillStyle asColor borderWidth: bw borderColor: bc].
	"Use a BalloonCanvas instead"
	self asBalloonCanvas fillOval: aRectangle fillStyle: aFillStyle borderWidth: bw borderColor: bc! !

!FormCanvas methodsFor: 'drawing-polygons' stamp: 'ar 7/15/1999 11:32'!
drawPolygon: vertices fillStyle: aFillStyle borderWidth: bw borderColor: bc
	"Use a BalloonCanvas"
	self asBalloonCanvas 
		drawPolygon: vertices 
		fillStyle: (shadowDrawing ifTrue:[shadowStipple] ifFalse:[aFillStyle])
		borderWidth: bw 
		borderColor: bc! !


