'From Squeak 2.3 of January 14, 1999 on 23 June 1999 at 9:18:09 pm'!
"Change Set:            Celeste-TimeZones
Date:                   23 June 1999
Author:                 Lex Spoon

Makes Celeste use timezone information when sorting messages.
"!

!Integer class methodsFor: 'instance creation' stamp: 'ls 6/23/1999 20:37'!
readFrom: aStream base: base 
	"Answer an instance of one of my concrete subclasses. Initial minus sign 
	accepted, and bases > 10 use letters A-Z. Embedded radix specifiers not 
	allowed--use Number readFrom: for that. Answer zero (not an error) if 
	there are no digits."

	| digit value neg startPos |
	neg _ aStream peekFor: $-.
	neg ifFalse: [aStream peekFor: $+].
	value _ 0.
	startPos _ aStream position.
	[aStream atEnd]
		whileFalse: 
			[digit _ aStream next digitValue.
			(digit < 0 or: [digit >= base])
				ifTrue: 
					[aStream skip: -1.
					aStream position = startPos ifTrue: [self error: 'At least one digit expected here'].
					neg ifTrue: [^ value negated].
					^ value]
				ifFalse: [value _ value * base + digit]].
	neg ifTrue: [^ value negated].
	^ value! !


!MailMessage methodsFor: 'parsing' stamp: 'ls 6/23/1999 20:54'!
timeFrom: aString

"Parse the date and time and answer the result as the number of seconds since the start of 1980." 


	| s t rawDelta delta |
	s _ ReadStream on: aString.
	t _ (self readDateFrom: s) asSeconds.  "date part"
	[s atEnd or: [s peek isAlphaNumeric]] whileFalse: [s next].
	(s atEnd) ifFalse:
		["read time part (interpreted as local, regardless of sender's timezone)"
		 t _ t + (Time readFrom: s) asSeconds].
	s skipSeparators.
	('+-' includes: s peek) ifTrue: [
		rawDelta _ Integer readFrom: s.
		delta _ (rawDelta // 100) * 60 + (rawDelta \\ 100).
		t _ t - (delta * 60) ].

	^t - (Date newDay: 1 year: 1980) asSeconds		"time started with 1980..."! !

