'From Squeak 2.4c of May 10, 1999 on 6 August 1999 at 4:19:15 pm'!
"Change Set:		EmbedInWindow
Date:			6 August 1999
Author:			Dan Ingalls

Adds a morph menu command to all morphs that will embed them in a SystemWindow.

Also a tiny fix to SelectorFinder documentation.
"!


!Morph methodsFor: 'menus' stamp: 'di 7/29/1999 11:53'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	"Add morph-specific items to the given menu which was invoked by the given hand."

	aCustomMenu add: 'add drop-shadow' action: #addDropShadow.
	(self isKindOf: SystemWindow)
		ifFalse: [aCustomMenu add: 'put in a window' action: #embedInWindow].
	self isSticky
		ifTrue: [aCustomMenu add: 'stop being sticky' action: #toggleStickiness]
		ifFalse: [aCustomMenu add: 'start being sticky' action: #toggleStickiness].
	aCustomMenu add: 'adhere to edge...' action: #adhereToEdge
! !

!Morph methodsFor: 'e-toy support' stamp: 'di 7/29/1999 12:22'!
embedInWindow

	| window |
	window _ (SystemWindow labelled: self defaultLabelForInspector) model: nil.
	window bounds: ((self position - ((0@window labelHeight) + window borderWidth))
						corner: self bottomRight + window borderWidth).
	window addMorph: self frame: (0@0 extent: 1@1).
	window updatePaneColors.
	World addMorph: window.
	window activate
! !


!SelectorBrowser methodsFor: 'as yet unclassified' stamp: 'di 8/4/1999 09:16'!
byExample
	^ 'Type a fragment of a selector in the top pane.  Accept it.

Or, use an example to find a method in the system.  Type receiver, args, and answer in the top pane with periods between the items.  3. 4. 7

Or, in this pane, use examples to find a method in the system.  Select the line of code and choose "print it".  

	MethodFinder methodFor: #( (4 3) 7  (0 5) 5  (5 5) 10).
This will discover (data1 + data2)

You supply inputs and answers and the system will find the method.  Each inner array is a list of inputs.  It contains the receiver and zero or more arguments.  For Booleans and any computed arguments, use brace notation.

	MethodFinder methodFor: { {1. 3}. true.  {20. 10}. false}.
This will discover the expression (data1 < data2)

	MethodFinder methodFor: { {''29 Apr 1999'' asDate}. ''Thursday''.  
		{''30 Apr 1999'' asDate}. ''Friday'' }.
This will discover the expression (data1 weekday)

Receiver and arguments do not have to be in the right order.
See MethodFinder.verify for more examples.'! !


!SystemWindow methodsFor: 'panes' stamp: 'di 7/29/1999 11:25'!
paneColor
	Display depth > 2 ifTrue:
		[model ifNotNil: [^ Color colorFrom: model defaultBackgroundColor].
		paneMorphs isEmptyOrNil ifFalse: [^ paneMorphs first color]].
	^ Color white! !


