'From Squeak 2.5 of August 6, 1999 [latest update: #1517] on 5 October 1999 at 8:30:20 pm'!
"Change Set:		scriptButton-sw
Date:			5 October 1999
Author:			Scott Wallace

Adds a command to the scriptor menu allowing the user to tear off a button which, when pressed, will run the script."!

SimpleButtonMorph subclass: #ScriptActivationButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Scripting'!

!PasteUpMorph methodsFor: 'flaps' stamp: 'sw 7/29/1999 10:19'!
closedFlapTabs
	^ self submorphs select:
		[:m | (m isKindOf: FlapTab) and: [m flapShowing not]]! !


!Player methodsFor: 'scripts-kernel' stamp: 'sw 10/5/1999 18:25'!
runScript: aSelector
	"Called from script-activation buttons.  Provides a safe way to run a script that may have changed its name"
	(self respondsTo: aSelector) ifTrue:
		[^ self perform: aSelector].
	self inform: 
'Oops, object "', self externalName, '" no longer has
a script named "', aSelector, '".
It must have been deleted or renamed.'! !


!ScriptActivationButton methodsFor: 'as yet unclassified' stamp: 'sw 10/1/1999 21:42'!
bringUpToDate
	self establishLabelWording! !

!ScriptActivationButton methodsFor: 'as yet unclassified' stamp: 'sw 10/5/1999 18:10'!
establishLabelWording
	| itsName |
	self label: ((itsName _ target externalName), ' ', arguments first).
	self setBalloonText: 'click to run the script "', arguments first, '" in player named "', itsName, '"'! !

!ScriptActivationButton methodsFor: 'as yet unclassified' stamp: 'sw 10/1/1999 21:42'!
isTileScriptingElement
	^ true! !


!ScriptEditorMorph methodsFor: 'other' stamp: 'sw 10/5/1999 18:28'!
offerScriptorMenu
	| aMenu result  aList lines title |
	self isAnonymous
		ifTrue:
			[^ self inform: 'ancient structure!!
please modernize!!']
		ifFalse:
			[title _ scriptName asString.
			self isTextuallyCoded
				ifTrue:
					[title _ title, ' (textually coded)'.
					aList _ #(
						('revert to tile version...'		revertScriptVersion)
						('modify textual script'			editScriptTextually)
						('fires per tick...'				chooseFrequency)
				"		('view all scripts'				browseScripts)"
						('destroy this script'				destroyScript)
						('rename this script'				renameScript)
						('explain status alternatives' 	explainStatusAlternatives)
						('button to fire this script'		tearOfButtonToFireScript)).
					lines _ #(2 3 5)]
				ifFalse:
					[aList _ #(
						('save this version'				saveScriptVersion)
						('revert to prior version...'		revertScriptVersion)
						('edit this script textually'		editScriptTextually)
						('fires per tick...'				chooseFrequency)
					"	('view all scripts'				browseScripts)"
						('destroy this script'				destroyScript)
						('rename this script'				renameScript)
						('explain status alternatives' 	explainStatusAlternatives)
						('button to fire this script'		tearOfButtonToFireScript)).
					lines _ #(3 4 6)]].

	aMenu _ SelectionMenu labelList: (aList collect: [:pair | pair first]) lines: lines selections: (aList collect: [:pair | pair second]).
	result _ aMenu startUpWithCaption: title.
	result ifNotNil: [self perform: result]

"		('add parameter to this script'	addParameter)"! !

!ScriptEditorMorph methodsFor: 'other' stamp: 'sw 10/5/1999 18:07'!
tearOfButtonToFireScript
	| aButton |
	aButton _ ScriptActivationButton new target: playerScripted.
	aButton actionSelector: #runScript:.
	aButton arguments: (Array with: scriptName).
	aButton establishLabelWording.
	self currentHand attachMorph: aButton! !


