'From Squeak2.6 of 11 October 1999 [latest update: #1671] on 29 November 1999 at 10:34:09 pm'!
"Change Set:		roundCornerTweaks-di
Date:			26 November 1999
Author:			Dan Ingalls

Several tweaks to make rounded corners work better, especially for DropShadows."!


!CornerRounder methodsFor: 'all' stamp: 'di 11/26/1999 20:46'!
tweakCornersOf: aMorph on: aCanvas borderWidth: w

	| offset corner saveBits c fourColors c14 c23 insetColor mask nonShadowCanvas |
	nonShadowCanvas _ aCanvas isShadowDrawing
			ifTrue: [aCanvas nonShadowCopy]
			ifFalse: [aCanvas].
	w > 0 ifTrue:
		[c _ aMorph borderColor.
		fourColors _ Array new: 4 withAll: c.
		c == #raised ifTrue:
			[c14 _ aMorph color lighter. c23 _ aMorph color darker.
			fourColors _ Array with: c14 with: c23 with: c23 with: c14].
		(c == #inset and: [aMorph owner notNil]) ifTrue:
			[insetColor _ aMorph owner colorForInsets.
			c14 _ insetColor lighter. c23 _ insetColor darker.
			fourColors _ Array with: c14 with: c23 with: c23 with: c14]].
	mask _ Form extent: cornerMasks first extent depth: aCanvas depth.
	(1 to: 4) do:
		[:i | 
		corner _ aMorph bounds corners at: i.
		saveBits _ underBits at: i.
		i = 1 ifTrue: [offset _ 0@0].
		i = 2 ifTrue: [offset _ 0@saveBits height negated].
		i = 3 ifTrue: [offset _ saveBits extent negated].
		i = 4 ifTrue: [offset _ saveBits width negated@0].

		"Mask out corner area (painting saveBits won't clear if transparent)."
		mask copyBits: mask boundingBox from: (cornerMasks at: i) at: 0@0 clippingBox: mask boundingBox rule: Form over fillColor: nil map: (Bitmap with: 0 with: 16rFFFFFFFF).
		nonShadowCanvas image: mask at: corner + offset sourceRect: mask boundingBox rule: Form and.

		"Paint back corner bits."
		nonShadowCanvas image: saveBits at: corner + offset.

		w > 0 ifTrue:
			["Paint over with border if any"
			aCanvas stencil: (cornerOverlays at: i) at: corner + offset
					color: (fourColors at: i)]].

! !


!FormCanvas methodsFor: 'drawing-support' stamp: 'di 11/26/1999 20:23'!
defeatShadowDrawing

	shadowDrawing _ false! !

!FormCanvas methodsFor: 'drawing-support' stamp: 'di 11/26/1999 20:24'!
nonShadowCopy

	^ self copy defeatShadowDrawing! !


