'From Squeak2.6 of 11 October 1999 [latest update: #1684] on 6 December 1999 at 8:52:18 am'!
"Change Set:		ScrollBarPrefs-STP
Date:			6 December 1999
Author:			Stephen T. Pope (tweaked by DI)

Provides preference control over whether or not to include menu buttons at the top of scroll bars.  For those who don't use control keys, use of option-click in the pane can still be used to bring up the pane menu when there is no menu button.

Provides preference control over whether to use narrow scrollbars.

Provides preference control over left/right placement of scrollbars independent of inboard/outboard selection.
"!


!ScrollBar methodsFor: 'initialize' stamp: 'di 12/6/1999 08:41'!
initializeMenuButton
	"Preferences disable: #scrollBarsWithoutMenuButton"
	"Preferences enable: #scrollBarsWithoutMenuButton"

	(Preferences valueOfFlag: #scrollBarsWithoutMenuButton) ifTrue: [^self].
	menuButton := RectangleMorph
			newBounds: (self innerBounds topLeft extent: self buttonExtent)
			color: Color lightGray.
	menuButton on: #mouseEnter send: #menuButtonMouseEnter: to: self.
	menuButton on: #mouseDown send: #menuButtonMouseDown: to: self.
	menuButton on: #mouseLeave send: #menuButtonMouseLeave: to: self.
	menuButton addMorphCentered:
		(RectangleMorph newBounds: (0@0 extent: 4@2) color: Color black).
	menuButton setBorderWidth: 1 borderColor: #raised.
	self addMorph: menuButton! !

!ScrollBar methodsFor: 'initialize' stamp: 'stp 12/1/1999 12:19'!
initializeUpButton
	upButton := RectangleMorph
		newBounds: ((menuButton ifNil: [self innerBounds topLeft]
				ifNotNil: [bounds isWide ifTrue: [menuButton bounds topRight]
									ifFalse: [menuButton bounds bottomLeft]])
					extent: self buttonExtent)
		color: Color lightGray.
	upButton on: #mouseDown send: #scrollUpInit to: self.
	upButton on: #mouseStillDown send: #scrollUp to: self.
	upButton on: #mouseUp send: #borderRaised to: upButton.
	upButton addMorphCentered: (ImageMorph new image: 
		(bounds isWide ifTrue: [UpArrow rotateBy: #left centerAt: 0@0] ifFalse: [UpArrow])).
	upButton setBorderWidth: 1 borderColor: #raised.
	self addMorph: upButton! !


!ScrollPane methodsFor: 'initialization' stamp: 'di 12/6/1999 08:47'!
initialize
	"Preferences enable: #inboardScrollbars"
	"Preferences enable: #scrollBarsOnRight"

	super initialize.
	borderWidth := 2.
	borderColor := Color black.
	retractableScrollBar := (Preferences valueOfFlag: #inboardScrollbars) not.
	scrollBarOnLeft := (Preferences valueOfFlag: #scrollBarsOnRight) not.

	scrollBar := ScrollBar new model: self slotName: 'scrollBar'.
	scrollBar borderWidth: 1; borderColor: Color black.
	retractableScrollBar ifFalse: [self addMorph: scrollBar].

	scroller := TransformMorph new color: Color transparent.
	scroller offset: -3@0.
	self addMorph: scroller.

	self on: #mouseEnter send: #mouseEnter: to: self.
	self on: #mouseLeave send: #mouseLeave: to: self.
	self extent: 150@120! !

!ScrollPane methodsFor: 'geometry' stamp: 'di 12/6/1999 08:35'!
scrollbarWidth  "Includes border"
	(Preferences valueOfFlag: #scrollBarsNarrow)
		ifTrue: [^ 12]
		ifFalse: [^ 16]! !


"Postscript:
Install preference for visibility, but disabled."
Preferences disable: #scrollBarsWithoutMenuButton.
Preferences disable: #scrollBarsNarrow.
Preferences disable: #scrollBarsOnRight.
!

