'From Squeak2.6 of 11 October 1999 [latest update: #1726] on 20 December 1999 at 1:37:31 pm'!
"Change Set:		sketchThumbnail-sw
Date:				20 December 1999
Author:			Scott Wallace

Removes long-standing special-case code in ThumbnailMorph.drawOn: (which is of unknown provenance and which seemed to do more harm than good) so that thumbnails of SketchMorphs now are better-behaved."!


!ThumbnailMorph methodsFor: 'as yet unclassified' stamp: 'sw 12/20/1999 13:35'!
drawOn: aCanvas
	"Draw a small view of a morph in another place. Guard against infinite recursion if that morph has a thumbnail of itself inside."

	| actualViewee viewedMorphBox myBox scale c shrunkForm |
	super drawOn: aCanvas.
	actualViewee _ self actualViewee.
	(actualViewee~~ nil and: [actualViewee isInWorld])
		ifTrue:
			[(RecursionDepth _ RecursionDepth + 1) > RecursionMax ifTrue: [^ self].
			viewedMorphBox _ actualViewee fullBounds.

			myBox _ self innerBounds.
			scale _ myBox width / (viewedMorphBox width max: viewedMorphBox
		height).
			c _ FormCanvas extent: viewedMorphBox extent depth: aCanvas depth.
			c translateBy: viewedMorphBox topLeft negated 
				"recursion happens here"
				during:[:tempCanvas| actualViewee fullDrawOn: tempCanvas].
			shrunkForm _ c form magnify: c form boundingBox by: scale smoothing: 1.
			lastFormShown _ shrunkForm.
			RecursionDepth _ RecursionDepth - 1]
		ifFalse:
			[lastFormShown ifNotNil: [shrunkForm _ lastFormShown]].


	shrunkForm ifNotNil:
		[aCanvas image: shrunkForm at: self center - shrunkForm boundingBox
center]

	"sw 12/20/1999 13:35 special-case code for SketchMorph commented out, since it seems to have done more harm than good:
 			((actualViewee isKindOf: SketchMorph) and: [false])
				ifTrue:
					[diag _ actualViewee form extent  asInteger.
					viewedMorphBox _
						(actualViewee bounds center - (diag // 2)) extent: diag@diag]
				ifFalse:
					[viewedMorphBox _ actualViewee fullBounds]."

! !


