'From Squeak2.7 of 5 January 2000 [latest update: #1788] on 18 January 2000 at 2:36:10 pm'!
"Change Set:		noPersonalize-sw
Date:			18 January 2000
Author:			Scott Wallace

Adds a new Preference, called 'personalizedWorldMenu', which governs which menu should be put up when the user yellow-button-clicks on the morphic desktop.  If the preference is true, the personalized menu will be used (as before), if false then the standard red-button (world) menu is used instead."!


!HandMorph methodsFor: 'world menu commands' stamp: 'sw 1/18/2000 14:29'!
yellowButtonClickOnDesktopWithEvent: evt
	"Put up either the personalized menu or the world menu when the user clicks on the morphic desktop with the yellow button.  The preference 'personalizedWorldMenu' governs which one is used"

	| aMenu |
		Preferences personalizedWorldMenu
			ifFalse:
				[aMenu _ self buildWorldMenu.
				aMenu addTitle: 'World']
			ifTrue:
				[aMenu _ MenuMorph new defaultTarget: self world.
				Preferences personalizeUserMenu: aMenu.
				aMenu addLine.
				aMenu add: 'personalize...' target: Preferences action: #letUserPersonalizeMenu].
	self invokeMenu: aMenu event: evt

! !


"Postscript:"
Preferences enable: #personalizedWorldMenu.
Preferences setHelpFor: #personalizedWorldMenu toString:
'If true, then a right-click (Mac option-click) on the morphic desktop will bring up the customizable "personalized" menu; if false, then it will bring up the standard world menu'.
!

