'From Squeak2.7 of 5 January 2000 [latest update: #1791] on 19 January 2000 at 4:23:55 pm'!
"Change Set:		prefRework-sw
Date:			20 January 2000
Author:			Scott Wallace

Another turn of the crank regarding Preferences.

*	A new preferences panel, in which preferences are factored into categories, is offered.  Checkboxes are used to represent the state, rather than textual 'true' & 'false'

*  Several preferences that were hard to locate alphabetically because their names started with common verbs such as 'show' and 'allow' and 'use', etc., are renamed, as are some of those with unusually oblique or awkward names, such as 'disableSounds' and 'allowLabelDragging'

*	Category information for preferences is contained in the methods in category 'initial values' of class Preferences; each preference can belong to multiple categories.

*	If a new preference is introduced to the system casually by a #enable: or #disable: call, without accompanying additions or changes to the 'initial values' category of Preferences class, it will show up in the new preferences panel in a tab labeled 'uncategorized'"!

PasteUpMorph subclass: #IndexTabs
	instanceVariableNames: 'highlightColor regularColor basicHeight basicWidth verticalPadding fixedWidth '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Palettes'!
Object subclass: #Preferences
	instanceVariableNames: ''
	classVariableNames: 'CategoryInfo DesktopColor FlagDictionary HelpDictionary Parameters SyntaxColorsAndStyles '
	poolDictionaries: ''
	category: 'System-Support'!

!HaloMorph methodsFor: 'handles' stamp: 'sw 1/12/2000 18:24'!
addDebugHandleInBox: aBox
	Preferences debugHaloHandle ifTrue:
		[self addHandleInBox: aBox horizontalPlacement: #right verticalPlacement: #topCenter
			color: Color blue veryMuchLighter
			icon: 'Halo-Debug'
			on: #mouseDown send: #doDebug:with: to: self]
! !


!HandMorph methodsFor: 'grabbing/dropping' stamp: 'sw 1/12/2000 22:17'!
dropTargetFor: aMorph event: evt
	"Return the morph that the given morph is to be dropped onto.  Return nil if we must repel the morph.  Return the world, if no other morph wants the dropping morph."

	| root coreSample |
	root _ nil.
	owner submorphsReverseDo: [:m |
		((m fullContainsPoint: evt cursorPoint) and:
		 [(m isKindOf: HaloMorph) not]) ifTrue: [root _ m]].
	root == nil ifTrue: [^ self world].
	coreSample _ root morphsAt: evt cursorPoint.
	(Preferences systemWindowEmbedOK not and:
		[(aMorph isKindOf: SystemWindow)]) ifTrue: [^ self world].
	coreSample do:
		[:m |
			(m repelsMorph: aMorph event: evt) ifTrue:
				[^ nil]].

	coreSample do:
		[:m |
			(m wantsDroppedMorph: aMorph event: evt) ifTrue: [^ m]].
	^ self world
! !

!HandMorph methodsFor: 'world menu' stamp: 'sw 1/12/2000 18:09'!
openMenu

"temporary support of WorldWindow (easy open)"


	"Build the open window menu for the world."
	| menu |
	menu _ (MenuMorph entitled: 'open...') defaultTarget: self.
	menu addStayUpItem.
	menu add: 'browser' action: #openBrowser.
	menu add: 'package browser' action: #openPackageBrowser.
	menu add: 'method finder' action: #openSelectorBrowser.
	menu add: 'workspace' action: #openWorkspace.
	menu add: 'file list' action: #openFileList.
	menu add: 'file...' action: #openFileDirectly.
	menu add: 'transcript' action: #openTranscript.
	menu add: 'inner world' action: #openWorldInWindow.
	menu addLine.
	menu add: 'simple change sorter' selector: #openChangeSorter: argument: 1.
	menu add: 'dual change sorter' selector: #openChangeSorter: argument: 2.
	menu addLine.
	menu add: 'email reader' action: #openEmail.
	menu add: 'web browser' action: #openWebBrowser.
	menu add: 'IRC chat' action: #openIRC.
	menu addLine.
	(Preferences allowMVCprojects and: [Smalltalk includesKey: #StandardSystemView])
		ifTrue: [menu add: 'mvc project' action: #openMVCProject].
	menu add: 'morphic project' action: #openMorphicProject.
	menu add: 'construction project' action: #openConstructionProject.
	^ menu
! !


!MethodFinder methodsFor: 'search' stamp: 'sw 1/19/2000 13:54'!
search: multi
	"if Multi is true, collect all selectors that work."
	| old |
	selector _ OrderedCollection new.	"list of them"
	old _ Preferences autoAccessors.
	Preferences disableGently: #autoAccessors.
	self simpleSearch.
	multi not & (selector isEmpty not) ifTrue:
		[old ifTrue: [Preferences enableGently: #autoAccessors].
		^ selector].

	[self permuteArgs] whileTrue:
		[self simpleSearch.
		multi not & (selector isEmpty not) ifTrue:
			[old ifTrue: [Preferences enableGently: #autoAccessors].
			^ selector]].

	old ifTrue: [Preferences enableGently: #autoAccessors].
	^ #()! !


!PasteUpMorph methodsFor: 'dropping/grabbing' stamp: 'sw 1/12/2000 22:17'!
repelsMorph: aMorph event: ev
	(Preferences systemWindowEmbedOK not and:
		[aMorph isKindOf: SystemWindow]) ifTrue: [^ false].
	(aMorph isKindOf: Viewer) ifTrue: [^ false].
	openToDragNDrop ifFalse: [^ true].
	(self wantsDroppedMorph: aMorph event: ev) ifFalse: [^ true].
	^ super repelsMorph: aMorph event: ev "consults #repelling flag"! !

!PasteUpMorph methodsFor: 'dropping/grabbing' stamp: 'sw 1/12/2000 22:17'!
wantsDroppedMorph: aMorph event: evt
	self visible ifFalse: [^ false].  "will be a call to #hidden again very soon"
	self openToDragNDrop ifFalse: [^ false].
	(self bounds containsPoint: (self pointFromWorld: evt cursorPoint)) ifFalse: [^ false].
	((aMorph isKindOf: SystemWindow) and: [Preferences systemWindowEmbedOK not])
		ifTrue:	[^ false].
	((aMorph isKindOf: BookPageSorterMorph) and: [self isWorldMorph not])
		ifTrue:	[^ false].

	(aMorph isKindOf: Viewer) ifTrue: [^ self isWorldMorph].
	^ true! !


!IndexTabs methodsFor: 'tabs' stamp: 'sw 1/11/2000 11:15'!
addTabFor: aReferent font: aFont
	|  aTab |
	aTab _ ReferenceMorph forMorph: aReferent font: aFont.
	self addMorphBack: aTab.
	aTab highlightColor: self highlightColor; regularColor: self regularColor.
	aTab unHighlight.
	self laySubpartsOutInOneRow; layoutChanged.
	^ aTab! !

!IndexTabs methodsFor: 'tabs' stamp: 'sw 1/13/2000 15:19'!
ownerChanged
	fixedWidth ifNil: [self laySubpartsOutInOneRow]! !

!IndexTabs methodsFor: 'tabs' stamp: 'sw 1/11/2000 10:17'!
tabMorphs
	"Presently all the submorphs are ReferenceMorphs, but this still supports an earlier design where spacers are interleaved, and where the old TabMorph class was used"

	^ submorphs select: [:m | (m isKindOf: TabMorph) or: [m isKindOf: ReferenceMorph]]! !

!IndexTabs methodsFor: 'layout' stamp: 'sw 1/13/2000 15:18'!
fixedWidth: aWidth
	fixedWidth _ aWidth! !

!IndexTabs methodsFor: 'layout' stamp: 'sw 1/19/2000 13:57'!
laySubpartsOutInOneRow
	| aPosition neededHeight widthToUse mid |
	fixedWidth ifNotNil: [self error: 'incompatibility in IndexTabs'].
	verticalPadding ifNil: [verticalPadding _ 4].  "for benefit of old structures"
	aPosition _ self topLeft.
	neededHeight _ self basicHeight.
	submorphs do:
		[:aMorph |
			aMorph position: (aPosition + (padding @ 0)).
			aPosition _ aMorph topRight.
			neededHeight _ neededHeight max: aMorph height].
	neededHeight _ neededHeight + (verticalPadding * 2).
	mid _ self top + (neededHeight // 2).
	submorphs do:
		[:aMorph |
			aMorph top: (mid - (aMorph height // 2))].
	widthToUse _ self widthImposedByOwner max: self requiredWidth.
	self extent: (((aPosition x + padding - self left) max: widthToUse) @ neededHeight)! !

!IndexTabs methodsFor: 'layout' stamp: 'sw 1/13/2000 15:50'!
rowsNoWiderThan: maxWidth
	| aPosition neededHeight |
	self fixedWidth: maxWidth.
	verticalPadding ifNil: [verticalPadding _ 4].  "for benefit of old structures"
	aPosition _ self topLeft.
	neededHeight _ self basicHeight.
	submorphs do:
		[:aMorph |
			aMorph position: (aPosition + (padding @ 0)).
			(aMorph right > (self left + maxWidth)) ifTrue:
				[aPosition _ self left @ (aPosition y + neededHeight).
				aMorph position: aPosition + (padding @ 0).
				neededHeight _ self basicHeight].
			aPosition _ aMorph topRight.
			neededHeight _ neededHeight max: aMorph height].
	self extent: (maxWidth @ ((aPosition y + neededHeight) - self top))! !

!IndexTabs methodsFor: 'object fileIn' stamp: 'sw 1/13/2000 15:27'!
convertbosfcebbfgccpmcpbttloiairfidcuwwhrbbv0: varDict bosfcebbfgccpmcpbttloiairfidcuwwhrbbvf0: smartRefStrm
	"These variables are automatically stored into the new instance ('highlightColor' 'regularColor' 'basicHeight' 'basicWidth' 'verticalPadding' ).
	This method is for additional changes. Use statements like (foo _ varDict at: 'foo')."

	"New variables: ('fixedWidth' )  If a non-nil value is needed, please assign it."
! !


!Preferences class methodsFor: 'initialization' stamp: 'sw 1/12/2000 22:34'!
allPreferenceInitializationSpecs
	"Preferences allPreferenceInitializationSpecs"
	| aList additions |
	aList _ OrderedCollection new.
	(self class organization listAtCategoryNamed: 'initial values' asSymbol) do:
		[:aSelector | aSelector numArgs = 0 ifTrue:
			[additions _ self perform: aSelector.
			(additions isKindOf: Collection) ifFalse: [self error: 'method in "initial values" categories must return collections'].
			aList addAll: additions]].
	^ aList
			! !

!Preferences class methodsFor: 'initialization' stamp: 'sw 1/13/2000 14:03'!
callHelpMessageInitializers
	| listOfPairs |
	"Preferences callHelpMessageInitializers"
	(self class organization listAtCategoryNamed: #help) do:
		[:aSelector | aSelector numArgs = 0 ifTrue:
			[((listOfPairs _ self perform: aSelector) isKindOf: Collection)
				ifTrue:
					[listOfPairs do:
						[:pair | HelpDictionary at: pair first put: 
					(pair first, ':
		', pair last)]]]]! !

!Preferences class methodsFor: 'initialization' stamp: 'sw 1/13/2000 14:17'!
chooseInitialSettings
	"Restore the default choices for Preferences."
	"Preferences chooseInitialSettings"

	self allPreferenceInitializationSpecs do:
		[:aSpec |
			aSpec second == #true
				ifTrue:
					[self enable: aSpec first]
				ifFalse:
					[self disable: aSpec first]].
	self resetCategoryInfo

! !

!Preferences class methodsFor: 'initialization' stamp: 'sw 1/13/2000 14:16'!
initializeAddedPreferences
	"Initialize any preference not yet known to the prefs dictionary as per descriptions in the 'initial values' category, but don't change the setting of any existing preference.
	Also, compile accessor methods for retrieving any preference that lacks one"

	"Preferences initializeAddedPreferences"

	| sym |
	self allPreferenceInitializationSpecs do:
		[:triplet |
			(self class selectors includes: (sym _ triplet first))
				ifFalse:
					[self compileAccessMethodFor: sym].
			(FlagDictionary includesKey: sym) ifFalse:
				[triplet second == #true
					ifTrue:
						[self enable: sym]
					ifFalse:
						[self disable: sym]]].
	self resetCategoryInfo

! !

!Preferences class methodsFor: 'initialization' stamp: 'sw 1/13/2000 13:49'!
initializeHelpMessages
	"Preferences initializeHelpMessages"
  	HelpDictionary _ Dictionary new.
	self callHelpMessageInitializers! !

!Preferences class methodsFor: 'preferences dictionary' stamp: 'sw 1/19/2000 14:11'!
deletePreference: preferenceNameSymbol

	FlagDictionary removeKey: preferenceNameSymbol ifAbsent: [^ self].
	self resetCategoryInfo
! !

!Preferences class methodsFor: 'preferences dictionary' stamp: 'sw 1/19/2000 13:52'!
disable: preferenceNameSymbol
	"Shorthand access"
	self setPreference: preferenceNameSymbol toValue: false.
	self resetCategoryInfo "in case this call introduced a new pref"! !

!Preferences class methodsFor: 'preferences dictionary' stamp: 'sw 1/19/2000 13:51'!
disableGently: preferenceNameSymbol
	"Unlike #disable:, this on does not reset the CategoryInfo cache"
	self setPreference: preferenceNameSymbol toValue: false! !

!Preferences class methodsFor: 'preferences dictionary' stamp: 'sw 1/19/2000 13:53'!
enable: preferenceNameSymbol
	"Shorthand access"
	self setPreference: preferenceNameSymbol toValue: true.
	self resetCategoryInfo  "in case this call introduced a new pref"! !

!Preferences class methodsFor: 'preferences dictionary' stamp: 'sw 1/19/2000 13:53'!
enableGently: preferenceNameSymbol
	"Unlike #enable:, this one does not reset the CategoryInfo cache"
	self setPreference: preferenceNameSymbol toValue: true! !

!Preferences class methodsFor: 'preferences dictionary' stamp: 'sw 1/12/2000 22:54'!
noteThatFlag: prefSymbol justChangedTo: aBoolean
	"Provides a hook so that a user's toggling of a preference might precipitate some immediate action"
	| keep |
	prefSymbol == #useGlobalFlaps ifTrue:
		[aBoolean
			ifFalse:		"Turning off use of flaps"
				[keep _ self confirm:
'Do you want to preserve the existing
global flaps for future use?'.
				Utilities globalFlapTabsIfAny do:
					[:aFlapTab | Utilities removeFlapTab: aFlapTab keepInList: keep.
					aFlapTab isInWorld ifTrue: [self error: 'Flap problem']].
				keep ifFalse: [Utilities clobberFlapTabList]]

			ifTrue:		"Turning on use of flaps"
				[Smalltalk isMorphic ifTrue:
					[self currentWorld addGlobalFlaps]]].

	prefSymbol == #roundedWindowCorners ifTrue:
		[World ifNotNil: [World fullRepaintNeeded]].

	prefSymbol == #optionalButtons ifTrue:
		[Utilities replacePartSatisfying: [:el |  (el isKindOf: MorphThumbnail) and: [(el morphRepresented isKindOf: SystemWindow) and: [el morphRepresented model isKindOf: FileList]]]
inGlobalFlapSatisfying: [:f1 | f1 wording = 'Tools'] with:  FileList openAsMorph applyModelExtent].

	(prefSymbol == #optionalButtons  or: [prefSymbol == #annotationPanes]) ifTrue:
		[Utilities replaceBrowserInToolsFlap].

	(prefSymbol == #smartUpdating) ifTrue:
		[SystemWindow allSubInstancesDo:
			[:aWindow | aWindow amendSteppingStatus]]! !

!Preferences class methodsFor: 'preferences dictionary' stamp: 'sw 1/13/2000 12:28'!
orphanedHelpEntries
	"Answer a list of all the keys in the help dictionary that are not represented by actual preferences"

	^ HelpDictionary keys asSortedArray copyWithoutAll: self allPreferenceFlagKeys

"Preferences orphanedHelpEntries"! !

!Preferences class methodsFor: 'preferences dictionary' stamp: 'sw 1/13/2000 11:12'!
preferencesLackingHelp
	^ self allPreferenceFlagKeys select:
		[:aKey | (self helpMessageOrNilForPreference: aKey) == nil]

"Preferences preferencesLackingHelp"! !

!Preferences class methodsFor: 'preferences dictionary' stamp: 'sw 1/13/2000 11:49'!
preferencesLackingInitializers
	^ self allPreferenceFlagKeys copyWithoutAll: (self allPreferenceInitializationSpecs collect: [:info | info first])

"Preferences preferencesLackingInitializers"! !

!Preferences class methodsFor: 'preferences dictionary' stamp: 'sw 1/12/2000 18:33'!
rawSetPreference: prefSymbol toValue: aBoolean
	"Set the given preference to the given value, without further ado"
	FlagDictionary at: prefSymbol put: aBoolean
! !

!Preferences class methodsFor: 'preferences panel' stamp: 'sw 1/13/2000 11:07'!
helpMessageForPreference: aSymbol
	^ (self helpMessageOrNilForPreference: aSymbol) ifNil:
		['No help available for ', aSymbol]! !

!Preferences class methodsFor: 'preferences panel' stamp: 'sw 1/13/2000 11:07'!
helpMessageOrNilForPreference: aSymbol
	"If the HelpDictionary has a help message prepared for aSymbol, return it, else return nil"
	HelpDictionary ifNil: [self initializeHelpMessages].
	^ HelpDictionary at: aSymbol ifAbsent: [nil]! !

!Preferences class methodsFor: 'preferences panel' stamp: 'sw 1/19/2000 15:15'!
openPreferencesControlPanel
	"Preferences openPreferencesControlPanel"
	| aPanel aWindow aRow wrapper but aList odd aColor w width1 width2 spacer |
	Smalltalk verifyMorphicAvailability ifFalse: [^ self beep].
	true ifTrue: [^ self openFactoredPanel].

	"What follows below is the former (pre-2.8alpha) implementation of the prefs panel"

	aPanel _ AlignmentMorph newColumn.
	aPanel beSticky.
	aList _ OrderedCollection new.
	FlagDictionary associationsDo: [:assoc | aList add: (Array
				with: assoc key
				with: assoc value
				with: (self helpMessageForPreference: assoc key))].
	odd _ false.
	width1 _ 172.
	spacer _ 4.
	width2 _ 14.
	(aList asSortedCollection: [:a :b | a first < b first])
		do: 
			[:triplet | 
			aPanel addMorphBack: (aRow _ AlignmentMorph newRow).
			aRow color: (aColor _ odd
							ifTrue: [Color green muchLighter]
							ifFalse: [Color red veryMuchLighter]).
			odd _ odd not.
			aRow addMorph: (wrapper _ Morph new color: aColor).
			wrapper setBalloonText: triplet third.
			wrapper extent: width1 @ 15.
			wrapper addMorph: (StringMorph new contents: triplet first).
			aRow addMorphBack: (Morph new color: aColor; extent: (spacer @ 15)).
			aRow addMorphBack: (wrapper _ Morph new color: aColor).
			wrapper extent: width2 @ 15.
			wrapper addMorphBack: (but _ UpdatingBooleanStringMorph new contents: triplet second printString).
			but getSelector: triplet first;
			putSelector: #setPreference:toValue:;
			stepTime: 1800;
			 target: self].
		wrapper _ ScrollPane new.
		wrapper scroller addMorph: aPanel.
	Smalltalk isMorphic
		ifTrue:
			[aWindow _ SystemWindow new model: self.
			aWindow addMorph: wrapper frame: (0 @ 0 extent: 1 @ 1).
			aWindow setLabel: 'Preferences'.
			aWindow openInWorld] 
		ifFalse:
			[(w _ MVCWiWPasteUpMorph newWorldForProject: nil)
						addMorph: wrapper.
			wrapper
				retractable: false;
				extent: self initialExtent + (wrapper scrollbarWidth @ 0).
			w startSteppingSubmorphsOf: wrapper.
			MorphWorldView openOn: w
				label: 'Preferences'
				extent: w fullBounds extent]
! !

!Preferences class methodsFor: 'pref buttons' stamp: 'sw 1/14/2000 19:39'!
buttonRepresenting: prefSymbol wording: aString color: aColor
	"self currentHand attachMorph: (Preferences buttonRepresenting: #balloonHelpEnabled wording: 'Balloon Help' color: nil)"
	"Return a button that controls the setting of prefSymbol.  It will keep up to date even if the preference value is changed in a different place"
	| outerButton aButton str aHelp miniWrapper |
	(FlagDictionary includesKey: prefSymbol) ifFalse: [self error: 'Unknown preference: ', prefSymbol printString].
	outerButton _ AlignmentMorph newRow height: 24.
	outerButton color:  (aColor ifNil: [Color r: 0.645 g: 1.0 b: 1.0]).
	outerButton hResizing: #spaceFill; vResizing: #shrinkWrap.
	outerButton addMorph: (aButton _ UpdatingThreePhaseButtonMorph checkBox).
	aButton
		target: self;
		actionSelector: #togglePreference:;
		arguments: (Array with: prefSymbol);
		target: Preferences;
		getSelector: prefSymbol.

	outerButton addTransparentSpacerOfSize: (2 @ 0).
	str _ StringMorph contents: aString font: (StrikeFont familyName: 'NewYork' size: 12).
	miniWrapper _ AlignmentMorph newRow hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	miniWrapper beTransparent addMorphBack: str lock.
	outerButton addMorphBack: miniWrapper.
	aButton setBalloonText: (aHelp _ Preferences helpMessageForPreference: prefSymbol).
	miniWrapper setBalloonText: aHelp.

	^ outerButton! !

!Preferences class methodsFor: 'misc' stamp: 'sw 1/12/2000 22:41'!
soundEnablingString
	^ self soundsEnabled
		ifFalse:
			['turn sound on']
		ifTrue:
			['turn sound off']! !

!Preferences class methodsFor: 'misc' stamp: 'sw 1/12/2000 22:42'!
toggleSoundEnabling
	self togglePreference: #sounsdEnabled! !

!Preferences class methodsFor: 'help' stamp: 'sw 1/14/2000 16:06'!
helpMsgsAThroughF
	"This, and the other methodds in this category, are automatically called whenever you call

   	Preferences initializeHelpMessages
		or
	Preferences callHelpMessageInitializers
"

	^ #( 
(autoAccessors
	'If true, an attempt to call a message which is not understood by an object but whose selector is the same as an inst var of the object will result in automatic compilation of an accessor method for that object''s class')

(automaticViewerPlacement
	'If true, new viewers are automatically positioned near the objects they view; if false, new viewers are attached to the hand, from whence you much choose a destination for them')

(annotationPanes
	'If true, a thin horizontal annotation pane is used in browsers.')

(balloonHelpEnabled
	'Whether balloon help should be offered when the cursor lingers over certain objects.')

(browserShowsPackagePane
	'If true, then the various ''browse full'' and ''browse it'' commands (usually invoked via cmd-b) will open a Package Browser rather than a System Browser.  The Package Browser includes a package pane which groups system categories into packages based on the initial portion of their category name.')

(browseWithPrettyPrint
	'If true, browsers will automatically format their contents')

(cautionBeforeClosing 
	'If true, Morphic windows seen in an mvc project will put up a warning before allowing themselves to be dismissed')

(caseSensitiveFinds
	'If true, then the "find" command in text will always make its searches in a case-sensitive fashion')

(changeSetVersionNumbers
	'If true, version-number extensions will be used when constructing names for change-set fileouts.  If false, timestamp extensions are used.')

(checkForSlips 
	'If true, then whenever you file out a change set, it is checked for ''slips'' and if any are found, you are so informed and given a chance to open a browser on them')

(clickOnLabelToEdit
	'If true, a click on the label of a system window lets you edit it; if false, allow dragging of system windows when clicking on the label')

(cmdDotEnabled
	'If true, cmd-dot brings up a debugger;
if false, the cmd-dot interrupt is disabled')

(colorWhenPrettyPrinting
	'If true, then when browseWithPrettyPrint is in effect, the pretty-printing will be presented in color')

(compressFlashImages
	'If true, flash images will automatically be reduced to 8-bit color depth upon being read')

(confirmFirstUseOfStyle
'If true, the first attempt to submit a method with non-standard style will bring up a confirmation dialog')

(conversionMethodsAtFileOut
	'Governs whether at fileout time you should be prompted to define conversion methods where deemed appropriate.')

(debugHaloHandle 
'If true, a special debugging halo handle is displayed at the right of the halo; if false, no such handle is shown.')

(diffsInChangeList
	'If true, changeList browsers and Versions browsers will open up by default showing diffs, i.e. revealing the differences between successive versions or between the in-memory code and the code on disk')

(editPlayerScriptsInPlace 
	'If true, textual player scripts are edited in place in Scriptors (still imperfectly implemented)')

(eToyScheme
	'If true, new scripting spaces place the Playfield to the left and the the palette to the right of the window; if false, the opposite is true.')

(extractFlashInHighQuality
	'Whether flash graphics should be extracted in high quality.')
(extractFlashInHighestQuality
	'Whether flash graphics should be extracted in highest possible quality.')

(fastDragWindowForMorphic
	'If true, morphic window drag will be done by dragging an outline of the window.')

(fenceEnabled
	'Whether an object obeying motion scripts should stop moving when it reaches the edge of its container.')

) 
! !

!Preferences class methodsFor: 'help' stamp: 'sw 1/19/2000 13:45'!
helpMsgsGThroughP
		^ #(

(iconicHalos
	'Whether, when simpleHalos is not in effect, the circular morphic halo handles should show icons within them as keys to their functions.')

(ignoreStyleIfOnlyBold
	'If true, then any method submission in which the only style change is for bolding will be treated as a method with no style specifications')

(inboardScrollbars
	'If true, then ScrollPane will place scrollbars inside on the right and will not hide them on exit')

(logDebuggerStackToFile
	'If true, whenever you fall into a debugger a summary of its stack will be written to a file named
''SqueakDebug.log''')

(menuColorFromWorld
	'Governs whether the colors used in morphic menus should be derived from the color of the world background.')

(mouseOverHalosEnabled
	'If false, halos will not be put up on mouseovers even if they otherwise might be.')

(mvcProjectsAllowed
	'If true, the open... menu will offer you the chance to open an mvc project.')

(noviceMode 
	'If true, certain novice-mode accommodations are made.')

(oneViewerFlapAtATime
	'If true, opening up one viewer flap will close all other such flaps.')

(optionalButtons
	'If true, then optional buttons will be used in certain standard tools, including browsers, message lists, fileLists, changeLists, and debuggers')

(personalizedWorldMenu
	'If true, then a right-click (Mac option-click) on the morphic desktop will bring up the customizable "personalized" menu; if false, then it will bring up the standard world menu.')

(preserveTrash
	'Whether morphs dismissed via halo or dragged into the Trash should be preserved in the TrashCan for possible future retrieval.  If false, they are not preserved.')

(printAlternateSyntax
	'If true, then
prettyPrint using experimental syntax.
Otherwise use normal ST-80 syntax.')

(projectsSentToDisk
	'If true, entering a new project swaps it in and swaps out other projects as appropriate. Projects are swapped in and out as ImageSegments, stored as files on disk in an image segment folder associated with the current image.')

(projectZoom
	'If true, then show a zoom effect when entering or leaving projects.  This can be costly of memory (at least an extra screen buffer) so dont use it in low space situations.  But it is cool.')

(promptForUpdateServer
	'If false, the prompt for server choice when updating code from the server is suppressed.  Set this to false to leave the server choice unchanged from update to update.')

			) 
! !

!Preferences class methodsFor: 'help' stamp: 'sw 1/13/2000 13:53'!
helpMsgsQThroughZ

	^ #(	
(reverseWindowStagger
	'If true, a reverse-stagger strategy  is used for determining where newly launched windows will be placed; if false, a direct- stagger strategy is used.')

(roundedMenuCorners
	'Whether morphic menus should have rounded corners')

(roundedWindowCorners
	'Governs whether morphic system windows should have rounded corners')

(scrollBarsNarrow
		'If true, morphic scrollbars will be narrow.')
(scrollBarsOnRight
		'If true, morphic scrollbars in subsequently opened windows will appear on the right side of their pane.')
(scrollBarsWithoutMenuButton
		'If true, morphic scrollbars in subsequently opened windows will not include a menu button.')

(showPlayerSource
	'If true, then all Player methods with fewer than 2 arguments are included in Viewers, whether or not they are intended for end-user use.  This can be dangerous')

(showScriptSource
	'If true, then the actual Smalltalk source code for methods is shown in the detail panes for scripts in a viewer; if false, then a help message for scripts is shown instead.')

(simpleHalos
	'Whether extremely simple halos should be offered in Morphic (intended primarily for young children only')

(smartUpdating
	'If true, then morphic tools such as browsers and inspectors will keep their contents up to date automatically, so that if something changes anywhere, the change will be reflected everywhere.')

(soundQuickStart
	'If true, attempt to start playing sounds using optional "quick start"')

(soundsEnabled
	'If false, all sound playing is disabled')

(systemWindowEmbedOK
	'Determines whether, in Morphic, when a SystemWindow is dropped onto a willing receptor it should be deposited into that receptor.')

(timeStampsInMenuTitles
	'If true, then the author''s timestamp is displayed as the menu title of any message list; if false, no author''s timestamps are shown')

(thoroughSenders
	'If true, then ''senders'' browsers will dive inside structured literals in their search')

(twentyFourHourFileStamps
	'If #changeSetVersionNumbers is false, this preference determines whether the date/time suffix used with changeset fileouts is based on a 24-hr clock or a 12-hr clock.')

(uniformWindowColors
	'If true, then all standard windows are given the same color rather than their customized window-type-specific colors')

(unlimitedPaintArea
	'If true, the painting area for a new drawing will not be limited in size; if false, a reasonable
limit will be applied, in an attempt to hold down memory and time price.')

(updateRemoveSequenceNum
	'If true, then remove the leading sequence number from the filename before automatically saving a local copy of any update loaded.')

(updateSavesFile
	'If true, then when an update is loaded from the server, a copy of it will automatically be saved on a local file as well.')

(useDetailPanesInViewers
	'If true, then Viewers will have an extra "" control at the left of each row, the hitting of which toggles the appearance of a textual detail pane.')

(useGlobalFlaps
	'If true, then flaps are shown along the edges of Morphic projects.')

(viewersInFlaps
	'If true, viewers are projected into flaps along the right edge of the screen')

(warnIfNoChangesFile
	'If true, then you will be warned, whenever you start up, if no changes file
can be found')

(warnIfNoSourcesFile 
	'If true, then you will be warned, whenever you start up, if no sources file can be found')


			) 
! !

!Preferences class methodsFor: 'standard preferences' stamp: 'programmatic 1/13/2000 10:57'!
annotationPanes
	^ self valueOfFlag: #annotationPanes! !

!Preferences class methodsFor: 'standard preferences'!
browserShowsPackagePane
	^ self valueOfFlag: #browserShowsPackagePane! !

!Preferences class methodsFor: 'standard preferences' stamp: 'programmatic 1/13/2000 10:57'!
cautionBeforeClosing
	^ self valueOfFlag: #cautionBeforeClosing! !

!Preferences class methodsFor: 'standard preferences' stamp: 'programmatic 1/13/2000 12:21'!
checkForSlips
	^ self valueOfFlag: #checkForSlips! !

!Preferences class methodsFor: 'standard preferences' stamp: 'programmatic 1/13/2000 10:57'!
clickOnLabelToEdit
	^ self valueOfFlag: #clickOnLabelToEdit! !

!Preferences class methodsFor: 'standard preferences' stamp: 'programmatic 1/13/2000 10:57'!
debugHaloHandle
	^ self valueOfFlag: #debugHaloHandle! !

!Preferences class methodsFor: 'standard preferences' stamp: 'programmatic 1/13/2000 10:57'!
diffsInChangeList
	^ self valueOfFlag: #diffsInChangeList! !

!Preferences class methodsFor: 'standard preferences' stamp: 'programmatic 1/13/2000 10:57'!
mvcProjectsAllowed
	^ self valueOfFlag: #mvcProjectsAllowed! !

!Preferences class methodsFor: 'standard preferences' stamp: 'programmatic 1/13/2000 10:57'!
projectZoom
	^ self valueOfFlag: #projectZoom! !

!Preferences class methodsFor: 'standard preferences' stamp: 'programmatic 1/13/2000 10:57'!
projectsSentToDisk
	^ self valueOfFlag: #projectsSentToDisk! !

!Preferences class methodsFor: 'standard preferences' stamp: 'programmatic 1/13/2000 10:57'!
promptForUpdateServer
	^ self valueOfFlag: #promptForUpdateServer! !

!Preferences class methodsFor: 'standard preferences' stamp: 'programmatic 1/13/2000 10:57'!
scrollBarsNarrow
	^ self valueOfFlag: #scrollBarsNarrow! !

!Preferences class methodsFor: 'standard preferences' stamp: 'programmatic 1/13/2000 10:57'!
scrollBarsOnRight
	^ self valueOfFlag: #scrollBarsOnRight! !

!Preferences class methodsFor: 'standard preferences' stamp: 'programmatic 1/13/2000 10:57'!
scrollBarsWithoutMenuButton
	^ self valueOfFlag: #scrollBarsWithoutMenuButton! !

!Preferences class methodsFor: 'standard preferences' stamp: 'programmatic 1/13/2000 10:57'!
soundQuickStart
	^ self valueOfFlag: #soundQuickStart! !

!Preferences class methodsFor: 'standard preferences' stamp: 'sw 1/12/2000 22:40'!
soundsEnabled
	^ self valueOfFlag: #soundsEnabled! !

!Preferences class methodsFor: 'standard preferences' stamp: 'programmatic 1/13/2000 10:57'!
systemWindowEmbedOK
	^ self valueOfFlag: #systemWindowEmbedOK! !

!Preferences class methodsFor: 'standard preferences' stamp: 'programmatic 1/13/2000 12:21'!
timeStampsInMenuTitles
	^ self valueOfFlag: #timeStampsInMenuTitles! !

!Preferences class methodsFor: 'standard preferences' stamp: 'sw 1/12/2000 22:56'!
useAnnotationPanes
	"Because of so any senders, this wording retained here though we defer to the renamed flag"

	^ self valueOfFlag: #annotationPanes! !

!Preferences class methodsFor: 'initial values' stamp: 'sw 1/19/2000 13:41'!
initialValuesAToM
	"CategoryInfo _ nil"
	"Preferences openFactoredPanel"
	^#(
		(annotationPanes					false	(browsing))
		(autoAccessors						false	(general))
		(automaticViewerPlacement			true	(scripting))
		(balloonHelpEnabled					true	(morphic))
		(browserShowsPackagePane			false	(browsing))
		(browseWithPrettyPrint				false	(browsing))
		(caseSensitiveFinds					false	(general))
		(cautionBeforeClosing				false	(windows))
		(changeSetVersionNumbers			true	(fileout))
		(checkForSlips						true	(fileout))
		(clickOnLabelToEdit					true	(windows))
		(cmdDotEnabled						true	(debug))
		(colorWhenPrettyPrinting			false	(browsing))
		(compressFlashImages				false	(media))
		(confirmFirstUseOfStyle				true	(browsing))
		(conversionMethodsAtFileOut			false	(fileout))
		(debugHaloHandle					true	(debug	halos))
		(diffsInChangeList					true	(browsing))
		(extractFlashInHighQuality			true	(media))
		(extractFlashInHighestQuality		false	(media))
		(fastDragWindowForMorphic			false	(windows))
		(fenceEnabled						true	(scripting))
		(iconicHalos							true	(halos))
		(ignoreStyleIfOnlyBold				true	(browsing))
		(inboardScrollbars					false	(scrolling))
		(logDebuggerStackToFile				true	(debug))
		(menuColorFromWorld				false	(menus))
		(mouseOverHalosEnabled				false	(halos))
		(mvcProjectsAllowed					false	(general))
)
! !

!Preferences class methodsFor: 'initial values' stamp: 'sw 1/19/2000 14:25'!
initialValuesNToZ
	"Another lot of initial values for prefs.  Simply placing methods of this sort in the 'initial values' category will assure that the initial values provided are ascribed to the preference when prefs are initialized"

	^ #(	
		(noviceMode							false	(general))
		(oneViewerFlapAtATime				true	(scripting))
		(optionalButtons						false	(general))
		(personalizedWorldMenu				true	(menus))
		(preserveTrash						true	(morphic))
		(printAlternateSyntax				false	(browsing))
		(projectsSentToDisk					false	(general))
		(projectZoom							false	(general))
		(promptForUpdateServer				true	(updates))
		(reverseWindowStagger				true	(windows))
		(roundedMenuCorners				true	(menus))
		(roundedWindowCorners				false	(windows))
		(scrollBarsNarrow					false	(scrolling))
		(scrollBarsOnRight					false	(scrolling))
		(scrollBarsWithoutMenuButton		false	(menus scrolling))
		(simpleHalos							false	(halos))
		(smartUpdating						true	(browsing))
		(soundsEnabled						false	(media))
		(soundQuickStart					false	(media))
		(systemWindowEmbedOK				false	(windows))
		(thoroughSenders					true	(general))
		(timeStampsInMenuTitles				false	(menus))
		(twentyFourHourFileStamps			true	(fileout)) 
		(unlimitedPaintArea					false	(morphic))
		(updateSavesFile						false	(updates))
		(useGlobalFlaps						true	(morphic))
		(viewersInFlaps						true	(scripting))
		(warnIfNoChangesFile				true	(general))
		(warnIfNoSourcesFile				true	(general))

)
	"Preferences resetCategoryInfo"


! !

!Preferences class methodsFor: 'factored pref panel' stamp: 'sw 1/11/2000 22:19'!
allHelpStrings
	| aList |
	aList _ OrderedCollection new.
	FlagDictionary keysDo:
		[:aKey  | aList add: (self helpMessageForPreference: aKey)].
	^ aList! !

!Preferences class methodsFor: 'factored pref panel' stamp: 'sw 1/13/2000 11:04'!
allPreferenceFlagKeys
	"Preferences allPreferenceFlagKeys"
	^ FlagDictionary keys asSortedArray! !

!Preferences class methodsFor: 'factored pref panel' stamp: 'sw 1/19/2000 14:16'!
factoredCategories
	| prefsWithoutInits extraItem |
	"Preferences factoredCategories"
	"CategoryInfo _ nil"

	CategoryInfo ifNil:
		[CategoryInfo _ self initialCategoryInfo].
	((prefsWithoutInits _ self preferencesLackingInitializers) size > 0)
		ifTrue:
			[extraItem _ (Array with: 'uncategorized' with: prefsWithoutInits asSortedArray)].
	^ extraItem
		ifNil:
			[CategoryInfo]
		ifNotNil:
			[CategoryInfo, (Array with: extraItem)]! !

!Preferences class methodsFor: 'factored pref panel' stamp: 'sw 1/14/2000 16:11'!
helpPaneForFactoredPanel
	| helpPane aTextMorph aTypeIn aMenu |
	"Still underway"
	helpPane _ PasteUpMorph new beTransparent extent: 600 @ 200.
	helpPane setNameTo: '?'.
	aTextMorph _ TextMorph new width: 10; contents: 'Help is on the way...'.
	helpPane addMorph: aTextMorph.
	aTypeIn _ SearchMorph new setQuery: 'Search for...' initialAnswer: '' answerHeight: 50.
	aTypeIn model: self.
	helpPane addMorph: (aTypeIn position: 10@30).


	helpPane addMorph: (aMenu _ self currentHand appearanceMenu toggleStayUp: true).
	aMenu right: helpPane right - 40.
	^ helpPane
! !

!Preferences class methodsFor: 'factored pref panel' stamp: 'sw 1/19/2000 16:16'!
initialCategoryInfo
	| categories |
	categories _ IdentityDictionary new.
	self allPreferenceInitializationSpecs do:
		[:spec |
			spec size > 2 ifTrue:
				[spec third do:
					[:sym | 
						(categories includesKey: sym) ifFalse:
							[categories at: sym put: OrderedCollection new].
					(categories at: sym) add: spec first]]].
	^ categories keys asSortedArray collect:
		[:aKey | Array with: aKey with: (categories at: aKey) asSortedArray]! !

!Preferences class methodsFor: 'factored pref panel' stamp: 'sw 1/19/2000 14:51'!
openFactoredPanel
	"Preferences openFactoredPanel"
	self openFactoredPanelWithWidth: 370! !

!Preferences class methodsFor: 'factored pref panel' stamp: 'sw 1/19/2000 14:23'!
openFactoredPanelWithWidth: aWidth
	"Preferences openFactoredPanelWithWidth: 325"
	| tabbedPalette controlPage window playfield aColor aFont  maxEntriesPerCategory tabsMorph |
	aFont _ StrikeFont familyName: 'NewYork' size: 19.
	aColor _ Color r: 0.645 g: 1.0 b: 1.0.
	tabbedPalette _ TabbedPalette newSticky.
	(tabsMorph _ tabbedPalette tabsMorph) color: aColor darker; highlightColor: Color red regularColor: Color brown darker darker.
	maxEntriesPerCategory _ 0.
	"tabbedPalette addTabFor: self helpPaneForFactoredPanel font: aFont.  LATER!!"
	self factoredCategories do:
		[:aCat |
			controlPage _ AlignmentMorph newColumn beSticky color: aColor.
			controlPage borderColor: aColor; inset: 4.
			aCat second do:
				[:aPrefSymbol |
					controlPage addMorphBack:
						(Preferences buttonRepresenting: aPrefSymbol wording: aPrefSymbol color: nil)].
			controlPage setNameTo: aCat first asString.
			tabbedPalette addTabFor: controlPage font: aFont.
			maxEntriesPerCategory _ maxEntriesPerCategory max: aCat second size].
	tabbedPalette selectTabNamed: 'general'.
	tabsMorph rowsNoWiderThan: aWidth.
	playfield _ PasteUpMorph newSticky extent: (aWidth @ (25 + tabsMorph height + (20 * maxEntriesPerCategory))).
	playfield color: aColor.
	playfield addMorphBack: tabbedPalette.
	Smalltalk isMorphic
		ifTrue:
			[window _ (SystemWindow labelled: 'Preferences') model: nil.
			window bounds: ((100@100- ((0@window labelHeight) + window borderWidth))
								extent: (playfield extent + window borderWidth)).
			window addMorph: playfield frame: (0@0 extent: 1@1).
			window updatePaneColors.
			window position: 200 @ 20.
			World addMorph: window.
			World startSteppingSubmorphsOf: window.
			window activate]
		ifFalse:
			[(window _ MVCWiWPasteUpMorph newWorldForProject: nil) addMorph: playfield.
			window startSteppingSubmorphsOf: playfield.
			MorphWorldView openOn: window  label: 'Preferences' extent: window fullBounds extent]

! !

!Preferences class methodsFor: 'factored pref panel' stamp: 'sw 1/19/2000 13:43'!
resetCategoryInfo
	"Preferences resetCategoryInfo"

	CategoryInfo _ nil! !


!Project methodsFor: 'displaying' stamp: 'sw 1/12/2000 18:44'!
showZoom
	"Decide if user wants a zoom transition, and if there is enough memory to do it."

	^ Preferences projectZoom and:
		"Only show zoom if there is room for both displays plus a megabyte"
		[Smalltalk garbageCollectMost > 
						(Display boundingBox area*displayDepth //8+1000000)]! !


!ReferenceMorph methodsFor: 'misc' stamp: 'sw 1/11/2000 10:18'!
morphToInstall: aMorph font: aFont
	"Create a new tab consisting of a string holding the morph's name"
	| aLabel nameToUse |
	aLabel _ StringMorph contents: (nameToUse _ aMorph externalName) font: aFont.
	self addMorph: aLabel.
	aLabel lock.
	self referent: aMorph.
	self setNameTo: nameToUse.
	self fitContents.! !


!ReferenceMorph class methodsFor: 'as yet unclassified' stamp: 'sw 1/11/2000 10:19'!
forMorph: aMorph font: aFont
	"Create a new tab consisting of a string holding the morph's name"
	^ self new morphToInstall: aMorph font: aFont! !


!ScreenController methodsFor: 'menu messages' stamp: 'sw 1/12/2000 22:43'!
soundOnOrOff
	Preferences setPreference: #soundsEnabled
		toValue: Preferences self soundsEnabled not! !

!ScreenController methodsFor: 'nested menus' stamp: 'sw 1/12/2000 22:42'!
helpMenu 
	"Answer the help menu to be put up as a screen submenu"

	^ SelectionMenu labelList:
		#(	'keep this menu up'

			'about this system'
			'update code from server'
			'edit preferences...'

			'command-key help'
			'font size summary'
			'useful expressions'
			'view graphical imports'),

			(Array with: (Preferences soundsEnabled
							ifFalse: ['turn sound on']
							ifTrue: ['turn sound off'])) ,

		#(	'definition for...'
			'set author initials...'
			'vm statistics'
			'space left')
		lines: #(1 4 6 10)
		selections: #(durableHelpMenu aboutThisSystem absorbUpdatesFromServer
editPreferences  openCommandKeyHelp fontSizeSummary openStandardWorkspace viewImageImports
soundOnOrOff  lookUpDefinition setAuthorInitials vmStatistics garbageCollect)
"
ScreenController new helpMenu startUp
"! !


!SoundPlayer class methodsFor: 'playing' stamp: 'sw 1/12/2000 22:43'!
resumePlaying: aSound quickStart: quickStart
	"Start playing the given sound without resetting it; it will resume playing from where it last stopped. If quickStart is true, then try to start playing the given sound immediately."

	| doQuickStart |
	Preferences soundsEnabled ifFalse: [^ self].
	doQuickStart _ quickStart.
	Preferences soundQuickStart ifFalse: [doQuickStart _ false].
	PlayerProcess == nil ifTrue: [
		self canStartPlayer ifFalse: [^ self].
		self startUp.
		"Check if startup was successful"
		SoundSupported ifFalse:[^self].
		doQuickStart _ false].

	PlayerSemaphore critical: [
		(ActiveSounds includes: aSound)
			ifTrue: [doQuickStart _ false]
			ifFalse: [
				doQuickStart ifFalse: [ActiveSounds add: aSound]]].

	"quick-start the given sound, unless the sound player has just started"
	doQuickStart ifTrue: [self startPlayingImmediately: aSound].
! !


!StringHolder methodsFor: 'message list menu' stamp: 'sw 1/13/2000 12:19'!
messageListSelectorTitle
	| selector aString aStamp |
	Preferences timeStampsInMenuTitles
		ifFalse:
			[^ nil].
	(selector _ self selectedMessageName) ifNotNil:
		[aString _ selector truncateWithElipsisTo: 28.
		^ (aStamp _ self timeStamp) size > 0
			ifTrue:
				[aString, String cr, aStamp]
			ifFalse:
				[aString]].
	^ nil! !


!ChangeList methodsFor: 'initialization-release' stamp: 'sw 1/13/2000 10:50'!
initialize
	showDiffs _ Preferences diffsInChangeList.
	changeList _ OrderedCollection new.
	list _ OrderedCollection new.
	listIndex _ 0.
	super initialize! !


!ChangeListForProjects methodsFor: 'as yet unclassified' stamp: 'sw 1/13/2000 12:48'!
contents

	^ self showDiffs
		ifFalse: [self undiffedContents]
		ifTrue: [self currentDiffedFromContents]
			"Current is writing over one in list.  Show how I would change it"! !


!SystemWindow methodsFor: 'label' stamp: 'sw 1/12/2000 22:23'!
relabelEvent: evt
	^ Preferences clickOnLabelToEdit
		ifFalse:	[self mouseDown: evt]
		ifTrue:	[self relabel]! !


!TabbedPalette methodsFor: 'initialization' stamp: 'sw 1/11/2000 11:16'!
addTabFor: aReferent font: aFont
	| aTab |
	aTab _ tabsMorph addTabFor: aReferent font: aFont.
	pages add: aReferent.
	currentPage ifNil: [currentPage _ aReferent].
	^ aTab! !

!TabbedPalette methodsFor: 'parts & controls tabs' stamp: 'sw 1/12/2000 22:43'!
addControlsTab
	| controlPage |
	controlPage _ AlignmentMorph newColumn beSticky color: Color white.

	controlPage addMorphBack:
		(Preferences buttonRepresenting: #balloonHelpEnabled wording: 'Balloon Help' color: nil).

	controlPage addMorphBack:
		(Preferences buttonRepresenting: #fenceEnabled wording: 'Fence Enabled' color: nil).

	controlPage addMorphBack:
		(Preferences buttonRepresenting: #mouseOverHalosEnabled wording: 'Halos' color: nil).

	controlPage addMorphBack:
		(Preferences buttonRepresenting: #soundsEnabled wording: 'Sound Enabled' color: nil).

	controlPage setNameTo: 'controls'.
	self addTabForBook: controlPage  withBalloonText:
'controls to turn sound,
balloon help, etc., on and off'! !

!TabbedPalette methodsFor: 'user-interface' stamp: 'sw 1/11/2000 12:50'!
selectTabNamed: aName
	| aTab |
	aTab _ self tabMorphs detect: [:m | ((m isKindOf: StringMorph) and: [m contents = aName])
		or: [(m isKindOf: ReferenceMorph) and: [(m firstSubmorph isKindOf: StringMorph) and:
				[m firstSubmorph contents = aName]]]] ifNone: [nil].
	aTab ifNotNil: [self selectTab: aTab]! !


!Utilities class methodsFor: 'fetching updates' stamp: 'sw 1/12/2000 22:16'!
chooseUpdateList
	"When there is more than one set of update servers, let the user choose which we will update from.  Put it at the front of the list. Return false if the user aborted.  If the preference #promptForUpdateServer is false, then suppress that prompt, in effect using the same server choice that was used the previous time (a convenience for those of us who always answer the same thing to the prompt.)"

	| index him |
	((UpdateUrlLists size > 1) and: [Preferences promptForUpdateServer])
		ifTrue:
			[index _ (PopUpMenu labelArray: (UpdateUrlLists collect: [:each | each first]) lines: #()) 
				startUpWithCaption: 'Choose a group of servers
from which to fetch updates.'.
			index > 0 ifTrue:
				[him _ UpdateUrlLists at: index.
				UpdateUrlLists removeAt: index.
				UpdateUrlLists addFirst: him].
			^ index > 0].
	^ true! !

!Utilities class methodsFor: 'support windows' stamp: 'sw 1/19/2000 13:59'!
standardWorkspaceContents
	^ self class firstCommentAt: #standardWorkspaceContents

	"Smalltalk recover: 10000.
ChangeList browseRecentLog.
ChangeList browseRecent: 2000.

Preferences editAnnotations.
Utilities reinstateDefaultFlaps. 
Preferences resetCategoryInfo

(FileStream oldFileNamed: 'Lives of the Wolves') edit.
(FileStream oldFileNamed: 'tuesdayFixes.cs') fileIn
ChangeList browseFile: 'myChanges.st'

TextStyle default fontAt: 7 put: (StrikeFont new readMacFontHex: 'Cairo 18')

StandardSystemView browseAllAccessesTo: 'maximumSize'.
StandardSystemView doCacheBits  ""restore fast windows mode in mvc""

Symbol selectorsContaining: 'rsCon'.
Smalltalk browseMethodsWhoseNamesContain: 'screen'.

Browser newOnClass: Utilities.
Browser fullOnClass: SystemDictionary.

FormView allInstances inspect.
StandardSystemView someInstance inspect.

Utilities storeTextWindowContentsToFileNamed: 'TextWindows'
Utilities reconstructTextWindowsFromFileNamed: 'TextWindows'

ScriptingSystem resetStandardPartsBin.
ScheduledControllers screenController openMorphicConstructionWorld.
ScheduledControllers screenController openMorphicWorld.

SystemOrganization categoryOfElement: #Controller. 
ParagraphEditor organization categoryOfElement: #changeEmphasis.

Cursor wait showWhile: [Sensor waitButton].

Smalltalk bytesLeft asStringWithCommas.
Symbol instanceCount. 
Time millisecondsToRun:
	[Smalltalk allCallsOn: #asOop]
MessageTally spyOn: [Smalltalk allCallsOn: #asOop].

"

"Utilities openStandardWorkspace"! !


IndexTabs removeSelector: #addActionTabWithTitle:!
IndexTabs removeSelector: #tabFont!
Preferences class removeSelector: #allowSysWindowEmbedding!
Preferences class removeSelector: #showDebugHaloHandle!
Preferences class removeSelector: #suppressCheckForSlips!
Preferences class removeSelector: #disableSounds!
Preferences class removeSelector: #initHelpMsgsB!
Preferences class removeSelector: #standardInitialValues!
Preferences class removeSelector: #initialValuesA!
Preferences class removeSelector: #initHelpMsgsD!
Preferences class removeSelector: #showProjectZoom!
Preferences class removeSelector: #initHelpMsgsA!
Preferences class removeSelector: #allowSoundQuickStart!
Preferences class removeSelector: #allowLabelDragging!
Preferences class removeSelector: #showTimeStampsInMenuTitles!
Preferences class removeSelector: #showDiffsInChangeList!
Preferences class removeSelector: #sysWindowEmbedOK!
Preferences class removeSelector: #allPreferenceInitializationPairs!
Preferences class removeSelector: #allowMVCprojects!
Preferences class removeSelector: #initHelpMsgsC!
Preferences class removeSelector: #suppressUpdateServerPrompt!
TabbedPalette removeSelector: #addScriptableTabWithTitle:!
"Postscript:"
	| currentValue newValue allCurrentKeys |
	allCurrentKeys _ Preferences allPreferenceFlagKeys.
	#(	
		(allowLabelDragging			clickOnLabelToEdit		reverse		clobber)
		(allowMVCprojects				mvcProjectsAllowed		same		clobber)
		(allowSoundQuickStart			soundQuickStart			same		clobber)
		(allowSysWindowEmbedding		systemWindowEmbedOK	same		clobber)
		(disableSounds					soundsEnabled			reverse		clobber)
		(showDebugHaloHandle			debugHaloHandle		same		clobber)
		(showDiffsInChangeList			diffsInChangeList		same		clobber)
		(showProjectZoom				projectZoom				same		clobber)
		(suppressCheckForSlips			checkForSlips			reverse		clobber)
		(suppressUpdateServerPrompt	promptForUpdateServer	reverse		clobber)
		(showTimeStampsInMenuTitles	timeStampsInMenuTitles	same		clobber)
		(useAnnotationPanes			annotationPanes			same		retain)
	) do:
		[:quad |
			(allCurrentKeys includes: quad second) ifFalse: 
				[currentValue _ Preferences valueOfFlag: quad first.
				newValue _ quad third == #same ifTrue: [currentValue] ifFalse: [currentValue not].
				Preferences rawSetPreference: quad second toValue: newValue].
			Preferences deletePreference: quad first.
			
			quad fourth == #clobber ifTrue: [Preferences class removeSelector: quad first]].

	Preferences initializeAddedPreferences; initializeHelpMessages.!

