'From Squeak2.8alpha of 13 January 2000 [latest update: #1857] on 15 February 2000 at 10:49:07 pm'!
"Change Set:		simpleMenuPref-sw
Date:			15 February 2000
Author:			Scott Wallace

Adds a preference 'simpleMenus', governing whether a more elementary (end-user-oriented) set of menus should be used.  This flag is honored in the morphic world menu, for starters."!


!HandMorph methodsFor: 'world menu' stamp: 'sw 2/15/2000 18:57'!
buildWorldMenu
	"Build the meta menu for the world."
	| menu |
	menu _ MenuMorph new defaultTarget: self.
	menu addStayUpItem.
	menu add: 'save project' target: self world 
			action: #saveOnFile.
	menu add: 'load project' target: self 
			action: #loadProject.
	menu add: 'previous project' target: owner action: #goBack.
	menu add: 'jump to project...' target: owner action: #jumpToProject.

	Preferences simpleMenus ifFalse:
		[menu addLine.
		menu add: 'save for future revert' target: self world project 
			action: #saveForRevert.
		menu add: 'revert to saved copy' target: self world project action: #revert].

	menu addLine.
	menu add: 'restore display' target: self world action: #restoreDisplay.

	menu addLine.
	Preferences simpleMenus ifFalse:
		[menu add: 'open...' action: #openWindow.
		menu add: 'windows & flaps...' action: #windowsDo.
		menu add: 'changes...' action: #changesDo].
	menu add: 'help...' action: #helpDo.
	menu add: 'appearance...' action: #appearanceDo.
	Preferences simpleMenus ifFalse:
		[menu add: 'do...' target: Utilities action: #offerCommonRequests].

	menu addLine.
	menu add: 'new morph...' action: #newMorph.
	menu add: 'authoring tools...' action: #scriptingDo.
	menu add: 'playfield options...' action: #playfieldDo.
	Preferences simpleMenus ifFalse:
		[menu add: 'print PS to file...' action: #printWorldOnFile.
		menu add: 'debug...' action: #debugDo].

	menu addLine.
	menu add: 'save' action: #saveSession.
	menu add: 'save as...' action: #saveAs.
	menu add: 'save and quit' action: #saveAndQuit.
	menu add: 'quit' action: #quitSession.

	^ menu! !


!Preferences class methodsFor: 'initialization' stamp: 'sw 2/15/2000 18:40'!
absorbAdditions
	"Preferences absorbAdditions"
	self initializeAddedPreferences.
	self initializeHelpMessages.
	self resetCategoryInfo! !

!Preferences class methodsFor: 'help' stamp: 'sw 2/15/2000 18:39'!
helpMsgsAdditionA
	"This, and the other methodds in this category, are automatically called whenever you call

   	Preferences initializeHelpMessages
		or
	Preferences callHelpMessageInitializers
"

	^ #( 
(simpleMenus
	'If true, simpler menus are presented.')
)
	"Preferences resetCategoryInfo"


! !

!Preferences class methodsFor: 'standard preferences' stamp: 'programmatic 2/15/2000 18:46'!
simpleMenus
	^ self valueOfFlag: #simpleMenus! !

!Preferences class methodsFor: 'initial values' stamp: 'sw 2/15/2000 18:37'!
initialValuesAdditionA
	"Another lot of initial values for prefs.  Simply placing methods of this sort in the 'initial values' category will assure that the initial values provided are ascribed to the preference when prefs are initialized"

	^ #(	
		(simpleMenus						false	(menus))
)
	"Preferences resetCategoryInfo"


! !


"Postscript:"
Preferences absorbAdditions.!

