'From Squeak2.8alpha of 4 February 2000 [latest update: #1873] on 27 February 2000 at 11:36:09 pm'!
"Change Set:		23PPBlockTemps-sma
Date:			27 February 2000
Author:			Stefan Matthias Aust

Pretty printing of block temporaries didn't work. Fixed."!

ParseNode subclass: #BlockNode
	instanceVariableNames: 'arguments statements returns nArgsNode size remoteCopyNode temporaries '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Compiler'!

!BlockNode methodsFor: 'accessing' stamp: 'sma 2/27/2000 22:37'!
temporaries: aCollection
	temporaries _ aCollection! !

!BlockNode methodsFor: 'printing' stamp: 'sma 2/27/2000 22:42'!
printOn: aStream indent: level

	statements size <= 1 ifFalse: [aStream crtab: level].
	aStream nextPut: $[.
	self printArgumentsOn: aStream indent: level.
	self printTemporariesOn: aStream indent: level.
	self printStatementsOn: aStream indent: level.
	aStream nextPut: $]! !

!BlockNode methodsFor: 'printing' stamp: 'sma 2/27/2000 22:43'!
printTemporariesOn: aStream indent: level

	temporaries size = 0
		ifFalse: 
			[aStream nextPut: $|.
			temporaries do: 
				[:arg | 
				aStream
					space;
					withAttributes: (Preferences syntaxAttributesFor: #temporaryVariable)
					do: [aStream nextPutAll: arg key]].
			aStream nextPutAll: ' | '.
			"If >0 args and >1 statement, put all statements on separate lines"
			statements size > 1 ifTrue: [aStream crtab: level]]! !


!Parser methodsFor: 'expression types' stamp: 'sma 2/27/2000 22:38'!
blockExpression
	"[ ({:var} |) (| {temps} |) (statements) ] => BlockNode."

	| variableNodes temporaryBlockVariables |

	variableNodes _ OrderedCollection new.

	"Gather parameters."
	[self match: #colon] whileTrue: [variableNodes addLast: (encoder autoBind: self argumentName)].
	(variableNodes size > 0 & (hereType ~~ #rightBracket) and: [(self match: #verticalBar) not]) ifTrue: [^self expected: 'Vertical bar'].

	temporaryBlockVariables _ self temporaryBlockVariables.
	self statements: variableNodes innerBlock: true.
	parseNode temporaries: temporaryBlockVariables.

	(self match: #rightBracket) ifFalse: [^self expected: 'Period or right bracket'].

	"The scope of the parameters and temporary block variables is no longer active."
	temporaryBlockVariables do: [:variable | variable scope: -1].
	variableNodes do: [:variable | variable scope: -1]! !


