'From Squeak2.8alpha of 13 January 2000 [latest update: #1898] on 8 March 2000 at 4:35:55 pm'!
"Change Set:		projectMenuItems-sw
Date:			8 March 2000
Author:			Scott Wallace

Restores the traditional position of 'previous project' and 'jump to project...' items at the top of the world menu, as per Alan's request.

Also, adds a new 'project' branch to the world menu, in which will be found all the project-related menu items.  Most of these items are also still available in their former locations as well."!


!HandMorph methodsFor: 'world menu' stamp: 'sw 3/8/2000 16:12'!
buildWorldMenu
	"Build the meta menu for the world."
	| menu |
	menu _ MenuMorph new defaultTarget: self.
	menu addStayUpItem.
	menu add: 'previous project' target: owner action: #goBack.
	menu add: 'jump to project...' target: owner action: #jumpToProject.
	menu add: 'save project on file...' target: self world  action: #saveOnFile.
	menu add: 'load project from file...' target: self  action: #loadProject.
	menu addLine.

	menu add: 'restore display' target: self world action: #restoreDisplay.

	menu addLine.

	Preferences simpleMenus ifFalse:
		[menu add: 'open...' action: #openWindow.
		menu add: 'windows & flaps...' action: #windowsDo.
		menu add: 'changes...' action: #changesDo].
	menu add: 'help...' action: #helpDo.
	menu add: 'appearance...' action: #appearanceDo.
	Preferences simpleMenus ifFalse:
		[menu add: 'do...' target: Utilities action: #offerCommonRequests].

	menu addLine.
	menu add: 'new morph...' action: #newMorph.
	menu add: 'authoring tools...' action: #scriptingDo.
	menu add: 'playfield options...' action: #playfieldDo.
	menu add: 'projects...' action: #projectDo.

	Preferences simpleMenus ifFalse:
		[menu add: 'print PS to file...' action: #printWorldOnFile.
		menu add: 'debug...' action: #debugDo].

	menu addLine.
	menu add: 'save' action: #saveSession.
	menu add: 'save as...' action: #saveAs.
	menu add: 'save and quit' action: #saveAndQuit.
	menu add: 'quit' action: #quitSession.

	^ menu! !

!HandMorph methodsFor: 'world menu' stamp: 'sw 3/8/2000 14:11'!
projectDo
	"Build and show the project menu for the world."

	self projectMenu popUpAt: self position forHand: self.
! !

!HandMorph methodsFor: 'world menu' stamp: 'sw 3/8/2000 16:34'!
projectMenu
	"Build the project menu for the world."
	| menu |
	menu _ (MenuMorph entitled: 'projects...') defaultTarget: self.
	menu addStayUpItem.
	menu add: 'save project on file...' target: self world 
		action: #saveOnFile.
	menu add: 'load project from file...' target: self 
		action: #loadProject.
	menu addLine.
	(Preferences mvcProjectsAllowed and: [Smalltalk includesKey: #StandardSystemView])
		ifTrue: [menu add: 'create new mvc project' action: #openMVCProject].
	menu add: 'create new morphic project' action: #openMorphicProject.

	menu addLine.
	menu add: 'go to previous project' target: Project action: #advanceToPreviousProject.
	menu add: 'go to next project' target: Project action: #returnToPreviousProject.
	menu add: 'jump to project...' target: owner action: #jumpToProject.

	Preferences simpleMenus ifFalse:
		[menu addLine.
		menu add: 'save for future revert' target: self world project 
			action: #saveForRevert.
		menu add: 'revert to saved copy' target: self world project action: #revert].

	^ menu! !

!HandMorph methodsFor: 'world menu' stamp: 'sw 3/8/2000 14:09'!
worldMenuHelp
	| aList aMenu cnts explanation |
	"self currentWorld primaryHand worldMenuHelp"

	aList _ OrderedCollection new.
	#(helpMenu changesMenu openMenu debugMenu projectMenu scriptingMenu windowsMenu playfieldMenu appearanceMenu) 
		with:
	#('help' 'changes' 'open' 'debug' 'projects' 'authoring tools' 'windows & flaps' 'playfield options' 'appearance') do:
		[:sel :title | aMenu _ self perform: sel.
			aMenu items do:
				[:it | (((cnts _ it contents) = 'keep this menu up') or: [cnts size = 0])
					ifFalse: [aList add: (cnts, ' - ', title)]]].
	aList _ aList asSortedCollection: [:a :b | a asLowercase < b asLowercase].

	explanation _ String streamContents: [:aStream | aList do:
		[:anItem | aStream nextPutAll: anItem; cr]].

	(StringHolder new contents: explanation)
		openLabel: 'Where in the world menu is...'! !


