'From Squeak2.8alpha of 4 February 2000 [latest update: #2005] on 22 April 2000 at 7:13:04 pm'!
"Change Set:		1040LowSpace-go
Date:			30 March 2000
Author:			Georg Gollmann

The current LowSpaceWatcher just alerts the user. This is not useful for servers or for situations when objects are cached and should be discarded when space becomes tight. I have now generalized the mechanism used in my MailArchiver (http://macos.tuwien.ac.at/Squeak/mailArchiver.html).

As an example setup is now:

   Smalltalk memoryHogs add: ArchivedMail

When space is low #freeSomeSpace gets sent:

	ArchivedMail>freeSomeSpace
		''Remove all cached text from my instances.''
		self allInstancesDo: [:m | m purgeText]

If freeSomeSpace fails to free enough memory - maybe because no memoryHogs have been registered - the old behavior (alert the user) is invoked."!

IdentityDictionary subclass: #SystemDictionary
	instanceVariableNames: 'cachedClassNames '
	classVariableNames: 'LastImageName LastQuitLogPosition LowSpaceProcess LowSpaceSemaphore MemoryHogs ShutDownList SpecialSelectors StartUpList StartupStamp SystemChanges '
	poolDictionaries: ''
	category: 'System-Support'!

!SystemDictionary methodsFor: 'memory space' stamp: 'sma 4/22/2000 19:05'!
lowSpaceWatcher
	"Wait until the low space semaphore is signalled, then take appropriate actions."

	self garbageCollectMost <= self lowSpaceThreshold ifTrue: [
		self garbageCollect <= self lowSpaceThreshold ifTrue: [
			"free space must be above threshold before starting low space watcher"
			^ self beep]].

	LowSpaceSemaphore _ Semaphore new.
	self primLowSpaceSemaphore: LowSpaceSemaphore.
	self primSignalAtBytesLeft: self lowSpaceThreshold.  "enable low space interrupts"

	LowSpaceSemaphore wait.  "wait for a low space condition..."

	self primSignalAtBytesLeft: 0.  "disable low space interrupts"
	self primLowSpaceSemaphore: nil.
	LowSpaceProcess _ nil.
	"Note: user now unprotected until the low space watcher is re-installed"

	self memoryHogs do: [:hog | hog freeSomeSpace].
	self bytesLeft > self lowSpaceThreshold ifTrue: [^ self installLowSpaceWatcher].

	Smalltalk isMorphic
			ifTrue: [Project current interruptName: 'Space is low']
			ifFalse: [ScheduledControllers interruptName: 'Space is low']! !

!SystemDictionary methodsFor: 'memory space' stamp: 'sma 4/22/2000 19:03'!
memoryHogs
	"Answer the list of objects to notify with #freeSomeSpace if memory gets full."

	^ MemoryHogs ifNil: [MemoryHogs _ OrderedCollection new]! !

