'From Squeak2.8alpha of 4 February 2000 [latest update: #2005] on 22 April 2000 at 8:00:29 pm'!
"Change Set:		1050FileDir-bf
Date:			22 March 2000
Author:			Bert Freudenberg

Enforces the absoluteness of FileDirectories for Windows. Also corrects FileDirclass>>splitName:to:, for the DOS 'C:' case (which makes the specialized fullNameFor: method obsolete) and for the Unix '/foo' case.

sma added support for Windows UNC names, i.e. \\magus\dev\dir\file.txt"!


!DosFileDirectory methodsFor: 'as yet unclassified' stamp: 'bf 3/21/2000 17:06'!
setPathName: pathString
	"Ensure pathString is absolute - relative directories aren't supported on all platforms."

	(pathString isEmpty
		or: [pathString first = $\
			or: [pathString size >= 2 and: [pathString second = $: and: [pathString first isLetter]]]])
				ifTrue: [^ super setPathName: pathString].

	self error: 'Fully qualified path expected'! !


!FileDirectory class methodsFor: 'name utilities' stamp: 'bf 3/22/2000 18:04'!
splitName: fullName to: pathAndNameBlock
	"Take the file name and convert it to the path name of a directory and a local file name within that directory. FileName must be of the form: <dirPath><delimiter><localName>, where <dirPath><delimiter> is optional. The <dirPath> part may contain delimiters."

	| delimiter i dirName localName |
	delimiter _ self pathNameDelimiter.
	(i _ fullName findLast: [:c | c = delimiter]) = 0
		ifTrue:
			[dirName _ String new.
			localName _ fullName]
		ifFalse:
			[dirName _ fullName copyFrom: 1 to: (i - 1 max: 1).
			localName _ fullName copyFrom: i + 1 to: fullName size].

	^ pathAndNameBlock value: dirName value: localName! !


!DosFileDirectory class methodsFor: 'platform specific' stamp: 'sma 3/24/2000 11:15'!
isDrive: fullName
	^ (fullName size = 2 and: [fullName first isLetter and: [fullName last = $:]])
		or: [(fullName beginsWith: '\\') and: [(fullName occurrencesOf: $\) <= 3]]! !

!DosFileDirectory class methodsFor: 'platform specific' stamp: 'sma 3/24/2000 11:15'!
splitName: fullName to: pathAndNameBlock
	(self isDrive: fullName)
		ifTrue: [^ pathAndNameBlock value: fullName value: ''].
	^ super splitName: fullName to: pathAndNameBlock! !


!UnixFileDirectory methodsFor: 'file names' stamp: 'bf 3/22/2000 18:24'!
fullPathFor: path
	"Return the fully-qualified path name for the given file."
	path isEmpty ifTrue: [^ pathName].
	path first = $/ ifTrue: [^ path].
	^ pathName = '/'			"Only root dir ends with a slash"
		ifTrue: ['/' , path]
		ifFalse: [pathName , '/' , path]! !

DosFileDirectory removeSelector: #fullNameFor:!
