'From Squeak2.8alpha of 12 January 2000 [latest update: #2040] on 26 April 2000 at 10:29:18 pm'!
"Change Set:		PasteRecent
Date:			26 April 2000
Author:			Dan Ingalls

Keeps a queue of the most recent 5 clippings, and makes them available to a new 'paste...' command in the text editor.
"!

ScrollController subclass: #ParagraphEditor
	instanceVariableNames: 'paragraph startBlock stopBlock beginTypeInBlock emphasisHere initialText selectionShowing otherInterval '
	classVariableNames: 'ChangeText CmdActions CurrentSelection FindText Keyboard PasteQueue ShiftCmdActions TextEditorYellowButtonMenu UndoInterval UndoMessage UndoParagraph UndoSelection Undone RecentClippings '
	poolDictionaries: 'TextConstants '
	category: 'Kernel-ST80 Remnants'!

!FileList methodsFor: 'file list menu' stamp: 'di 4/26/2000 20:33'!
fileContentsMenu: aMenu shifted: shifted

| shiftMenu |
^ shifted 
	ifFalse: [aMenu 
		labels: 
'get entire file
view as hex
browse changes
find...(f)
find again (g)
set search string (h)
do again (j)
undo (z)
copy (c)
cut (x)
paste (v)
paste...
do it (d)
print it (p)
inspect it (i)
fileIn selection
accept (s)
cancel (l)
more...' 
		lines: #(3 6 8 12 16 18)
		selections: #(get getHex browseChanges
find findAgain setSearchString
again undo
copySelection cut paste pasteRecent
doIt printIt inspectIt fileItIn
accept cancel
shiftedYellowButtonActivity)]

	ifTrue: [shiftMenu _ ParagraphEditor shiftedYellowButtonMenu.
		aMenu 
			labels: shiftMenu labelString 
			lines: shiftMenu lineArray
			selections: shiftMenu selections]

! !


!ParagraphEditor methodsFor: 'menu messages' stamp: 'di 4/26/2000 21:57'!
pasteRecent
	"Paste an item chose from RecentClippings."

	| clipping |
	(clipping _ self class chooseRecentClipping) ifNil: [^ self].
	CurrentSelection _ clipping.
	^ self paste! !


!ParagraphEditor class methodsFor: 'class initialization' stamp: 'di 4/26/2000 20:32'!
initializeTextEditorMenus   "ParagraphEditor initializeTextEditorMenus"
		"Initialize the yellow button pop-up menu and corresponding messages."

	TextEditorYellowButtonMenu _ SelectionMenu
		labels: 
'find...(f)
find again (g)
set search string (h)
do again (j)
undo (z)
copy (c)
cut (x)
paste (v)
paste...
do it (d)
print it (p)
inspect it (i)
accept (s)
cancel (l)
show bytecodes
more...' 
		lines: #(3 5 9 12 14 15)
		selections: #(find findAgain setSearchString again undo copySelection cut paste pasteRecent doIt printIt inspectIt accept cancel showBytecodes shiftedYellowButtonActivity)
! !

!ParagraphEditor class methodsFor: 'clipboard access' stamp: 'di 4/26/2000 21:55'!
chooseRecentClipping  "ParagraphEditor chooseRecentClipping"
	"Choose by menu from among the recent clippings"

	RecentClippings ifNil: [^ nil].
	^ (SelectionMenu
		labelList: (RecentClippings collect: [:txt | ((txt asString contractTo: 50)
									copyReplaceAll: Character cr asString with: '\')
									copyReplaceAll: Character tab asString with: '|'])
		selections: RecentClippings) startUp.

! !

!ParagraphEditor class methodsFor: 'clipboard access' stamp: 'di 4/26/2000 20:54'!
clipboardTextPut: text
	"Set text currently on the clipboard.  Also export to Mac"

	CurrentSelection _ text.
	self noteRecentClipping: text.
	Smalltalk clipboardText: CurrentSelection string! !

!ParagraphEditor class methodsFor: 'clipboard access' stamp: 'di 4/26/2000 22:29'!
noteRecentClipping: text
	"Keep most recent clippings in a queue for pasteRecent (paste... command)"

	text isEmpty ifTrue: [^ self].
	text size > 50000 ifTrue: [^ self].
	RecentClippings ifNil: [RecentClippings _ OrderedCollection new].
	(RecentClippings includes: text) ifTrue: [^ self].
	RecentClippings addFirst: text.
	[RecentClippings size > 5] whileTrue: [RecentClippings removeLast].
! !


!PluggableTextMorph methodsFor: 'menu commands' stamp: 'di 4/26/2000 22:22'!
pasteRecent
	"Paste an item chosen from RecentClippings."

	| clipping |
	(clipping _ ParagraphEditor chooseRecentClipping) ifNil: [^ self].
	ParagraphEditor clipboardTextPut: clipping.
	^ self handleEdit: [textMorph editor paste]! !


!RecentMessageSet methodsFor: 'as yet unclassified' stamp: 'di 4/26/2000 20:48'!
reformulateList
	self initializeMessageList: Utilities recentMethodSubmissions reversed.
	self messageListIndex: (messageList size min: 1).	"0 or 1"
	self changed: #messageList.
	self changed: #messageListIndex! !

Utilities class removeSelector: #recentlySubmittedMessages!
ScrollController subclass: #ParagraphEditor
	instanceVariableNames: 'paragraph startBlock stopBlock beginTypeInBlock emphasisHere initialText selectionShowing otherInterval '
	classVariableNames: 'ChangeText CmdActions CurrentSelection FindText Keyboard RecentClippings ShiftCmdActions TextEditorYellowButtonMenu UndoInterval UndoMessage UndoParagraph UndoSelection Undone '
	poolDictionaries: 'TextConstants '
	category: 'Kernel-ST80 Remnants'!
"Postscript:
Cause the 'paste...' command to get installed."
ParagraphEditor initializeTextEditorMenus!

