'From Squeak2.8alpha of 4 February 2000 [latest update: #2052] on 6 May 2000 at 7:22:19 pm'!
"Change Set:		044FileCntBrwEnh-sma
Date:			7 May 2000
Author:			Stefan Matthias Aust

The FileContentsBrowser shows now whether existing methods are identical or modified.  Implemented browse (b) menu item. Also a few refactorings."!


!FileContentsBrowser methodsFor: 'class list' stamp: 'sma 5/6/2000 18:48'!
browseMethodFull
	| myClass |
	(myClass _ self selectedClassOrMetaClass) ifNotNil:
		[Browser fullOnClass: myClass realClass selector: self selectedMessageName]! !

!FileContentsBrowser methodsFor: 'diffs' stamp: 'sma 5/6/2000 18:08'!
methodDiffFor: aString class: aPseudoClass selector: selector meta: meta 
	| theClass source |
	theClass _ Smalltalk at: aPseudoClass name ifAbsent: [^ aString copy].
	meta ifTrue: [theClass _ theClass class].
	(theClass includesSelector: selector)
		ifFalse: [^ aString copy].
	source _ theClass sourceCodeAt: selector.
	^ Cursor wait showWhile: [TextDiffBuilder buildDisplayPatchFrom: source to: aString]! !

!FileContentsBrowser methodsFor: 'infoView' stamp: 'sma 5/6/2000 19:19'!
extraInfo
	^ (self
		methodDiffFor: (self selectedClassOrMetaClass sourceCodeAt: self selectedMessageName)
		class: self selectedClass
		selector: self selectedMessageName
		meta: self metaClassIndicated) unembellished
			ifTrue: [' - identical']
			ifFalse: [' - modified']! !

!FileContentsBrowser methodsFor: 'infoView' stamp: 'sma 5/6/2000 18:26'!
infoViewContents
	| theClass |
	editSelection == #newClass ifTrue: [^ self packageInfo: self selectedPackage].
	self selectedClass isNil ifTrue: [^ ''].
	theClass _ Smalltalk at: self selectedClass name asSymbol ifAbsent: [].
	editSelection == #editClass ifTrue: [^ theClass notNil
			ifTrue: ['Class exists already in the system']
			ifFalse: ['New class']].
	editSelection == #editMessage ifFalse: [^ ''].
	(theClass notNil and: [self metaClassIndicated])
		ifTrue: [theClass _ theClass class].
	^ (theClass notNil and: [theClass includesSelector: self selectedMessageName])
		ifTrue: ['Method already exists' , self extraInfo]
		ifFalse: ['New method']! !

!FileContentsBrowser methodsFor: 'menus' stamp: 'sma 5/6/2000 18:36'!
classListMenu: aMenu

	^ aMenu 
		labels:
'definition
comment
browse full (b)
class refs (N)
fileIn
fileOut
rename...
remove
remove existing'
		lines: #(2 4 6 8)
		selections: #(editClass editComment browseMethodFull browseClassRefs fileInClass fileOutClass renameClass removeClass removeUnmodifiedCategories) 

! !

!FileContentsBrowser methodsFor: 'keys' stamp: 'sma 5/6/2000 18:48'!
classListKey: aChar from: view
	aChar == $b ifTrue: [^ self browseMethodFull].
	aChar == $N ifTrue: [^ self browseClassRefs].
	self packageListKey: aChar from: view! !

!FileContentsBrowser methodsFor: 'keys' stamp: 'sma 5/6/2000 18:50'!
messageListKey: aChar from: view
	aChar == $b ifTrue: [^ self browseMethodFull].
	super messageListKey: aChar from: view! !


!TextDiffBuilder methodsFor: 'printing' stamp: 'sma 5/6/2000 18:15'!
printPatchSequence: seq on: aStream 
	seq do: 
		[:assoc | 
		aStream
			withAttribute: (self attributeOf: assoc key)
			do: [aStream nextPutAll: assoc value; cr]]! !

!TextDiffBuilder methodsFor: 'private' stamp: 'sma 5/6/2000 18:13'!
attributeOf: type
	"Private. Answer a TextAttribute that is used to display text of the given type."

	type == #insert ifTrue: [^ TextColor red].
	type == #remove ifTrue: [^ TextEmphasis struckOut].
	^ TextEmphasis normal! !

