'From Squeak2.8alpha of 4 February 2000 [latest update: #2052] on 6 May 2000 at 7:28:13 pm'!
"Change Set:		046PasteUpGradient-bf
Date:			6 May 2000
Author:			Bert Freudenberg

Changes the superclass of PasteUpMorph from the now obsolete GradientFillMorph to BorderedMorph. This gives a significant speedup through fillstyle caching and saves 4 instance variables. A conversion method is provided (thanks to Bob Arning for fixing that special verifyStructure case) which preserves the gradient for old saved morphs. The preamble and postscript preserve existing gradients. ATTENTION!! I did not check what this does to PasteUpMorphs in image segments on disk - possibly these are brought in?
Todo: - make the appearance menu use the fillstyle menu
	- remove the backwards compatibility methods (flagged #fixThis)"

PasteUpMorph superclass name == #GradientFillMorph ifTrue: [
	dict _ Smalltalk at: #PasteUpFillTemp put: IdentityDictionary new.
	PasteUpMorph allSubInstances do: [:m | | c1 c2 |
		c1 _ m color.
		c2 _ m instVarNamed: 'fillColor2'.
		(c1 isColor and: [c2 isColor and: [c1 ~= c2]])
			ifTrue: [dict at: m put: c2]]]. !

!TranscriptStream methodsFor: 'initialization' stamp: 'di 5/9/2000 09:11'!
closeAllViews  "Transcript closeAllViews"

	self dependents do:
		[:d |
		(d isKindOf: PluggableTextView) ifTrue: [d topView controller closeAndUnscheduleNoTerminate].
		(d isKindOf: SystemWindow) ifTrue: [d delete]]! !

Transcript closeAllViews!

ClassBuilder beSilentDuring: [
BorderedMorph subclass: #PasteUpMorph
	instanceVariableNames: 'presenter model cursor padding backgroundMorph turtleTrailsForm turtlePen lastTurtlePositions openToDragNDrop isPartsBin autoLineLayout indicateCursor resizeToFit fileName isStackLike dataInstances currentDataInstance userFrameRectangle wantsMouseOverHalos worldState '
	classVariableNames: 'DisableDeferredUpdates MinCycleLapse StillAlive '
	poolDictionaries: ''
	category: 'Morphic-Worlds'
]!

!PasteUpMorph methodsFor: 'initialization' stamp: 'bf 5/4/2000 15:07'!
initialize
	owner _ nil.
	submorphs _ EmptyArray.
	borderWidth _ 1.
	borderColor _ Color r: 0.861 g: 1.0 b: 0.722.
	color _ Color r: 0.8 g: 1.0 b: 0.6.
	bounds _ 0@0 corner: 50@40.
	cursor _ 1.
	padding _ 3.
	autoLineLayout _ false.
	openToDragNDrop _ true.
	self isWorldMorph ifTrue: [self setProperty: #automaticPhraseExpansion toValue: true]
! !

!PasteUpMorph methodsFor: 'display' stamp: 'bf 5/4/2000 15:27'!
canHaveFillStyles
	"Return true if the receiver can have general fill styles; not just colors.
	This method is for gradually converting old morphs."
	^ true! !

!PasteUpMorph methodsFor: 'display' stamp: 'bf 5/6/2000 12:25'!
color: aColor
	"For backwards compatibility with GradientFillMorph"

	self flag: #fixThis.
	self removeProperty: #fillStyle.
	^ super color: aColor! !

!PasteUpMorph methodsFor: 'display' stamp: 'bf 5/6/2000 12:31'!
gradientFillColor: aColor
	"For backwards compatibility with GradientFillMorph"

	self flag: #fixThis.
	self useGradientFill.
	self fillStyle colorRamp: {0.0 -> color. 1.0 -> aColor}.
	self changed
! !

!PasteUpMorph methodsFor: 'display' stamp: 'bf 5/6/2000 12:49'!
pseudoDraw: aRectangle on: aCanvas
	| c |
	c _ aCanvas copyClipRect: aRectangle.
	c fillRectangle: aRectangle fillStyle: self fillStyle.
	turtleTrailsForm ifNotNil: [c paintImage: turtleTrailsForm at: 0@0].
	^c! !

!PasteUpMorph methodsFor: 'display' stamp: 'bf 5/6/2000 12:27'!
setGradientColor: evt
	"For backwards compatibility with GradientFillMorph"

	self flag: #fixThis.
	evt hand changeColorTarget: self selector: #gradientFillColor:
		originalColor: (self fillStyle isGradientFill
			ifTrue: [self fillStyle colorRamp last value]
			ifFalse: [color]).
! !

!PasteUpMorph methodsFor: 'object fileIn' stamp: 'bf 5/6/2000 12:00'!
convertbosfcebbfgccpmcpbttloiairfidcuww0: varDict bosfcebbpmcpbttloiairfidcuww0: smartRefStrm
	"These variables are automatically stored into the new instance ('bounds' 'owner' 'submorphs' 'fullBounds' 'color' 'extension' 'borderWidth' 'borderColor' 'presenter' 'model' 'cursor' 'padding' 'backgroundMorph' 'turtleTrailsForm' 'turtlePen' 'lastTurtlePositions' 'openToDragNDrop' 'isPartsBin' 'autoLineLayout' 'indicateCursor' 'resizeToFit' 'fileName' 'isStackLike' 'dataInstances' 'currentDataInstance' 'userFrameRectangle' 'wantsMouseOverHalos' 'worldState' ).
	This method is for additional changes. Use statements like (foo _ varDict at: 'foo')."

	"These are going away ('fillColor2' 'gradientDirection' 'colorArray' 'colorDepth' ) because we don't subclass GradientFillMorph anymore. Instead, we create a fillstyle that hopefully looks alike."

	| color2 |
	color2 _ varDict at: 'fillColor2'.
	(color isColor and: [color2 isColor and: [color ~= color2]]) ifTrue: [
		self useGradientFill.
		self fillStyle
			colorRamp: {0.0 -> color. 1.0 -> color2};
			radial: false;
			origin: self position;
			direction: ((varDict at: 'gradientDirection') == #vertical 
				ifTrue:[0@self height] 
				ifFalse:[self width@0]).
	]! !

!PasteUpMorph methodsFor: 'world state' stamp: 'bf 5/4/2000 15:09'!
initForProject: aWorldState

	worldState _ aWorldState.
	color _ (Color r:0.937 g: 0.937 b: 0.937).
	self addHand: HandMorph new.
	self setProperty: #automaticPhraseExpansion toValue: true.
	model _ nil.
! !


!IndexTabs methodsFor: 'initialization' stamp: 'bf 5/4/2000 15:09'!
initialize
	super initialize.
	padding _ 10.
	verticalPadding _ 4.
	basicHeight _ 14.
	basicWidth _ 200.
	color _ Color r: 0.0 g: 0.6 b: 0.6.
	borderWidth _ 0! !

"Postscript:
Restore gradients in old PasteUpMorphs"

| dict |
dict _ Smalltalk removeKey: #PasteUpFillTemp ifAbsent: [].
dict ifNotNil: [dict keysAndValuesDo: [:m :c | m gradientFillColor: c]]
!

