'From Squeak2.8alpha of 12 January 2000 [latest update: #2098] on 12 May 2000 at 3:18:09 pm'!
"Change Set:		ChgSetDropHistory
Date:			12 May 2000
Author:			Dan Ingalls

Adds a feature to drop history associated with classes that have been newly added in this change set.

The history that will be dropped includes method removals, renaming and reorganization.

Note that changeSets that have been so modified may not work properly if filed in over other earlier versions of the same classes.
"!


!ChangeSet methodsFor: 'class changes' stamp: 'di 5/12/2000 15:03'!
trimHistory
	"Drop non-essential history (rename, reorg, method removals) from newly-added classes."

	| baseClass |
	self changedClasses do:
		[:c | c isMeta
			ifTrue: [baseClass _ c theNonMetaClass]
			ifFalse: [baseClass _ c].
		((self classChangeAt: baseClass name) includes: #add) ifTrue:
			[(changeRecords at: c name) trimHistory]]! !


!ChangeSorter methodsFor: 'changeSet menu' stamp: 'di 5/12/2000 15:03'!
shiftedChangeSetMenu: aMenu
	aMenu add: 'conflicts with other change sets' action: #browseMethodConflicts.
	aMenu balloonTextForLastItem: 
'Browse all methods that occur both in this change set and in at least one other change set.'.

	parent ifNotNil:
		[aMenu add: 'conflicts with opposite side' action: #methodConflictsWithOtherSide.
			aMenu balloonTextForLastItem: 
'Browse all methods that occur both in this change set and in the one on the opposite side of the change sorter.'.
].
	aMenu addLine.
	aMenu add: 'check for slips' action: #lookForSlips.
	aMenu balloonTextForLastItem: 
'Check this change set for halts and references to Transcript.'.

	aMenu add: 'check for unsent messages' action: #checkForUnsentMessages.
	aMenu balloonTextForLastItem:
'Check this change set for messages that are not sent anywhere in the system'.
	aMenu addLine.

	aMenu add: 'inspect change set' action: #inspectChangeSet.
	aMenu balloonTextForLastItem: 
'Open an inspector on this change set. (There are some details in a change set which you don''t see in a change sorter.)'.

	aMenu add: 'update' action: #update.
	aMenu balloonTextForLastItem: 
'Update the display for this change set.  (This is done automatically when you activate this window, so is seldom needed.)'.

	aMenu add: 'go to change set''s project' action: #goToChangeSetsProject.
	aMenu balloonTextForLastItem: 
'If this change set is currently associated with a Project, go to that project right now.'.

	aMenu add: 'promote to top of list' action: #promoteToTopChangeSet.
	aMenu balloonTextForLastItem:
'Make this change set appear first in change-set lists in all change sorters.'.

	aMenu add: 'trim history' action: #trimHistory.
	aMenu balloonTextForLastItem: 
'Drops rename, reorganize and method removals from classes that are newly added here.  NOTE: can cause confusion if later filed in over older versions of these changes'.

	aMenu add: 'clear this change set' action: #clearChangeSet.
	aMenu balloonTextForLastItem: 
'Reset this change set to a pristine state where it holds no information. CAUTION: this is destructive and irreversible!!'.

	aMenu add: 'uninstall this change set' action: #uninstallChangeSet.
	aMenu balloonTextForLastItem: 
'Attempt to uninstall this change set. CAUTION: this may not work completely and is irreversible!!'.

	aMenu addLine.
	aMenu add: 'file into new...' action: #fileIntoNewChangeSet.
	aMenu balloonTextForLastItem: 
'Load a fileout from disk and place its changes into a new change set (seldom needed -- much better to do this from a file-list browser these days.)'.

	aMenu addLine.
	aMenu add: 'more...' action: #unshiftedYellowButtonActivity.
	aMenu balloonTextForLastItem: 
'Takes you back to the primary change-set menu.'.

	^ aMenu! !

!ChangeSorter methodsFor: 'changeSet menu' stamp: 'di 5/12/2000 15:03'!
trimHistory
	"Drop non-essential history (rename, reorg, method removals) from newly-added classes."

	myChangeSet trimHistory

! !


!ClassChangeRecord methodsFor: 'all changes' stamp: 'di 5/12/2000 14:53'!
trimHistory
	"Drop non-essential history (rename, reorg, method removals) from newly-added classes."

	changeTypes removeAllFoundIn: #(rename reorganize).
	methodChanges keysAndValuesRemove:
		[:sel :chgRecord | #(remove addedThenRemoved) includes: chgRecord changeType]
		! !

