'From Squeak2.8alpha of 4 February 2000 [latest update: #2158] on 20 May 2000 at 12:26:39 pm'!
"Change Set:		067CelesteTimeZones-dvf
Date:			18 May 2000
Author:			Daniel Vainsencher

sma kindly pointed out that Celeste currently ignores timezone, causing much temporal confusion. Adds a user setting to amend that."!

Model subclass: #Celeste
	instanceVariableNames: 'mailDB currentCategory currentMessages currentTOC currentMsgID lastCategory subjectFilter fromFilter dateFilter customFilterBlock formatMessages lastCategoryList lastCategoryMenu messageTextView userPassword status '
	classVariableNames: 'CCList CustomFilters DeleteInboxAfterFetching FormatWhenFetching PopServer PopUserName SmtpServer SuppressWorthlessHeaderFields TimeZone UserName '
	poolDictionaries: ''
	category: 'Network-Mail Reader'!

!Celeste methodsFor: 'sending mail' stamp: 'dvf 5/17/2000 20:48'!
queueMessageWithText: aStringOrText 
	"Queue a message to be sent later. The message is added to the database 
	and filed in the '.tosend.' category."
	| messageText id |
	messageText _ 'X-Mailer: ' , Celeste versionString , String cr , 'Date: ' , MailMessage dateStampNow, ' ' , self timeZoneString, ' ', String cr.
	messageText _ messageText , aStringOrText asString.
	self requiredCategory: '.tosend.'.
	"queue the message"
	id _ mailDB addNewMessage: (MailMessage from: messageText).
	mailDB file: id inCategory: '.tosend.'.
	self category = '.tosend.' ifTrue: [self updateTOC]! !

!Celeste methodsFor: 'sending mail' stamp: 'dvf 5/17/2000 20:48'!
timeZoneString
	^Celeste userTimeZone! !


!Celeste class methodsFor: 'user preferences' stamp: 'dvf 5/18/2000 00:08'!
setTimeZone
	TimeZone _ FillInTheBlank request: 'What is your time zone ?' initialAnswer: '+0300'! !

!Celeste class methodsFor: 'user preferences' stamp: 'sma 5/20/2000 10:18'!
userTimeZone
	"Answer the user's timezone string to be used when sending messages."

	TimeZone isEmptyOrNil ifTrue: [self setTimeZone].
	^ TimeZone ifNil: ['']! !

