'From Squeak2.8alpha of 12 January 2000 [latest update: #2240] on 5 June 2000 at 10:17:35 am'!
"Change Set:		ButtonTweaks
Date:			5 June 2000
Author:			Dan Ingalls

Streamlines creation of SimpleButtons and Switches so that labels do not get created two or three times during initialization.
"!


!SimpleButtonMorph methodsFor: 'initialization' stamp: 'di 6/5/2000 09:08'!
initialize

	self initializeAllButLabel; setDefaultLabel! !

!SimpleButtonMorph methodsFor: 'initialization' stamp: 'di 6/5/2000 09:07'!
initializeAllButLabel

	super initialize.
	self borderWidth: 1.
	self cornerStyle: #rounded.
	self color: (Color r: 0.4 g: 0.8 b: 0.6).
	self borderColor: self color darker.
	target _ nil.
	actionSelector _ #flash.
	arguments _ EmptyArray.
	actWhen _ #buttonUp
! !

!SimpleButtonMorph methodsFor: 'initialization' stamp: 'di 6/5/2000 09:09'!
initializeWithLabel: labelString

	self initializeAllButLabel; label: labelString
! !

!SimpleButtonMorph methodsFor: 'initialization' stamp: 'sw 9/28/1999 14:05'!
setDefaultLabel
	self label: 'Flash'.
! !


!SimpleButtonMorph class methodsFor: 'as yet unclassified' stamp: 'di 6/5/2000 08:42'!
newWithLabel: labelString

	^ self basicNew initializeWithLabel: labelString
! !


!SimpleSwitchMorph methodsFor: 'as yet unclassified' stamp: 'di 6/5/2000 08:44'!
initialize

	^ self initializeWithLabel: 'Toggle'
! !

!SimpleSwitchMorph methodsFor: 'as yet unclassified' stamp: 'di 6/5/2000 08:43'!
initializeWithLabel: labelString

	super initializeWithLabel: labelString.
	self borderWidth: 3.
	self extent: self extent + 2.
	onColor _ Color r: 1.0 g: 0.6 b: 0.6.
	offColor _ Color lightGray.
! !

