'From Squeak2.8alpha of 12 January 2000 [latest update: #2240] on 5 June 2000 at 10:38:47 am'!
"Change Set:		CalendarTweaks
Date:			5 June 2000
Author:			Dan Ingalls

Speeds month scrolling by not creating three labels during every initialization of a day morph.
Adds scroll by year and jump to any year.
"!


!MonthMorph methodsFor: 'all' stamp: 'di 6/5/2000 09:31'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu 
		addLine;
		addUpdating: #startMondayOrSundayString action: #toggleStartMonday;
		add: 'jump to year...' action: #chooseYear.! !

!MonthMorph methodsFor: 'all' stamp: 'di 6/5/2000 10:21'!
chooseYear

	| newYear yearString |
	newYear _ (SelectionMenu selections: {'today'} , (month year - 5 to: month year + 5) , {'other...'}) startUpWithCaption: 'Choose another year'.
	newYear ifNil: [^ self].
	newYear isNumber ifTrue:
		[^ self month: (Month newDay: 1 month: month monthName year: newYear)].
	newYear = 'today' ifTrue:
		[^ self month: (Month fromDate: Date today)].
	yearString _ FillInTheBlank request: 'Type in a year' initialAnswer: Date today year asString.
	yearString ifNil: [^ self].
	newYear _ yearString asNumber.
	(newYear between: 0 and: 9999) ifTrue:
		[^ self month: (Month newDay: 1 month: month monthName year: newYear)].
! !

!MonthMorph methodsFor: 'all' stamp: 'di 6/5/2000 10:30'!
initializeHeader
	| title sep  frame button |
	title _ (self findA: WeekMorph) title.
	sep _ Morph new color: Color transparent; extent: title width @ 1.
	self
		addMorph: sep;
		addMorph: title;
		addMorph: sep copy.
	button _ SimpleButtonMorph new
				target: self;
				actWhen: #whilePressed;
				color: (Color r: 0.8 g: 0.8 b: 0.8).
	frame _ AlignmentMorph new
		color: Color transparent;
		orientation: #horizontal;
		inset: 0.
	frame
		addMorph:
			(button
				label: '>>';
				actionSelector: #nextYear;
				width: 15);
		addMorph:
			(button copy
				label: '>';
				actionSelector: #next;
				width: 15);
		addMorph:
			((AlignmentMorph new
				color: Color transparent;
				orientation: #vertical;
				centering: #center;
				extent: (title fullBounds width - (button width * 3)) @ title height)
				addMorph:
					(StringMorph new
						contents:
							month name, ' ', month year printString));
		addMorph:
			(button copy
				label: '<';
				actionSelector: #previous;
				width: 15);
		addMorph:
			(button copy
				label: '<<';
				actionSelector: #previousYear;
				width: 15).
	self addMorph: frame
! !

!MonthMorph methodsFor: 'all' stamp: 'di 6/5/2000 08:29'!
initializeWeeks
	| weeks |
	self removeAllMorphs.
	weeks _ OrderedCollection new.
	month eachWeekDo: [:each | weeks add: (WeekMorph newWeek: each month: month)].
	weeks reverseDo: [:each | self addMorph: each].
	self initializeHeader
! !

!MonthMorph methodsFor: 'all' stamp: 'di 6/5/2000 10:29'!
nextYear
	self month: (Month newDay: 1 month: month monthName year: month year + 1)
! !

!MonthMorph methodsFor: 'all' stamp: 'di 6/5/2000 10:29'!
previousYear
	self month: (Month newDay: 1 month: month monthName year: month year - 1)
! !


!WeekMorph methodsFor: 'all' stamp: 'di 6/5/2000 08:46'!
initializeDays
	| extent days |
	self removeAllMorphs.
	days _ OrderedCollection new: 7.
	extent _ self tile extent.
	week do:
		[:each |
		days add:
			(each month = month
				ifTrue:
					[(self tileLabeled: each dayOfMonth printString)
						extent: extent;
						setBalloonText: each printString]
				ifFalse:
					[Morph new
						color: Color transparent;
						extent: extent])].
	days reverseDo: [:each | self addMorph: each]! !

!WeekMorph methodsFor: 'all' stamp: 'di 6/5/2000 08:27'!
initializeForWeek: aWeek month: aMonth

	super initialize.
	self inset: 0;
		color: Color transparent;
		orientation: #horizontal;
		disableDragNDrop;
		height: 19.
	self week: aWeek month: aMonth
! !

!WeekMorph methodsFor: 'all' stamp: 'di 6/5/2000 08:45'!
tileLabeled: labelString
	| onColor offColor |
	offColor _ Color r: 0.4 g: 0.8 b: 0.6.
	onColor _ offColor mixed: 1/2 with: Color white.
	^ (SimpleSwitchMorph newWithLabel: labelString)
		offColor: offColor;
		onColor: onColor;
		borderWidth: 1;
		useSquareCorners;
		extent: 23 @ 19! !

!WeekMorph methodsFor: 'all' stamp: 'di 6/5/2000 08:49'!
title
	"Answer a title with the names of the days."
	| title extent days |
	title _ AlignmentMorph new
		inset: 0;
		color: Color red;
		orientation: #horizontal;
		vResizing: #shrinkWarp;
		height: 19.
		extent _ self tile extent.
	days _ Week startMonday
		ifTrue: [7 to: 1 by: -1]       "Original code, Mon-Sun."
		ifFalse: [#(6 5 4 3 2 1 7)].   "Sun-Sat."
	(days collect: [:each | Date nameOfDay: each]) do:
		[:each |
		title addMorph:
			((self tileLabeled: (each copyFrom: 1 to: 2))
				extent: extent;
				setBalloonText: each printString)].
	^ title
	! !


!WeekMorph class methodsFor: 'instance creation' stamp: 'di 6/5/2000 08:29'!
newWeek: aWeek month: aMonth

	^ self basicNew initializeForWeek: aWeek month: aMonth
! !

