'From Squeak2.8alpha of 13 January 2000 [latest update: #2239] on 2 June 2000 at 10:34:45 pm'!
"Change Set:		miscTweaks-sw
Date:			2 June 2000
Author:			Scott Wallace

1.  Now that the package browser can show annotation panes and optional buttons, make sure the copies in the Tools Flap and the parts bin are made right and that the tools flap copy gets replaced when the user's preference changes regarding use of those extra panes

2.  Factor out the grep functionality so that it can be called via various UIs."!


!FileDirectory methodsFor: 'searching' stamp: 'sw 6/2/2000 21:55'!
filesContaining: searchString caseSensitive: aBoolean
	| aList |
	"Search the contents of all files in the receiver and its subdirectories for the search string.  Return a list of paths found.  Make the search case sensitive if aBoolean is true."

	aList _ OrderedCollection new.
	self withAllFilesDo: [:stream |
			(stream contentsOfEntireFile includesSubstring: searchString caseSensitive: aBoolean)
				ifTrue:	[aList add: stream name]]
		andDirectoriesDo: [:d | d pathName].
	^ aList

"FileDirectory default filesContaining: 'includesSubstring:'  caseSensitive: true"! !


!FileDirectory class methodsFor: 'name utilities' stamp: 'sw 6/2/2000 21:56'!
searchAllFilesForAString

	"Prompt the user for a search string, and a starting directory. Search the contents of all files in the starting directory and its subdirectories for the search string (case-insensitive search.)
	List the paths of files in which it is found on the Transcript.
	By Stewart MacLean 5/00; subsequently moved to FileDirectory class-side, and refactored to call FileDirectory.filesContaining:caseSensitive:"

	| searchString dir |

	searchString _ FillInTheBlankMorph request: 'Enter search string'.
	searchString isEmpty ifTrue: [^nil].
	Transcript cr; show: 'Searching for ', searchString printString, ' ...'.
	(dir _ PluggableFileList getFolderDialog open) ifNotNil:
		[(dir filesContaining: searchString caseSensitive: false) do:
				[:pathname | Transcript cr; show: pathname]].
	Transcript cr; show: 'Finished searching for ', searchString printString

	"FileDirectory searchAllFilesForAString"! !


!Utilities class methodsFor: 'flaps' stamp: 'sw 6/2/2000 21:45'!
replaceBrowserInToolsFlap
	self replacePartSatisfying: [:el |  (el isKindOf: MorphThumbnail) and: [(el morphRepresented isKindOf: SystemWindow) and: [el morphRepresented model isMemberOf: Browser]]]
inGlobalFlapSatisfying: [:f1 | f1 wording = 'Tools'] with:  ((Browser new openAsMorphEditing: nil) applyModelExtent setLabel: 'System Browser').

	self replacePartSatisfying: [:el |  (el isKindOf: MorphThumbnail) and: [(el morphRepresented isKindOf: SystemWindow) and: [el morphRepresented model isMemberOf: PackageBrowser]]]
inGlobalFlapSatisfying: [:f1 | f1 wording = 'Tools'] with:  ((PackageBrowser new openAsMorphEditing: nil) applyModelExtent setLabel: 'Package Browser')

! !

FileDirectory removeSelector: #searchAllFilesForAString!
"Postscript:"
Utilities replaceBrowserInToolsFlap.
ScriptingSystem resetStandardPartsBin.
!

