'From Squeak2.8alpha of 12 January 2000 [latest update: #2246] on 7 June 2000 at 5:41:18 pm'!
"Change Set:		BigTextFixes
Date:			7 June 2000
Author:			Dan Ingalls

Changes NewParagraph>>selectionRectsFrom:to: to return a single rectangle for all lines between the first and last when the container is a simple rectangle.  This changes the time to display a full selection in a megabyte file from over 10 seconds to about 1/4 second.

Changes CharacterBlock copy to do a simple shallowCopy.  It had been inheriting deepCopy from Rectangle, thus making an unneeded copy of the entire text as well.  Greatly improves typing into a megabyte file.
"!


!CharacterBlock methodsFor: 'accessing' stamp: 'di 6/7/2000 17:33'!
copy
	"Overridden because Rectangle does a deepCopy, which goes nuts with the text"

	^ self clone! !


!NewParagraph methodsFor: 'selection' stamp: 'di 6/7/2000 16:52'!
selectionRectsFrom: characterBlock1 to: characterBlock2 
	"Return an array of rectangles representing the area between the two character blocks given as arguments."
	| line1 line2 rects cb1 cb2 w |
	characterBlock1 <= characterBlock2
		ifTrue: [cb1 _ characterBlock1.  cb2 _ characterBlock2]
		ifFalse: [cb2 _ characterBlock1.  cb1 _ characterBlock2].
	cb1 = cb2 ifTrue:
		[w _ self caretWidth.
		^ Array with: (cb1 topLeft - (w@0) corner: cb1 bottomLeft + ((w+1)@0))].
	line1 _ self lineIndexForCharacter: cb1 stringIndex.
	line2 _ self lineIndexForCharacter: cb2 stringIndex.
	line1 = line2 ifTrue:
		[^ Array with: (cb1 topLeft corner: cb2 bottomRight)].
	rects _ OrderedCollection new.
	rects addLast: (cb1 topLeft corner: (lines at: line1) bottomRight).
	(container isMemberOf: Rectangle)
		ifTrue: [(line1+1) <= (line2-1) ifTrue:
					[rects addLast: ((lines at: line1+1) topLeft
								corner: (lines at: line2-1) bottomRight)]]
		ifFalse: [(line1+1) to: (line2-1) do:
					[:i | rects addLast: (lines at: i) rectangle]].
	rects addLast: ((lines at: line2) topLeft corner: cb2 bottomLeft).
	^ rects! !

