'From Squeak2.9alpha of 16 June 2000 [latest update: #2447] on 18 July 2000 at 3:32:27 pm'!
"Change Set:		WldMenuCompat-tk
Date:			18 July 2000
Author:			Ted Kaehler

Informs the user in a gentle way if they use a World menu that dates from before update 2401 (Jul 2000).  Old menus can be open in a project that is loaded.  Old menus send many messages to the HandMorph that are now sent to a TheWorldMenu object."!


!MenuMorph methodsFor: 'control' stamp: 'tk 7/18/2000 15:25'!
invokeItem: aMenuItem event: evt
	"Perform the action associated with the given menu item."

	| sel target args selArgCount |
	aMenuItem isEnabled ifFalse: [^ self].
	self notObsolete ifFalse: [^ self].
	lastSelection _ aMenuItem.
	"to do: report lastSelection"
	sel _ aMenuItem selector.
	target _ aMenuItem target.
	args _ aMenuItem arguments.
	selArgCount _ sel numArgs.
	Cursor normal showWhile: [  "show cursor in case item opens a new MVC window"
		selArgCount = 0
			ifTrue: [target perform: sel]
			ifFalse: [
				selArgCount = args size
					ifTrue: [target perform: sel withArguments: args]
					ifFalse: [target perform: sel withArguments: (args copyWith: evt)]]].
! !

!MenuMorph methodsFor: 'control' stamp: 'tk 7/18/2000 15:28'!
notObsolete
	"Provide backward compatibility with messages being sent to the Hand.  Remove this when no projects made prior to 2.9 are likely to be used.  If this method is removed early, the worst that can happen is a notifier for an obsolete menu."

	submorphs size = 28 ifFalse: [^ true].		"not an obsolete world menu"
	submorphs fourth class == MenuItemMorph ifFalse: [^ true].
	submorphs fourth contents = 'previous project' ifFalse: [^ true].
	(submorphs at: 11) class == MenuItemMorph ifFalse: [^ true].
	(submorphs at: 11) contents = 'open...' ifFalse: [^ true].
	(submorphs at: 11) target class == HandMorph ifFalse: [^ true]. 	"a modern one"

	self inform: 'This world menu is obsolete.
Please dismiss the menu and open a new one.'.
	^ false
! !

