'From Squeak2.9alpha of 12 June 2000 [latest update: #2449] on 14 July 2000 at 1:13:19 pm'!
"Change Set:		EnvelopeEdChgs
Date:			14 July 2000
Author:			Dan Ingalls

Removes the duration control which was no longer used.  Puts in its place the name of the currently viewed sound.  Clicking on the this name allows one to choose another sound to view.
"!


!EnvelopeEditorMorph methodsFor: 'initialization' stamp: 'di 7/14/2000 12:48'!
initialize
	super initialize.
	prevMouseDown _ false.
	showAllEnvelopes _ true.
	soundName ifNil: [soundName _ 'test'].
	self editSound: (sound ifNil: [FMSound brass1 copy]).
	sound duration: 0.25.
	denominator _ 7.
	self extent: 10@10.  "ie the minimum"
! !

!EnvelopeEditorMorph methodsFor: 'initialization' stamp: 'di 7/14/2000 11:13'!
wantsRoundedCorners
	^ Preferences roundedWindowCorners or: [super wantsRoundedCorners]! !

!EnvelopeEditorMorph methodsFor: 'construction' stamp: 'di 7/14/2000 13:08'!
addControls
	| chooser |
	chooser _ PopUpChoiceMorph new extent: 110@14;
		contentsClipped: 'Editing: ' , envelope name;
		target: self;
		actionSelector: #chooseFrom:envelopeItem:;
		getItemsSelector: #curveChoices.
	chooser arguments: (Array with: chooser).
	self addMorph: chooser.
	chooser align: chooser bounds topLeft with: graphArea bounds bottomLeft + (0@5).

	chooser _ PopUpChoiceMorph new extent: 130@14;
		contentsClipped: 'Timbre: ' , soundName;
		target: self;
		actionSelector: #chooseFrom:soundItem:;
		getItemsSelector: #soundChoices.
	chooser arguments: (Array with: chooser).
	self addMorph: chooser.
	chooser align: chooser bounds topRight with: graphArea bounds bottomRight + (-50@5).
! !

!EnvelopeEditorMorph methodsFor: 'construction' stamp: 'di 7/14/2000 12:56'!
soundChoices
	^ #('new...') , AbstractSound soundNames! !

!EnvelopeEditorMorph methodsFor: 'menu' stamp: 'di 7/14/2000 13:03'!
chooseFrom: chooserMorph soundItem: item
	self editSoundNamed: item.
! !

!EnvelopeEditorMorph methodsFor: 'menu' stamp: 'di 7/14/2000 12:42'!
chooseSound: evt
	| menu |
	menu _ MenuMorph new.
	menu add: 'new...' target: self selector: #editNewSound.
	menu addLine.
	AbstractSound soundNames do:
		[:name |
		menu add: name
			target: self selector: #editSoundNamed:
			argument: name].
	menu popUpEvent: evt in: self world! !

!EnvelopeEditorMorph methodsFor: 'menu' stamp: 'di 7/14/2000 12:44'!
editSoundNamed: name

	name = 'new...' ifTrue: [^ self editNewSound].
	soundName _ name.
	self editSound: (AbstractSound soundNamed: soundName) copy! !

EnvelopeEditorMorph removeSelector: #chooseFrom:durationItem:!
EnvelopeEditorMorph removeSelector: #durationChoices!
EnvelopeEditorMorph removeSelector: #durationName!
EnvelopeEditorMorph removeSelector: #playChoices!
