'From Squeak2.9alpha of 26 July 2000 [latest update: #2574] on 8 September 2000 at 8:53:58 pm'!
"Change Set:		steplistTools-sw
Date:			8 September 2000
Author:			Scott Wallace

Some tools for tracking down and repairing problems with steplists."!


!PasteUpMorph methodsFor: 'project state' stamp: 'sw 9/5/2000 06:45'!
listOfSteppingMorphs
	^ worldState listOfSteppingMorphs

"self currentWorld listOfSteppingMorphs"! !

!PasteUpMorph methodsFor: 'project state' stamp: 'sw 9/5/2000 09:56'!
stepListSize
	^ worldState stepListSize

"Transcript cr; show: self currentWorld stepListSize printString, ' items on steplist as of ', Date dateAndTimeNow printString"! !

!PasteUpMorph methodsFor: 'project state' stamp: 'sw 9/5/2000 09:56'!
stepListSummary
	^ worldState stepListSummary

"Transcript cr show: self currentWorld stepListSummary"! !

!PasteUpMorph methodsFor: 'project state' stamp: 'sw 9/5/2000 09:59'!
steppingMorphsNotInWorld
	| all |
	all _ self allMorphs.
	^ self listOfSteppingMorphs select: [:m | (all includes: m) not]

	"self currentWorld steppingMorphsNotInWorld do: [:m | m delete]"! !


!Utilities class methodsFor: 'miscellaneous' stamp: 'sw 9/6/2000 09:06'!
cleanseOtherworldlySteppers
	"If the current project is a morphic one, then remove from its steplist those morphs that are not really in the world"

	| old delta |
	Smalltalk isMorphic ifTrue:
		[old _ self currentWorld stepListSize.
		self currentWorld steppingMorphsNotInWorld do: [:m | m delete].
		self currentWorld cleanseStepList.
		(delta _ (old - self currentWorld stepListSize)) > 0 ifTrue:
			[Transcript cr; show: (delta asString, ' morphs removed from steplist')]]

	"Utilities cleanseOtherworldlySteppers"! !

!Utilities class methodsFor: 'miscellaneous' stamp: 'sw 9/8/2000 10:02'!
steplistToolsWorkspace
	^ ((StringHolder new contents:  'self currentWorld listOfSteppingMorphs asArray inspectWithLabel: ''stepping morphs''.
Utilities cleanseOtherworldlySteppers.
self currentWorld steppingMorphsNotInWorld do: [:m | m delete].
self currentWorld stepListSummary.
self currentWorld stepListSize.
self currentHand attachMorph: FrameRateMorph new') embeddedInMorphicWindowLabeled: 'Steplist workspace')

setWindowColor: (Color r: 0.9 g: 0.7 b: 0.5);
			openInWorld: self currentWorld extent: (550 @ 140)

"Utilities steplistToolsWorkspace"! !


!WorldState methodsFor: 'initialization' stamp: 'sw 9/5/2000 06:39'!
stepListSize
	^ stepList size! !

!WorldState methodsFor: 'initialization' stamp: 'sw 9/5/2000 06:34'!
stepListSummary
	^ String streamContents:
		[:aStream |
			aStream nextPutAll: stepList size printString, ' items in steplist:'.
			stepList do:
				[:anElement | aStream nextPutAll: anElement first printString]]

"Transcript cr show: self currentWorld stepListSummary"! !

!WorldState methodsFor: 'stepping' stamp: 'sw 9/5/2000 06:44'!
listOfSteppingMorphs
	^ stepList collect: [:el | el first]! !

