'From Squeak2.9alpha of 12 June 2000 [latest update: #2551] on 4 September 2000 at 2:12:34 pm'!
"Change Set:		PolygonFlex
Date:			4 September 2000
Author:			Dan Ingalls

Supports rotation of Polygon vertices without loss of resolution, instead of the old bitmap flex.
"!


!PolygonMorph methodsFor: 'halo control' stamp: 'di 9/4/2000 13:29'!
addFlexShell

	self assuredFlex.
! !

!PolygonMorph methodsFor: 'halo control' stamp: 'di 9/4/2000 13:22'!
assuredFlex

	| flex unflexedVertices |
	((flex _ self valueOfProperty: #flex) == nil or:
			["Check if cached flex is still current"
			unflexedVertices _ self valueOfProperty: #unflexedVertices.
			unflexedVertices size ~= vertices size or:
				[(vertices
					with: (unflexedVertices collect: [:v | (flex transform: v) - flex offset])
					collect: [:a :b | (a dist: b) > 0.1])
						anySatisfy: [:x | x]]])
		ifTrue:
			["Need to start a new flex base"
			flex _ MorphicTransform offset: bounds center negated.
			self setProperty: #flex toValue: flex.
			self setProperty: #unflexedVertices toValue: vertices copy].
	^ flex! !

!PolygonMorph methodsFor: 'halo control' stamp: 'di 9/4/2000 12:11'!
rotationDegrees

	^ self assuredFlex angle radiansToDegrees! !

!PolygonMorph methodsFor: 'halo control' stamp: 'di 9/4/2000 14:12'!
rotationDegrees: degrees

	| unflexedVertices flex |
	flex _ self assuredFlex withAngle: degrees degreesToRadians.
	unflexedVertices _ self valueOfProperty: #unflexedVertices.
	self setVertices: (unflexedVertices collect: [:v | (flex transform: v) - flex offset]).
	self setProperty: #flex toValue: flex.
	self setProperty: #unflexedVertices toValue: unflexedVertices.  "may have been purged"
! !

!PolygonMorph methodsFor: 'private' stamp: 'di 9/4/2000 13:36'!
releaseCachedState
	super releaseCachedState.
	filledForm _ nil.
	arrowForms _ nil.
	borderForm _ nil.
	curveState _ nil.
	(self hasProperty: #flex) ifTrue:
		[self removeProperty: #unflexedVertices;
			removeProperty: #flex].
! !



