'From Squeak2.9alpha of 12 June 2000 [latest update: #2606] on 12 September 2000 at 9:52:27 am'!
"Change Set:		TransformFix
Date:			12 September 2000
Author:			Andreas Raab

Fixes a bug in the handling of #transformFrom:. If #transformFrom: is supposed to return the transform from a morph above the receiver into the coordinate system of the receiver, then the morph above should better be involved in the action."!


!Morph methodsFor: 'event handling' stamp: 'ar 9/12/2000 00:27'!
transformFrom: uberMorph
	"Return a transform to be used to map coordinates in a morph above me into my local coordinates, or vice-versa. This is used to support scrolling, scaling, and/or rotation. This default implementation just returns my owner's transform or the identity transform if my owner is nil."
	(self == uberMorph or:[owner == nil]) ifTrue:[^IdentityTransform new].
	^ owner transformFrom: uberMorph
! !


!MatrixTransformMorph methodsFor: 'events' stamp: 'ar 9/12/2000 01:22'!
transformFrom: uberMorph
	(owner isNil or:[self == uberMorph]) ifTrue:[^self transform].
	^(owner transformFrom: uberMorph) asMatrixTransform2x3 composedWithLocal: self transform! !


!TransformMorph methodsFor: 'events' stamp: 'ar 9/12/2000 00:28'!
transformFrom: uberMorph
	"Return a transform to map coorinates of uberMorph, a morph above me in my owner chain, into the coordinates of my submorphs."

	(self == uberMorph or:[owner == nil]) ifTrue: [^ transform].
	^ (owner transformFrom: uberMorph) composedWithLocal: transform! !

