'From Squeak2.9alpha of 5 August 2000 [latest update: #2676] on 21 September 2000 at 10:34:08 pm'!
"Change Set:		noMetaMenuForEtoy-sw
Date:			21 September 2000
Author:			Scott Wallace

Makes the 'meta-menu' not accessible when the eToyFriendly preference is set to true.  The desktop menu remains accessible to those who know enough to hit cmd-shift-W while the mouse is over a bare piece of desktop.

This all as per explicit request from Kim and BJ."!


!HandMorph methodsFor: 'event handling' stamp: 'sw 9/21/2000 20:12'!
unfocusedKeystroke: evt
	"A keystroke has come through when no object claimed the keyboard focus.  See if there's something we can do with it"

	|  aChar isCmd aWorld aMenu |
	aChar _ evt keyCharacter.
	(aChar == Character tab) ifTrue:
		[((aWorld _ self world) hasProperty: #tabAmongFields)
			ifTrue:
				[^ aWorld tabHitWithEvent: evt]].
	isCmd _ evt commandKeyPressed and: [Preferences cmdKeysInText].
	(isCmd and: [Preferences eToyFriendly]) ifTrue:
		[(aChar == $W) ifTrue:
			["put put screen menu -- Explicit request from Kim Rose"
			aMenu _ self buildWorldMenu.
			aMenu addTitle: Preferences desktopMenuTitle.
			^ aMenu popUpEvent: evt]].  

	isCmd ifTrue:
		[(aChar == $b) ifTrue: [^ Browser openBrowser].          "for example"
		(aChar == $z) ifTrue: [^ self commandHistory undoOrRedoCommand]]! !

!HandMorph methodsFor: 'world menu commands' stamp: 'sw 9/21/2000 20:27'!
invokeMetaMenu: evt
	"Invoke the meta menu. If the hand is over the background, the world menu is presented. If it is over a morph, a menu of operations for that morph is presented. Each menu entry contains a string to be presented in the menu and a selector. If the selector takes an argument, the mouse-down event that invoked the menu is passed as an argument. This lets the command know which hand invoked it in order to do things like attaching the result of the command to that hand.

If the hand is over the background and the shift key is pressed, the find-window menu is immediately put up.

If the hand is over the background but the yellow button was pressed, an alternate menu, which individual users are encouraged to personalize, is put up -- see HandMorph.yellowButtonClickOnDesktopWithEvent:"

	| menu |

	"if carrying morphs, just drop them"
	self hasSubmorphs ifTrue: [^ self dropMorphsEvent: evt].

	(Preferences metaMenuDisabled or: [Preferences eToyFriendly]) ifTrue: [^ self].

	self flag: #bob.		"do we need this?"
	targetOffset _ menuTargetOffset _ self worldUnderCursor globalPointToLocal: self position.
	argument _ self argumentOrNil.
	argument == nil
		ifTrue:
			[Utilities bringFlapsToFront.
			evt yellowButtonPressed
				ifTrue: [^ self yellowButtonClickOnDesktopWithEvent: evt].

			evt shiftPressed
				ifFalse:
					["put put screen menu"
					menu _ self buildWorldMenu.
					menu addTitle: Preferences desktopMenuTitle]
				ifTrue:
					[^ self findWindow]]
		ifFalse:
			[menu _ self buildMorphMenuFor: argument.
			menu addTitle: argument class name].
	menu popUpEvent: evt.
! !


!StandardScriptingSystem methodsFor: 'utilities' stamp: 'sw 9/21/2000 20:29'!
customizeForEToyUsers: aBoolean
	"If aBoolean is true, set things up for etoy users.  If it's false, unset some of those things.  Some things are set when switching into etoy mode but not reversed when switching out of etoy mode"
 
	#(	
		(balloonHelpEnabled			yes		dontReverse)
		(debugHaloHandle			no		reverse)
		(modalColorPickers			yes		dontReverse)
		(uniqueNamesInHalos		yes		reverse)
		(useUndo					yes		dontReverse)
		(infiniteUndo				no		dontReverse)
		(warnIfNoChangesFile		no		reverse)
		(warnIfNoSourcesFile		no		reverse)) do:
			[:trip |
				(aBoolean or: [trip third == #reverse]) ifTrue:
					[Preferences enableOrDisable: trip first asPer:
						((trip second == #yes) & aBoolean) | ((trip second == #no) & aBoolean not)]]! !

