'From Squeak2.9BJ of 22 September 2000 [latest update: #2718] on 26 September 2000 at 2:13:40 pm'!
"Change Set:		CostumeFix-ar
Date:			26 September 2000
Author:			Andreas Raab

Fixes a problem with copying state between morphs. Some state which is associated with morphs should be associated with the player but isn't so a careful copy of these properties is required."!


!Morph methodsFor: 'e-toy support' stamp: 'ar 9/26/2000 14:12'!
asWearableCostume
	"Return a wearable costume for some player"
	^(SketchMorph withForm: self imageForm) copyCostumeStateFrom: self! !


!Player methodsFor: 'costume' stamp: 'ar 9/26/2000 14:11'!
renderedCostume: aMorph
	"Make aMorph be the receiver's rendered costume; if flexing is currently in effect, make the new morph be flexed correspondingly"

	| renderedMorph known anEventHandler w |
	renderedMorph _ costume renderedMorph.
	renderedMorph == aMorph ifTrue: [^ self].
	self rememberCostume: renderedMorph.
	renderedMorph changed.
	w _ renderedMorph world.
	"Copy 'player state' (e.g., state which should be associated with the player but is stored in the morph itself these days) from the old rendered morph the new morph."
	aMorph rotationStyle: renderedMorph rotationStyle.
	aMorph forwardDirection: renderedMorph forwardDirection.
	"Note: referencePosition is *not* state but #moveTo: behavior"
	aMorph referencePosition: renderedMorph referencePosition.
	anEventHandler _ renderedMorph eventHandler.
	costume isFlexMorph
		ifTrue:
			[costume adjustAfter:
				[costume replaceSubmorph: renderedMorph by: aMorph]]
		ifFalse:
			[costume owner replaceSubmorph: costume by: aMorph.
			aMorph player: self.
			aMorph actorState: costume actorState.
			(known _ costume knownName) ifNotNil:
				[aMorph setNameTo: known].
			costume _ aMorph.
			w ifNotNil:[
				w stopStepping: renderedMorph.
				w startStepping: aMorph]].
	aMorph eventHandler: anEventHandler.
	aMorph changed.! !


!SketchMorph methodsFor: 'e-toy support' stamp: 'ar 9/26/2000 14:12'!
asWearableCostume
	"Return a wearable costume for some player"
	^(SketchMorph withForm: originalForm) copyCostumeStateFrom: self! !

