'From Squeak2.9alpha of 17 July 2000 [latest update: #2739] on 27 September 2000 at 5:07:09 pm'!
"Change Set:		betterThumbGIF
Date:			27 September 2000
Author:			Bob Arning

- fix project publish failures when thumbnail has more than 256 colors"!


!Project methodsFor: 'file in/out' stamp: 'RAA 9/27/2000 17:06'!
storeOnServerInnards
	"Save to disk as an Export Segment.  Then put that file on the server I came from, as a new version.  Version is literal piece of file name.  Mime encoded and http encoded."

	| servers resp newName local primaryServerDirectory serverVersionPair localDirectory localVersionPair myVersionNumber warning maxNumber gifFileName gifStream f |

	"NebraskaDebug at: #savingproject add: {'beginning'}."
	"Find out what version"
	(servers _ self serverList) isEmpty ifTrue: [
		(primaryServerDirectory _ self findAFolderToStoreProjectIn) ifNotNil: [
			servers _ Array with: primaryServerDirectory.
			urlList _ Array with: primaryServerDirectory realUrl, '/'.
		].
	] ifFalse: [
		primaryServerDirectory _ servers first.
	].
	localDirectory _ self squeakletDirectory.
	serverVersionPair _ self class mostRecent: self name onServer: primaryServerDirectory.
	localVersionPair _ self class mostRecent: self name onServer: localDirectory.
	maxNumber _ myVersionNumber _ self currentVersionNumber.
	ProgressNotification signal: '2:versionsDetected'.
	"NebraskaDebug at: #savingproject add: {'versions detected'}."

	warning _ ''.
	myVersionNumber < serverVersionPair second ifTrue: [
		warning _ warning,'\There are newer version(s) on the server'.
		maxNumber _ maxNumber max: serverVersionPair second.
	].
	myVersionNumber < localVersionPair second ifTrue: [
		warning _ warning,'\There are newer version(s) in the local directory'.
		maxNumber _ maxNumber max: localVersionPair second.
	].
	warning isEmpty ifFalse: [
		myVersionNumber = 0 ifTrue: [
			warning _ warning,'\THIS PROJECT HAS NEVER BEEN SAVED'
		].
		warning _ 'WARNING', '\Project: ',self name,warning.
		resp _ (PopUpMenu labels: 'Store anyway\Cancel' withCRs) startUpWithCaption: 
			(warning, '\Please cancel, rename this project, and see what is there.') withCRs.
			resp ~= 1 ifTrue: [^ nil]
	].
	version _ self bumpVersion: maxNumber.

	"write locally - now zipped automatically"
	newName _ self versionedFileName.
	self exportSegmentFileName: newName directory: localDirectory.		
	"NebraskaDebug at: #savingproject add: {'local save complete'}."
	ProgressNotification signal: '4:localSaveComplete'.	"3 is deep in export logic"

	primaryServerDirectory ifNotNil: [
		local _ localDirectory oldFileNamed: newName.
		resp _ primaryServerDirectory putFile: local named: newName retry: false.
		local close.
		resp == true ifFalse: [
			self inform: 'the primary server of this project seems to be down (',
								resp printString,')'. 
			^ self
		].

		gifFileName _ self name,'.gif'.
		gifStream _ primaryServerDirectory fileNamed: gifFileName.
		gifStream dataIsValid.
		thumbnail unhibernate.
		f _ thumbnail colorReduced.  "minimize depth"
		f depth > 8 ifTrue: [
			f _ thumbnail asFormOfDepth: 8
		].
		GIFReadWriter putForm: f onStream: gifStream.
		primaryServerDirectory sleep.	"if ftp, close the connection"
	].
	"NebraskaDebug at: #savingproject add: {'remote save complete'}."
	ProgressNotification signal: '9999 save complete'.

	"Later, store with same name on secondary servers.  Still can be race conditions.  All machines will go through the server list in the same order."
	"2 to: servers size do: [:aServer | aServer putFile: local named: newName]."
! !

