'From Squeak2.9alpha of 13 June 2000 [latest update: #2725] on 27 September 2000 at 2:12:36 pm'!
"Change Set:		PerfectCircles
Date:			27 September 2000
Author:			Andreas Raab

Fixes a problem when removing some flexing wrapper. The wrapper did not align the flexed object by its reference position leading to tiny offsets depending on width and height of the wrappee. Also improves #referencePosition: a bit to prevent the generation of float points when unnecessary."!


!Morph methodsFor: 'geometry eToy' stamp: 'ar 9/27/2000 14:04'!
referencePosition: aPosition
	"Move the receiver to match its reference position with aPosition"
	| newPos intPos |
	newPos _ self position + (aPosition - self referencePosition).
	intPos _ newPos asIntegerPoint.
	newPos = intPos 
		ifTrue:[self position: intPos]
		ifFalse:[self position: newPos].! !


!TransformationMorph methodsFor: 'menu' stamp: 'ar 9/27/2000 14:01'!
removeFlexShell
	"Remove the shell used to make a morph rotatable and scalable."

	| oldHalo unflexed pensDown player myWorld refPos |
	refPos _ self referencePosition.
	myWorld _ self world.
	oldHalo _ self halo.
	submorphs isEmpty ifTrue: [^ self delete].
	unflexed _ self firstSubmorph.
	pensDown _ OrderedCollection new.
	self allMorphsDo:  "Note any pens down -- must not be down during the move"
		[:m | ((player _ m player) notNil and: [player getPenDown]) ifTrue:
			[m == player costume ifTrue:
				[pensDown add: player.
				player setPenDown: false]]].
	self submorphs do: [:m |
		m position: self center - (m extent // 2).
		owner addMorph: m].
	unflexed absorbStateFromRenderer: self.
	pensDown do: [:p | p setPenDown: true].
	oldHalo ifNotNil: [oldHalo setTarget: unflexed].
	myWorld ifNotNil: [myWorld startSteppingSubmorphsOf: unflexed].
	self delete.
	unflexed referencePosition: refPos.
	^ unflexed! !

