'From Squeak 2.2beta of Sept 11, 1998 on 16 September 1998 at 10:41:53 am'!
"Change Set:		jhmHTTPTweaks
Date:			16 September 1998
Author:			John Maloney

Two tiny bug fixes:
  1. reset the stream in URL fetching
  2. don't keep making new Web browsers when following links in MVC (from Andreas)"
!


!HTTPSocket class methodsFor: 'examples' stamp: 'jm 9/16/1998 10:31'!
httpGet: url args: args accept: mimeType
	"Return the exact contents of a web object. Asks for the given MIME type. If mimeType is nil, use 'text/html'. The parsed header is saved. Use a proxy server if one has been registered.  tk 7/23/97 17:12"
	"Note: To fetch raw data, you can use the MIMI type 'application/octet-stream'."

	| document |
	document _ self httpGetDocument: url  args: args  accept: mimeType.
	(document isKindOf: String) ifTrue: [
		"strings indicate errors"
		^ document ].

	^ (RWBinaryOrTextStream with: document content) reset
! !


!TextURL methodsFor: 'as yet unclassified' stamp: 'jm 9/16/1998 10:36'!
actOnClickFor: anObject
	"Do what you can with this URL.  Later a web browser."

	| response m browser | 
		"if it's a web browser, tell it to jump"
		anObject isWebBrowser ifTrue: [
			anObject jumpToUrl: url.
			^true ].

		"if it's a morph, see if it is contained in a web browser"
		(anObject isKindOf: Morph) ifTrue: [
			m _ anObject.
			[ m ~= nil ] whileTrue: [
				(m isWebBrowser) ifTrue: [ 
					m  jumpToUrl: url.  
					^true ].
				(m hasProperty: #webBrowserView) ifTrue: [
					m model jumpToUrl: url.
					^true ].
				m _ m owner. ]
		].


	"no browser in sight.  ask if we should start a new browser"
	(self confirm: 'open a browser to view this URL?') ifTrue: [
		browser _ Scamper new.
		browser jumpToUrl: url.
		browser openAsMorph.
		^self ].
	
	"couldn't display in a browser.  Offer to put up just the source"	
	response _ (PopUpMenu labels: 'View web page as source\Cancel' withCRs)
		startUpWithCaption: 'Couldn''t find a web browser.  View page as source?'.
	response = 1 ifTrue: [HTTPSocket httpShowPage: url].
	^ true! !


