'From Squeak2.9alpha of 13 June 2000 [latest update: #2911] on 29 October 2000 at 9:15:07 pm'!
"Change Set:		ThreeFixes-ar
Date:			29 October 2000
Author:			Andreas Raab

Three fixes for Alan."!

!Morph methodsFor: 'meta-actions' stamp: 'ar 10/29/2000 21:04'!
buildHandleMenu: aHand
	"Build the morph menu for the given morph's halo's menu handle. This menu has two sections. The first section contains commands that are interpreted by the hand; the second contains commands provided by the target morph. This method allows the morph to decide which items should be included in the hand's section of the menu."

	| menu |
	menu _ MenuMorph new defaultTarget: self.
	menu addStayUpItem.
	self addAddHandMenuItemsForHalo: menu hand: aHand.
	menu defaultTarget: self.
	self addCustomHaloMenuItems: menu hand: aHand.
	menu addLine.
	self player ifNotNil: [self player addPlayerMenuItemsTo: menu hand: aHand].
	menu defaultTarget: aHand.
	^ menu
! !


!SketchEditorMorph methodsFor: 'morphic' stamp: 'ar 10/29/2000 21:13'!
mouseDown: evt
	"Start a new stroke.  Check if any palette setting have changed.  6/11/97 20:30 tk"
	| cur pfPen myAction |
	"verify that we are in a good state"
	self verifyState: evt.		"includes prepareToPaint and #scalingOrRotate"
	pfPen _ self get: #paintingFormPen for: evt.
	undoBuffer _ paintingForm deepCopy.	"know we will draw something"
	pfPen place: (evt cursorPoint - bounds origin).
	myAction _ self getActionFor: evt.
	myAction == #paint: ifTrue:[
		palette recentColor: (self getColorFor: evt)].
	self set: #strokeOrigin for: evt to: evt cursorPoint.
		"origin point for pickup: rect: ellispe: polygon: line: star:.  Always take it."
	myAction == #pickup: ifTrue: [
		cur _ Cursor corner clone.
		cur offset: 0@0  "cur offset abs".
		evt hand showTemporaryCursor: cur].
	myAction == #polygon: ifTrue: [self polyNew: evt].	"a mode lets you drag vertices"
	self mouseMove: evt.! !

TextPlusPasteUpMorph removeSelector: #handlesMouseDown:!
TextPlusPasteUpMorph removeSelector: #mouseDown:!
