'From Squeak2.9alpha of 13 June 2000 [latest update: #2915] on 11 November 2000 at 6:37:23 pm'!
"Change Set:		209SeqCollForceToFix-dew
Date:			30 October 2000
Author:			Doug Way / Andres Valloud

Fixes a bug in SequenceableCollection>>forceTo:paddingWith: introduced in update #2018.  Executing ''asdf' forceTo: 3 paddingWith: $-' was causing an error, instead of being truncated.  This new version still includes the optimizations from #2018, but with an extra check to handle this case.

Actually on the behalf of Doug, this has been replaced by a better change of Andres --sma"!


!SequenceableCollection methodsFor: 'accessing' stamp: 'SqR 10/30/2000 22:06'!
from: startIndex to: endIndex put: anObject
	"Put anObject in all indexes between startIndex 
	and endIndex. Very fast. Faster than to:do: for
	more than 26 positions. Answer anObject"

	| written toWrite thisWrite |

	startIndex > endIndex ifTrue: [^self].
	self at: startIndex put: anObject.
	written _ 1.
	toWrite _ endIndex - startIndex + 1.
	[written < toWrite] whileTrue:
		[
			thisWrite _ written min: toWrite - written.
			self 
				replaceFrom: startIndex + written
				to: startIndex + written + thisWrite - 1
				with: self startingAt: startIndex.
			written _ written + thisWrite
		].
	^anObject! !
