'From Squeak2.9alpha of 13 June 2000 [latest update: #3059] on 3 December 2000 at 4:21:26 pm'!
"Change Set:		CelesteFixes
Date:			3 December 2000
Author:			Bruce O'Neel

- updateToc has left the building.  Replace the call with cacheTOC.
- mail messages weren't parsing correctly for TOC entries.  Changed
comparisions with field names such as 'date' to case insensitive
comparisons.
- attachment separaters were looking for content-type rather than Content-Type."!


!Celeste methodsFor: 'categories pane' stamp: 'BEO 12/2/2000 21:09'!
setCategory: newCategory 
	"Change the currently selected category. We must also compute the table  
	of contents and message list for the new category."

	| messageCount |
	currentCategory _ newCategory.
	newCategory isNil
		ifTrue: [status _ currentMessages _ currentTOC _ currentMsgID _ nil]
		ifFalse: 
			[currentMessages _ self filteredMessagesIn: newCategory.
			messageCount _ currentMessages size.
			messageCount > self maxMessageCount
				ifTrue: 
					[self messages: self maxMessageCount from: messageCount.
					currentMessages _ currentMessages copyLast: self maxMessageCount]
				ifFalse: [self messages: messageCount from: messageCount].
			self cacheTOC].
	self changed: #category.
	self changed: #tocEntryList.
	self changed: #tocEntry.
	self changed: #messageText.
	self changed: #status! !


!MailMessage methodsFor: 'initialize-release' stamp: 'BEO 12/3/2000 15:53'!
from: aString 
	"Parse aString to initialize myself."
	| parseStream isMime contentType bodyText contentTransferEncoding |
	time _ 0.
	from _ to _ cc _ subject _ '' copy.
	text _ aString withoutTrailingBlanks, String cr.
	parseStream _ ReadStream on: text.
	isMime _ false.  "mdr: This variable is later set but never seems to be used???"
	contentType _ 'text/plain'.
	contentTransferEncoding _ nil.
	fields := Dictionary new.

	self fieldsFrom: parseStream do: 
		[:fName :fValue | 
		(fName asLowercase) = 'date' ifTrue: 
			[time _ (self timeFrom: fValue) ifNil: [ 0 ]].
		(fName asLowercase) = 'from' ifTrue: [from _ fValue].
		(fName asLowercase) = 'to'
			ifTrue: [to isEmpty
					ifTrue: [to _ fValue]
					ifFalse: [to _ to , ', ' , fValue]].
		(fName asLowercase)  = 'cc'
			ifTrue: [cc isEmpty
					ifTrue: [cc _ fValue]
					ifFalse: [cc _ cc , ', ' , fValue]].
		(fName asLowercase) = 'subject' ifTrue: [subject _ fValue].
		(fName asLowercase) = 'mime-version' ifTrue: [isMime _ true].
		(fName asLowercase) = 'content-type' ifTrue: [contentType _ (fValue copyUpTo: $;) asLowercase].
		(fName asLowercase) = 'content-transfer-encoding' ifTrue: [contentTransferEncoding _ fValue asLowercase].

		fields at: fName put: (MIMEHeaderValue fromString: fValue)].
	bodyText _ parseStream upToEnd.
	contentTransferEncoding = 'base64'
		ifTrue: 
			[bodyText _ Base64MimeConverter mimeDecodeToChars: (ReadStream on: bodyText).
			bodyText _ bodyText contents].
	contentTransferEncoding = 'quoted-printable' ifTrue: [bodyText _ bodyText decodeQuotedPrintable].
	body _ MIMEDocument contentType: contentType content: bodyText! !

!MailMessage methodsFor: 'multipart' stamp: 'BEO 12/3/2000 16:20'!
attachmentSeparator
	^(self fields at: 'Content-Type') parameters at: 'boundary' ! !

