'From Squeak2.9alpha of 17 July 2000 [latest update: #3372] on 2 February 2001 at 10:16:27 am'!
"Change Set:		morePSTweaks
Date:			2 February 2001
Author:			Bob Arning

Not the best, but an improvement:
- fix walkback when drawing closed polygon with #raised or #inset border to PostScript canvas. Just use gray for now. Alternative is to use ST drawing commands for these curves which wouldn't look as smooth.
- fix walkback when printing a gradient fill. Just use the fill #asColor for now."!


!PostscriptCanvas methodsFor: 'drawing support' stamp: 'RAA 2/2/2001 10:09'!
stroke: strokeColor
	strokeColor ifNil: [^ self].

	(strokeColor isKindOf: Symbol) ifTrue: [
		^self paint: Color gray operation: #stroke	"punt"
	].
	strokeColor isSolidFill ifTrue: [
		^self paint: strokeColor asColor operation: #stroke
	].
	self preserveStateDuring: [:inner | inner strokepath; fill: strokeColor].! !

!PostscriptCanvas methodsFor: 'drawing' stamp: 'RAA 2/2/2001 10:06'!
drawPolygon: vertices color: aColor borderWidth: bw borderColor: bc
	self outlinePolygon:vertices;
	     setLinewidth:bw;
	     fill:aColor andStroke: ((bc isKindOf: Symbol) ifTrue: [Color gray] ifFalse: [bc]).

! !

!PostscriptCanvas methodsFor: 'drawing' stamp: 'RAA 2/2/2001 09:54'!
fillRectangle: aRectangle fillStyle: aFillStyle
	"Fill the given rectangle."
	| pattern |

	(aFillStyle isKindOf: InfiniteForm) ifTrue: [
		^self infiniteFillRectangle: aRectangle fillStyle: aFillStyle
	].

	aFillStyle isSolidFill ifTrue:[^self fillRectangle: aRectangle color: aFillStyle asColor].

	"We have a very special case for filling with infinite forms"
	(aFillStyle isBitmapFill and:[aFillStyle origin = (0@0)]) ifTrue:[
		pattern _ aFillStyle form.
		(aFillStyle direction = (pattern width @ 0) 
			and:[aFillStyle normal = (0@pattern height)]) ifTrue:[
				"Can use an InfiniteForm"
				^self fillRectangle: aRectangle color: (InfiniteForm with: pattern)].
	].

	"Use a BalloonCanvas instead PROBABLY won't work here"
	"self balloonFillRectangle: aRectangle fillStyle: aFillStyle."

	^self fillRectangle: aRectangle color: aFillStyle asColor! !

