'From Squeak 2.2 of Sept 23, 1998 on 8 October 1998 at 11:10:01 am'!
"Change Set:		Finalization-RoundFive
Date:			7 October 1998
Author:			Andreas Raab

Round five of the Finalization updates activates
the weak registries in class Socket and StandardFileStream"!


!Socket methodsFor: 'initialize-destroy' stamp: 'ar 10/7/1998 14:42'!
destroy
	"Destroy this socket. Its connection, if any, is aborted and its resources are freed. Do nothing if the socket has already been destroyed (i.e., if its socketHandle is nil)."

	socketHandle = nil
		ifFalse: [
			self isValid ifTrue: [self primSocketDestroy: socketHandle].
			Smalltalk unregisterExternalObject: semaphore.
			socketHandle _ nil.
			semaphore _ nil.
			self unregister].
! !

!Socket methodsFor: 'initialize-destroy' stamp: 'ar 10/7/1998 14:43'!
initialize
	"Initialize a new socket handle. If socket creation fails, socketHandle will be set to nil."

	| semaIndex |
	semaphore _ Semaphore new.
	semaIndex _ Smalltalk registerExternalObject: semaphore.
	socketHandle _
		self primSocketCreateNetwork: 0
			type: 0
			receiveBufferSize: 8000
			sendBufSize: 8000
			semaIndex: semaIndex.

	socketHandle = nil ifTrue: [  "socket creation failed"
		Smalltalk unregisterExternalObject: semaphore.
		semaphore _ nil
	] ifFalse:[self register].
! !


!StandardFileStream methodsFor: 'open/close' stamp: 'ar 10/7/1998 14:43'!
close
	"Close this file."

	fileID ifNotNil: [
		self primClose: fileID.
		self unregister.
		fileID _ nil].
! !

!StandardFileStream methodsFor: 'open/close' stamp: 'ar 10/7/1998 14:44'!
open: fileName forWrite: writeMode 
	"Open the file with the given name. If writeMode is true, allow writing, otherwise open the file in read-only mode."
	"Changed to do a GC and retry before failing ar 3/21/98 17:25"
	fileID _ self retryWithGC:[self primOpen: fileName writable: writeMode] until:[:id| id notNil].
	fileID ifNil: [^ nil].  "allows sender to detect failure"
	self register.
	name _ fileName.
	rwmode _ writeMode.
	buffer1 _ String new: 1.
! !


