'From Squeak3.1alpha of 5 February 2001 [latest update: #3567] on 12 February 2001 at 2:54:28 pm'!
"Change Set:		fullScreenStack-sw
Date:			12 February 2001
Author:			Scott Wallace

Adds controls for full-screen mode to menus for Stacks"!


!StackMorph methodsFor: 'menu' stamp: 'sw 2/12/2001 14:49'!
addBookMenuItemsTo: aMenu hand: aHandMorph
	"Add book-related items to the given menu"

	| controlsShowing subMenu |
	subMenu _ MenuMorph new defaultTarget: self.
	subMenu add: 'previous card' action: #goToPreviousCardInStack.
	subMenu add: 'next card' action: #goToNextCardInStack.
	subMenu add: 'go to card...' action: #goToCard.
	subMenu add: 'insert a card' action: #insertCard.
	subMenu add: 'delete this card' action: #deleteCard.

	controlsShowing _ self hasSubmorphWithProperty: #pageControl.
	controlsShowing
		ifTrue:
			[subMenu add: 'hide card controls' action: #hidePageControls.
			subMenu add: 'fewer card controls' action: #fewerPageControls]
		ifFalse:
			[subMenu add: 'show card controls' action: #showPageControls].

	subMenu addLine.
	subMenu add: 'sound effect for all backgrounds' action: #menuPageSoundForAll:.
	subMenu add: 'sound effect this background only' action: #menuPageSoundForThisPage:.
	subMenu add: 'visual effect for all backgrounds' action: #menuPageVisualForAll:.
	subMenu add: 'visual effect this background only' action: #menuPageVisualForThisPage:.

	subMenu addLine.
	subMenu add: 'sort pages' action: #sortPages:.
	subMenu add: 'uncache page sorter' action: #uncachePageSorter.
	(self hasProperty: #dontWrapAtEnd)
		ifTrue: [subMenu add: 'wrap after last page' selector: #setWrapPages: argument: true]
		ifFalse: [subMenu add: 'stop at last page' selector: #setWrapPages: argument: false].

	subMenu  addUpdating: #showingFullScreenString action: #toggleFullScreen.
	subMenu addLine.
	subMenu add: 'search for text' action: #textSearch.
	(self primaryHand pasteBuffer class isKindOf: PasteUpMorph class) ifTrue:
		[subMenu add: 'paste book page'	action: #pasteBookPage].

	subMenu add: 'send all pages to server' action: #savePagesOnURL.
	subMenu add: 'send this page to server' action: #saveOneOnURL.
	subMenu add: 'reload all from server' action: #reload.
	subMenu add: 'copy page url to clipboard' action: #copyUrl.
	subMenu add: 'keep in one file' action: #keepTogether.
	subMenu add: 'save as new-page prototype' action: #setNewPagePrototype.
	newPagePrototype ifNotNil:
		[subMenu add: 'clear new-page prototype' action: #clearNewPagePrototype].

	aMenu add: 'book...' subMenu: subMenu
! !

!StackMorph methodsFor: 'menu' stamp: 'sw 2/12/2001 14:42'!
invokeBookMenu
	"Invoke the book's control panel menu."
	| aMenu |
	aMenu _ MenuMorph new defaultTarget: self.
	aMenu addTitle: 'Stack'.
	aMenu addStayUpItem.
	aMenu addList: #(
		('find...'								textSearch)
		('show designations' 					showDesignationsOfObjects)
		('explain designations'					explainDesignations)
		('look inside'							openInsideLook)
		-
		('previous card' 						goToPreviousCardInStack)
		('next card' 							goToNextCardInStack)
		('first card' 							goToFirstCardOfStack)
		('last card' 								goToLastCardOfStack)
		('go to card...' 							goToCard)
		-
		('add a card of this background' 		insertCard)
		('add a card of background...'		 	insertCardOfBackground)
		('make a new background...' 			makeNewBackground)
		-
		('delete this card' 						deleteCard)
		-
		('scripts for this background'			browseCardClass)
		-
		('debug...'								offerStackDebugMenu)
		('bookish items...' 						offerBookishMenu)).
	aMenu addUpdating: #showingPageControlsString action: #toggleShowingOfPageControls.
	aMenu addUpdating: #showingFullScreenString action: #toggleFullScreen.

	aMenu popUpEvent: self world activeHand lastEvent in: self world


! !

