'From Squeak 2.2 of Sept 23, 1998 on 13 October 1998 at 1:55:25 pm'!
"Change Set:		TR-VM-Fixes
Date:			13 October 1998
Author:			Andreas Raab

Two fixes suggested by Tim Rowledge:
#1 fixes a possibly fatal bug in argumentCountOf:
#2 fixes a problem from using #normalSend in bytecodePrimAt and bytecodePrimAtPut"!


!DynamicInterpreter methodsFor: 'compiled methods' stamp: 'ar 10/13/1998 13:49'!
argumentCountOf: methodPointer
	^ ((self headerOf: methodPointer) >> 25) bitAnd: 16r0F! !


!Interpreter methodsFor: 'compiled methods' stamp: 'ar 10/13/1998 13:50'!
argumentCountOf: methodPointer
	^ ((self headerOf: methodPointer) >> 25) bitAnd: 16r0F! !

!Interpreter methodsFor: 'array and stream primitives' stamp: 'ar 10/13/1998 13:51'!
commonAt: stringy
	"This version of at: is called from the special byteCode, from
	primitiveAt, and from primStringAt.  The boolean 'stringy'
	indicates that the result should be converted to a Character."

	| index rcvr result |
	self inline: true.
	index _ self stackTop.
	rcvr _ self stackValue: 1.
	(self isIntegerObject: index) & (self isIntegerObject: rcvr) not ifTrue: [
		index _ self integerValueOf: index.
		result _ self stObject: rcvr at: index.
		(stringy and: [successFlag]) ifTrue: [result _ self characterForAscii: result].
	] ifFalse: [
		successFlag _ false.
	].
	successFlag ifTrue: [
		self pop: 2 thenPush: result.
	].! !

!Interpreter methodsFor: 'array and stream primitives' stamp: 'ar 10/13/1998 13:52'!
commonAtPut: stringy
	"See the comment in commonAt:."

	| value valToStore index rcvr |
	self inline: true.
	value _ valToStore _ self stackTop.
	index _ self stackValue: 1.
	rcvr _ self stackValue: 2.
	(self isIntegerObject: index) & (self isIntegerObject: rcvr) not ifTrue: [
		index _ self integerValueOf: index.
		stringy ifTrue: [valToStore _ self asciiOfCharacter: value].
		self stObject: rcvr at: index put: valToStore.
	] ifFalse: [
		successFlag _ false.
	].
	successFlag ifTrue: [
		self pop: 3 thenPush: value.
	].! !


