"Change Set:		FastDragZOrderFix-nk
Date:			16 February 2001
Author:			Ned Konz

This makes the fast dragging of SystemWindows
equivalent to the non-fast dragging in that it makes sure
the window is at the top of the Z-order after the drag.

Without this fix, the window may be slid 'under' the
last morph picked up and moved by the hand.
"!


!SystemWindow methodsFor: 'events' stamp: 'nk 2/16/2001 15:45'!
doFastFrameDrag

	| offset newBounds outerWorldBounds |

	outerWorldBounds _ self boundsIn: nil.
	offset _ outerWorldBounds origin - Sensor cursorPoint.
	newBounds _ outerWorldBounds newRectFrom: [:f | 
		Sensor cursorPoint + offset extent: outerWorldBounds extent
	].
	^ self position: (self globalPointToLocal: newBounds topLeft); comeToFront! !

