'From Squeak3.1alpha [latest update: #''Squeak3.1alpha'' of 28 February 2001 update 3962] on 30 April 2001 at 9:23 pm'!
"Change Set:		suppressWorldMenu-sw
Date:			30 April 2001
Author:			Scott Wallace

Restores the suppression of the world menu when the eToyFriendly preference is true (a feature seemingly lost during the event remake last fall,) while retaining the loophole of cmd-shift-W over the desktop for bringing it up."!


!PasteUpMorph methodsFor: 'world menu' stamp: 'sw 4/30/2001 21:03'!
invokeWorldMenu: evt
	"Put up the world menu, triggered by the passed-in event.  But don't do it if the eToyFriendly preference is set to true."

	Preferences eToyFriendly ifFalse:
		[self putUpWorldMenu: evt]! !

!PasteUpMorph methodsFor: 'world menu' stamp: 'sw 4/30/2001 21:11'!
keystrokeInWorld: evt
	"A keystroke was hit when no keyboard focus was in set, so it is sent here to the world instead.  This current implementation is regrettably hard-coded; until someone cleans this up, you may wish to edit this method to suit your personal taste in interpreting cmd-keys issued to the desktop."

	|  aChar isCmd |
	aChar _ evt keyCharacter.
	isCmd _ evt commandKeyPressed and: [Preferences cmdKeysInText].
	(isCmd and: [Preferences honorDesktopCmdKeys]) ifTrue:
		[Preferences eToyFriendly
			ifTrue:
				[(aChar == $W) ifTrue: [^ self putUpWorldMenu: evt]]
			ifFalse:
				[(aChar == $z) ifTrue: [^ self commandHistory undoOrRedoCommand].
				(aChar == $w) ifTrue: [^ SystemWindow closeTopWindow].
				(aChar == $\) ifTrue: [^ SystemWindow sendTopWindowToBack].

				(aChar == $t) ifTrue: [^ self findATranscript: evt].
				(aChar == $b) ifTrue: [^ Browser openBrowser].
				(aChar == $k) ifTrue: [^ Workspace open].
				(aChar == $m) ifTrue: [^ TheWorldMenu new adaptToWorld: World; newMorph].

				(aChar == $C) ifTrue: [^ self findAChangeSorter: evt].
				(aChar == $R) ifTrue: [^ self openRecentSubmissionsBrowser: evt].
				(aChar == $P) ifTrue: [^ self findAPreferencesPanel: evt].

				(aChar == $r) ifTrue: [^ World restoreMorphicDisplay]]]! !

!PasteUpMorph methodsFor: 'world menu' stamp: 'sw 4/30/2001 21:03'!
putUpWorldMenu: evt
	"Put up a menu in response to a click on the desktop, triggered by evt."

	| menu |
	self bringFlapTabsToFront.
	evt isMouse ifTrue:
		[evt yellowButtonPressed
			ifTrue: [^ self yellowButtonClickOnDesktopWithEvent: evt].
		evt shiftPressed ifTrue:[^ self findWindow: evt]].
	"put up screen menu"
	menu _ self buildWorldMenu: evt.
	menu addTitle: Preferences desktopMenuTitle.
	menu popUpEvent: evt in: self! !

