'From Squeak3.1alpha of 28 February 2001 [latest update: #3984] on 4 May 2001 at 4:27:06 pm'!
"Change Set:		FlashVersionWarning
Date:			4 May 2001
Author:			Andreas Raab

Warn the user about possible problems before attempting to load flash 4/5 .swf files."!


!FlashFileReader methodsFor: 'reading' stamp: 'ar 5/4/2001 16:25'!
processHeader
	"Read header information from the source stream.
	Return true if successful, false otherwise."
	| twipsFrameSize frameRate frameCount |
	self processSignature ifFalse:[^false].
	version _ stream nextByte.
	"Check for the version supported"
	version > self maximumSupportedVersion ifTrue:[
		(self confirm:'This file''s version (',version printString,') is higher than 
the currently supported version (', self maximumSupportedVersion printString,'). 
It may contain features that are not supported 
and it may not display correctly.
Do you want to continue?') ifFalse:[^false]].

	dataSize _ stream nextLong.
	"Check for the minimal file size"
	dataSize < 21 ifTrue:[^false].
	twipsFrameSize _ stream nextRect.
	self recordGlobalBounds: twipsFrameSize.
	frameRate _ stream nextWord / 256.0.
	self recordFrameRate: frameRate.
	frameCount _ stream nextWord.
	self recordFrameCount: frameCount.
	log ifNotNil:[
		log cr; nextPutAll:'------------- Header information --------------'.
		log cr; nextPutAll:'File version		'; print: version.
		log cr; nextPutAll:'File size			'; print: dataSize.
		log cr; nextPutAll:'Movie width		'; print: twipsFrameSize extent x // 20.
		log cr; nextPutAll:'Movie height	'; print: twipsFrameSize extent y // 20.
		log cr; nextPutAll:'Frame rate		'; print: frameRate.
		log cr; nextPutAll:'Frame count	'; print: frameCount.
		log cr; cr.
		self flushLog].
	^true! !

!FlashFileReader methodsFor: 'processing actions' stamp: 'ar 5/4/2001 16:21'!
processActionWaitForFrame: data
	| length frame skip |
	length _ data nextWord.
	length = 3 ifFalse:["Something is wrong"
		data skip: -2.
		^self processUnknownAction: data].
	frame _ data nextWord.
	skip _ data nextByte.
	log ifNotNil:[
		log nextPutAll:'frame = '; print: frame;
			nextPutAll:', skip = '; print: skip].
	^Message selector: #isFrameLoaded:elseSkip: arguments: (Array with: frame with: skip).! !

!FlashFileReader methodsFor: 'private' stamp: 'ar 5/4/2001 16:22'!
maximumSupportedVersion
	^3! !

