'From Squeak3.1alpha of 28 February 2001 [latest update: #4001] on 9 May 2001 at 10:55:42 pm'!
"Change Set:		WnldAnimCtrl-ar
Date:			9 May 2001
Author:			Andreas Raab

The change set exposes the 'animation index' for animated 3D objects, removing one more need for 'behind the scenes magic'. Now the entire NudiBranch3D project scripting is done using the 'real' (aka end-user) system"!


!B3DIndexedMesh methodsFor: 'accessing' stamp: 'ar 5/9/2001 22:34'!
animationIndex
	^1! !

!B3DIndexedMesh methodsFor: 'accessing' stamp: 'ar 5/9/2001 22:35'!
animationIndex: index
! !


!B3DInterpolatedMesh methodsFor: 'accessing' stamp: 'ar 5/9/2001 22:35'!
animationIndex
	^index! !

!B3DInterpolatedMesh methodsFor: 'accessing' stamp: 'ar 5/9/2001 22:44'!
animationIndex: newIndex
	index _ newIndex \\ meshes size.
	index < 1 ifTrue:[index _ 1 + index].! !

!B3DInterpolatedMesh methodsFor: 'displaying' stamp: 'ar 5/9/2001 22:42'!
renderOn: aRenderer
	^(meshes at: index asInteger) renderOn: aRenderer! !


!Vocabulary class methodsFor: 'testing and demo' stamp: 'ar 5/9/2001 22:32'!
newWonderlandVocabulary
	"Answer a Wonderland vocabulary -- highly experimental"
	| aVocabulary  |
	aVocabulary _ Vocabulary new vocabularyName: #WonderlandVocabulary.
	aVocabulary documentation: 'A simple vocabulary for scripting Alice objects'.
	aVocabulary initializeFromTable:  #(
		(color color: () color (basic color) 'The color of the object' unused updating)
		"--"
		(getX setX: () number (basic geometry) 'The x position' unused updating)
		(getY setY: () number (basic geometry) 'The y position' unused updating)
		(getZ setZ: () number (basic geometry) 'The z position' unused updating)
		"--"
		(width setWidth: () number (geometry) 'The width of the object' unused updating)
		(height setHeight: () number (geometry) 'The height of the object' unused updating)
		(depth setDepth: () number (geometry) 'The depth of the object' unused updating)
		"--"
		(heading setHeading: () number (basic geometry) 'The heading of the object' unused updating)
		(forwardBy: unused ((distance number)) none (basic motion) 'Moves the object by the specified distance' 'forward by')
		(turnBy: unused ((angle number)) none (basic motion) 'Turns the object by the specified number of degrees' 'turn by')
		(graphic setGraphic: () graphic (basic graphics) 'The picture currently being worn' unused updating)
		(animationIndex setAnimationIndex: () number (graphics) 'The index in the object''s animation chain' unused updating)
		(emptyScript unused () none (scripts) 'The empty script')
	).
	^ aVocabulary
"Vocabulary initialize"
! !


!WonderlandActor methodsFor: 'private' stamp: 'ar 5/9/2001 22:34'!
getMeshAnimationIndex
	myMesh == nil ifTrue:[^1].
	^myMesh animationIndex! !

!WonderlandActor methodsFor: 'private' stamp: 'ar 5/9/2001 22:34'!
setMeshAnimationIndex: index
	myMesh animationIndex: index.
! !

!WonderlandActor methodsFor: 'eToy-basic' stamp: 'ar 5/9/2001 22:33'!
animationIndex
	^self getMeshAnimationIndex! !

!WonderlandActor methodsFor: 'eToy-basic' stamp: 'ar 5/9/2001 22:33'!
setAnimationIndex: aNumber
	self setMeshAnimationIndex: aNumber.! !

!WonderlandActor methodsFor: 'eToy-support' stamp: 'ar 5/9/2001 22:39'!
assignDecrGetter: getterSelector setter: setterSelector amt: aDecrement
	self perform: setterSelector with:
		((self perform: getterSelector) - aDecrement)! !

!WonderlandActor methodsFor: 'eToy-support' stamp: 'ar 5/9/2001 22:39'!
assignGetter: getterSelector setter: setterSelector amt: amt
	self perform: setterSelector with: amt! !

!WonderlandActor methodsFor: 'eToy-support' stamp: 'ar 5/9/2001 22:39'!
assignIncrGetter: getterSelector setter: setterSelector amt: anIncrement
	self perform: setterSelector with:
		((self perform: getterSelector) + anIncrement)! !

!WonderlandActor methodsFor: 'eToy-support' stamp: 'ar 5/9/2001 22:39'!
assignMultGetter: getterSelector setter: setterSelector amt: aMultiplier
	self perform: setterSelector with:
		((self perform: getterSelector) * aMultiplier)! !

!WonderlandActor methodsFor: 'eToy-fake' stamp: 'ar 5/9/2001 22:37'!
getAnimationIndex
	"Why does eToy system send #getXyz instead of #xyz???"
	^self animationIndex! !

"Postscript:
Dump old wonderland vocabulary"
Vocabulary removeVocabularyNamed: #WonderlandVocabulary.!

