'From Squeak3.1alpha of 28 February 2001 [latest update: #4343] on 20 September 2001 at 12:18:55 am'!
"Change Set:		propSheetPref-sw
Date:			20 September 2001
Author:			Scott Wallace

Makes the Property Sheet and the simple Color Picker both always directly available from the morph halo.  A new preference, #propertySheetFromHalo, governs which of the two choices a simple click on the recoloring halo-handle should put up; shift-click will then put up the opposite one.

The default value for the new preference is true, to keep things exactly the same way they were.  If you change #propertySheetFromHalo to false, a simple click on the recoloring handle will now put up the simple, one-click color-picker, and you will need to use shift-click on the recoloring handle to get the full property sheet."

Preferences addPreference: #propertySheetFromHalo category: #halos default: true balloonHelp: 'governs whether a full property sheet or a simple "color picker" should be presented when you click on the "recoloring" (eyedropper) halo handle.  If you hold down the *shift* key as you click on the eyedropper, you will get the the reverse choice.'. !


!HaloMorph methodsFor: 'private' stamp: 'sw 9/20/2001 00:16'!
doRecolor: evt with: aHandle
	"The mouse went down in the 'recolor' halo handle.  Allow the user to change the color of the innerTarget"

	evt hand obtainHalo: self.
	(aHandle containsPoint: evt cursorPoint)
		ifFalse:  "only do it if mouse still in handle on mouse up"
			[self delete.
			target addHalo: evt]
		ifTrue:
			[(Preferences propertySheetFromHalo == evt shiftPressed)
				ifFalse:	[innerTarget openAPropertySheet]
				ifTrue:	[innerTarget changeColor].
			self showingDirectionHandles ifTrue: [self addHandles]]! !

