'From Squeak 2.3 beta of Nov 25, 1998 on 25 November 1998 at 3:37:55 pm'!

!HandMorph methodsFor: 'world menu' stamp: 'di 11/25/1998 12:24'!
openMenu
	"Build the open window menu for the world."
	| menu |
	menu _ (MenuMorph entitled: 'Open a new window') defaultTarget: self.
	menu addStayUpItem.
	menu add: 'browser' action: #openBrowser.
	menu add: 'workspace' action: #openWorkspace.
	menu add: 'file list' action: #openFileList.
	menu add: 'transcript' target: Transcript action: #open.
	menu add: 'selector finder' target: ScreenController new action: #openSelectorBrowser.
	menu addLine.
	menu add: 'email reader' action: #openEmail.
	menu add: 'web browser' action: #openWebBrowser.
	menu add: 'IRC chat' action: #openIRC.
	menu addLine.
	menu add: 'project (mvc)' action: #openMVCProject.
	menu add: 'project (morphic)' action: #openMorphicProject.
	menu add: 'project (construction)' action: #openConstructionProject.
	menu add: 'project link...' action: #projectThumbnail.
	^ menu
! !


!ParagraphEditor methodsFor: 'private' stamp: 'di 11/25/1998 14:40'!
againOnce: indices
	"Find the next occurrence of FindText.  If none, answer false.
	Append the start index of the occurrence to the stream indices, and, if
	ChangeText is not the same object as FindText, replace the occurrence by it.
	Note that the search is case-sensitive for replacements, otherwise not."

	| where |
	where _ paragraph text findString: FindText startingAt: stopBlock stringIndex
				caseSensitive: ChangeText ~~ FindText.
	where = 0 ifTrue: [^ false].
	self deselect; selectInvisiblyFrom: where to: where + FindText size - 1.
	ChangeText ~~ FindText ifTrue: [self zapSelectionWith: ChangeText].
	indices nextPut: where.
	self selectAndScroll.
	^ true! !


!ScreenController methodsFor: 'menu messages' stamp: 'di 11/25/1998 12:21'!
durableOpenMenu 
	| colorPattern |
	colorPattern _ #(blue lightGreen lightYellow lightMagenta  lightOrange lightCyan) asOrderedCollection.
	colorPattern add: Project someInstance backgroundColorForMvcProject.
	colorPattern add: Project someInstance backgroundColorForMorphicProject.
	colorPattern add: #orange.
	Utilities windowFromMenu: self openMenu target: self title: 'Openers'
		colorPattern: colorPattern! !

!ScreenController methodsFor: 'nested menus' stamp: 'di 11/25/1998 12:23'!
openMenu
	^ SelectionMenu labelList:
		#(	'keep this menu up'

			'browser'
			'workspace'
			'file list'
			'transcript'
			'selector finder'

			'project (mvc)'
			'project (morphic)'
			'project (construction)'
			)
		lines: #(1 6)
		selections: #(durableOpenMenu
openBrowser openWorkspace openFileList openTranscript openSelectorBrowser
openProject  openMorphicProject  openConstructionProject )
"
ScreenController  new openMenu startUp
"! !


!SequenceableCollection methodsFor: 'converting' stamp: 'djm 11/20/1998 05:44'!
asStringWithCr
	"Convert to a string with returns between items.  Elements are
usually strings.
	 Useful for labels for PopUpMenus."
	| labelStream |
	labelStream _ WriteStream on: (String new: 200).
	self do: [:each |
		(each isKindOf: String)
			ifTrue: [labelStream nextPutAll: each; cr]
			ifFalse: [each printOn: labelStream. labelStream cr]].
	self size > 0 ifTrue: [labelStream skip: -1].
	^ labelStream contents! !


!SystemDictionary methodsFor: 'sources, change log' stamp: 'di 11/25/1998 14:20'!
version
	"Answer the version of this release."

	^ 'Squeak 2.3 beta of Nov 25, 1998'! !


!SystemWindow methodsFor: 'top window' stamp: 'di 11/25/1998 15:15'!
activate
	"Bring me to the front and make me able to respond to mouse and keyboard"
	| oldTop outerMorph |
	outerMorph _ self topRendererOrSelf.
	outerMorph owner ifNil: [^ self "avoid spurious activate when drop in trash"].
	oldTop _ TopWindow.
	TopWindow _ self.
	oldTop ifNotNil: [oldTop passivate].
	outerMorph owner firstSubmorph == outerMorph
		ifFalse: ["Bring me (with any flex) to the top if not already"
				outerMorph owner addMorphFront: outerMorph].
	self submorphsDo: [:m | m unlock].
	self setStripeColorsFrom: self paneColor.
	self isCollapsed ifFalse:
		[model modelWakeUp.
		self positionSubmorphs]! !


