'From Squeak3.2alpha of 3 October 2001 [latest update: #4554] on 2 December 2001 at 9:41:05 pm'!
"Change Set:		miscFixes-rhi
Date:			December 2001
Author:			Robert Hirschfeld

 Fixes a problem with removing a class from within a hierarchy browser. The removal caused a walkback since the code for reinitializing the hierarchy worked on an obsolete class...

 Fixes a browser relabeling problem. To reproduce: [#1] open a browser -> the window label does not contain a class name, [#2] select a system category -> the window label does not contain a class name, [#3] select a class -> the window label now contains the name of the selected class, [#4] select another system category -> the window label STILL contains the name of the previously selected class ...

 Removes duplicated code from (Object|StringHolder|CodeHolder)>>contentsChanged ...

 Makes copyWithoutIndex: work also with OrderedCollections by replacing new: with ofSize: since OrderedCollection new: creates an empty collection that is not indexable from within copyWithoutIndex: ...
Examples:
	#(a b c) copyWithoutIndex: 2 ==> #(#a #c)
	(OrderedCollection with: $a with: $b with: $c) copyWithoutIndex: 2
		==(without fix)==> error: 'attempt to index non-existent element in an ordered collection'
		==(with fix)==> an OrderedCollection($a $c)"!

!SequenceableCollection methodsFor: 'copying' stamp: 'rhi 12/6/2001 14:04'!
copyWithoutIndex: index
	"Return a copy containing all elements except the index-th."

	| copy |
	copy := self species ofSize: self size - 1.
	copy replaceFrom: 1 to: index-1 with: self startingAt: 1.
	copy replaceFrom: index to: copy size with: self startingAt: index+1.
	^ copy! !

!CodeHolder methodsFor: 'contents' stamp: 'rhi 12/3/2001 22:25'!
contentsChanged

	super contentsChanged.
	self changed: #annotation! !

!Browser methodsFor: 'system category list' stamp: 'rhi 12/3/2001 22:32'!
systemCategoryListIndex: anInteger 
	"Set the selected system category index to be anInteger. Update all other 
	selections to be deselected."

	systemCategoryListIndex _ anInteger.
	classListIndex _ 0.
	messageCategoryListIndex _ 0.
	messageListIndex _ 0.
	editSelection _ anInteger = 0 ifTrue: [#none] ifFalse: [#newClass].
	metaClassIndicated _ false.
	self setClassOrganizer.
	contents _ nil.
	self changed: #systemCategorySelectionChanged.
	self changed: #systemCategoryListIndex.	"update my selection"
	self changed: #classList.
	self changed: #messageCategoryList.
	self changed: #messageList.
	self changed: #relabel.
	self contentsChanged! !

!HierarchyBrowser methodsFor: 'initialization' stamp: 'rhi 12/2/2001 21:32'!
updateAfterClassChange
	"It is possible that some the classes comprising the hierarchy have changed, so reinitialize the entire browser."

	(centralClass notNil and: [centralClass isObsolete not])
		ifTrue: [self initHierarchyForClass: centralClass]! !

StringHolder removeSelector: #contentsChanged!


