'From Squeak 2.3 beta of Nov 25, 1998 on 2 January 1999 at 10:22 pm'!

!Project methodsFor: 'menu messages' stamp: 'di 1/2/1999 21:58'!
enter: returningFlag
	"Install my ChangeSet, Transcript, and scheduled views as current globals. If returningFlag is true, we are return to the project from whence the current project was entered; don't change its previousProject link in this case."

	| newDisplay entering vanishingPoint showZoom priorProject |
	self == CurrentProject ifTrue: [^ self].
	Smalltalk at: #ScorePlayer ifPresent: [:playerClass |
		playerClass allInstancesDo: [:player | player pause]].
	returningFlag ifFalse: [
		"record link to previous project unless we're returning via that link"
		previousProject _ CurrentProject].
	priorProject _ CurrentProject.

	"Same code runs for enter and exit; test which for zoom"
	entering _ self ~~ CurrentProject parent.
	displayDepth == nil ifTrue: [displayDepth _ Display depth].
	CurrentProject makeThumbnail.
	CurrentProject saveState.
	CurrentProject _ self.
	Smalltalk newChanges: changeSet.
	TranscriptStream newTranscript: transcript.
	showZoom _ Preferences showProjectZoom
		and: [Smalltalk garbageCollectMost > (Display boundingBox area*displayDepth//8+200000)].
	Display replacedBy:
			(showZoom
				ifTrue: [newDisplay _ DisplayScreen extent: Display extent
													depth: displayDepth]
				ifFalse: [Display newDepthNoRestore: displayDepth])
		do: [world isMorph
				ifTrue: [World _ world.  "Signifies Morphic"
						world install]
				ifFalse: [World _ nil.  "Signifies MVC"
						Smalltalk at: #ScheduledControllers put: world.
						ScheduledControllers restore]].
	showZoom
		ifTrue: ["Show animated zoom to new display"
				entering
					ifTrue: [vanishingPoint _ Sensor cursorPoint]
					ifFalse: [vanishingPoint _ self viewLocFor: priorProject].
				Display zoomIn: entering orOutTo: newDisplay at: 0@0
							vanishingPoint: vanishingPoint.
				displayDepth ~= Display depth ifTrue:
					[Display newDepthNoRestore: displayDepth.
					newDisplay displayOn: Display at: 0@0]].
	world isMorph
		ifTrue: [self spawnNewProcessAndTerminateOld: true]
		ifFalse: [world searchForActiveController]! !

!Project methodsFor: 'menu messages' stamp: 'di 1/2/1999 21:56'!
viewLocFor: exitedProject
	"Look for a view of the exitedProject, and return its center"
	World isMorph
		ifTrue: [exitedProject dependents do:
					[:v | (v isKindOf: SystemWindow)
						ifTrue: [^ v center]]]
		ifFalse: [exitedProject dependents do:
					[:v | (v isKindOf: StandardSystemView)
						ifTrue: [^ v windowBox center]]].

	^ Sensor cursorPoint.  "default result"

! !


