'From Squeak 2.3 of January 14, 1999 on 28 January 1999 at 4:27:36 pm'!
"Change Set:		fasterPlayerList-sw
Date:			28 January 1999
Author:			Scott Wallace

Makes the recaching of playerLists faster by no longer traversing unseen pages of bookmorphs.  This means that players belonging to not-currently-seen pages of bookmorphs will not be in the steplist, but I believe they actually weren't getting there anyway, or at least not getting serviced."!


!Morph methodsFor: 'scripting' stamp: 'sw 1/5/1999 15:17'!
makeAllTilesColored
	self allMorphs do: 
		[:m | m restoreTypeColor]! !

!Morph methodsFor: 'scripting' stamp: 'sw 1/5/1999 15:17'!
makeAllTilesGreen
	self allMorphs do: 
		[:m | m useUniformTileColor]! !


!Presenter methodsFor: 'playerList' stamp: 'sw 1/5/1999 15:13'!
allExtantPlayers
	"The initial intent here was to produce a list of Player objects associated with any Morph in the tree beneath the receiver's associatedMorph.  whether it is the submorph tree or perhaps off on unseen bookPages.  We have for the moment moved away from that initial intent, and in the current version we only deliver up players associated with the submorph tree only.

Call #flushPlayerListCache to force recomputation."

	playerList ifNotNil:
		[^ playerList].

	^ playerList _ (associatedMorph allMorphs select: 
		[:m | m player ~~ nil] thenCollect: [:m | m player]) asArray! !


