'From Squeak 2.3 of January 14, 1999 on 6 February 1999 at 1:09:35 pm'!
"Change Set:		ERFasterRead
Date:			6 February 1999
Author:			Dan Ingalls

Several tweaks to read EventTapes faster:
1.  Reads a line at a time from the file so skips and peeks go faster in a non-file stream.
2.  Recognizes 'mouseMove' without having to do asSymbol.
3.  Better stream construction in MorphicEvent readFrom:

I got 8.5x speedup on MWLessonOne.tape.
NOTE: #foreward has been replaced by #forward.
"!


!EventRecorderMorph methodsFor: 'private' stamp: 'di 2/6/1999 12:16'!
readFrom: aStream
	"Private"
	| cr t evt line lineStream |
	cr _ Character cr.
	[aStream atEnd]
		whileFalse:
			[line _ aStream upTo: cr.
			line isEmpty
				ifTrue: [tape write: nil]
				ifFalse: [lineStream _ ReadStream on: line.
						t _ Integer readFrom: lineStream.
						[lineStream peek isLetter] whileFalse: [lineStream next].
						evt _ MorphicEvent readFrom: lineStream.
						tape write: t -> evt].
			tape forward]
! !


!MorphicEvent class methodsFor: 'instance creation' stamp: 'di 2/6/1999 12:42'!
readFrom: aStream
	"Read a MorphicEvent from the given stream."

	| type x y buttons keyValue typeString c |
	typeString _ String streamContents:
		[:s |   [(c _ aStream next) isLetter] whileTrue: [s nextPut: c]].
	typeString = 'mouseMove'
		ifTrue: [type _ #mouseMove  "fast treatment of common case"]
		ifFalse: [type _ typeString asSymbol].

	x _ Integer readFrom: aStream.
	aStream skip: 1.
	y _ Integer readFrom: aStream.
	aStream skip: 1.

	buttons _ Integer readFrom: aStream.
	aStream skip: 1.

	keyValue _ Integer readFrom: aStream.

	^ self basicNew setType: type
		cursorPoint: x@y
		buttons: buttons
		keyValue: keyValue
! !


