'From Squeak 2.3 of January 14, 1999 on 10 February 1999 at 9:26:33 pm'!
"Change Set:		PolygonBorders2
Date:			10 February 1999
Author:			Dan Ingalls

Final tweaks for polygons with translucent borders.
Makes sure to recompute forms when translucency changes.
Also prevents overwrite of arrows and line when translucent.
"!


!PolygonMorph methodsFor: 'access' stamp: 'di 2/10/1999 21:13'!
borderColor: aColor
	(borderColor isColor and: [borderColor isTranslucentColor])
		== (aColor isColor and: [aColor isTranslucentColor])
		ifTrue: [super borderColor: aColor]
		ifFalse: ["Need to recompute fillForm and borderForm
					if translucency of border changes."
				super borderColor: aColor.
				self releaseCachedState]! !

!PolygonMorph methodsFor: 'private' stamp: 'di 2/10/1999 21:21'!
borderForm
	"A form must be created for drawing the border whenever the borderColor is translucent."

	| borderCanvas |
	borderForm ifNotNil: [^ borderForm].
	borderCanvas _ (FormCanvas extent: bounds extent depth: 1)
		setShadowDrawing; stipple: Color black;
		copyOffset: bounds topLeft negated.
	self drawBorderOn: borderCanvas.
	borderForm _ borderCanvas form copy offset: 0@0.
	self arrowForms do:
		[:f |  "Eliminate overlap between line and arrowheads if transparent."
		borderForm copy: f boundingBox from: f to: f offset - self position rule: Form erase].
	^ borderForm! !


