'From Squeak 2.3 of January 14, 1999 on 8 March 1999 at 10:42:35 pm'!
"Change Set:		moreButtonLike-sw
Date:			8 March 1999
Author:			Scott Wallace

Gives a more button-like look to two controls in the viewer, the thumbnail and the category-pane, which serve double duty as status indicators and menu-providers  -- one by having a 'raised' look and the other by having a drop-shadow.  Provisional, to invite comment."!


!CategoryViewer methodsFor: 'categories' stamp: 'sw 3/8/1999 12:15'!
categoryChoice: aCategory
	"Temporarily switch-hits in support of two competing ui designs for the list"
	| bin actualPane |
	((actualPane _ namePane renderedMorph) isKindOf: StringMorph)
		ifTrue:
			[namePane contents: aCategory; color: Color black]
		ifFalse:
			[(actualPane isKindOf: RectangleMorph)
				ifTrue:	[actualPane firstSubmorph contents: aCategory; color: Color black.
						actualPane extent: actualPane firstSubmorph extent]
				ifFalse:
					[actualPane selection: (scriptedPlayer categories indexOf: aCategory)]].

	Preferences useScrollingInPartsLists
		ifTrue:
			[bin _ PluggableListMorph on: self list: #itemsInCategory selected: #selectedItemInCategory changeSelected: #itemInCategoryIndex:]

		ifFalse:
			[bin _ PhraseWrapperMorph new
				borderWidth: 0;
				orientation: #vertical.

			bin addAllMorphs:
				((scriptedPlayer tilePhrasesForCategory: aCategory inViewer: self) collect:
					[:aViewerRow | self viewerEntryFor: aViewerRow])].


	bin enforceTileColorPolicy.
	submorphs size < 2
		ifTrue:
			[self addMorphBack: bin]
		ifFalse:
			[self replaceSubmorph: self listPane by: bin].
	self world ifNotNil: [self world startSteppingSubmorphsOf: self]

! !

!CategoryViewer methodsFor: 'categories' stamp: 'sw 3/8/1999 12:15'!
currentCategory
	"Temporarily switch-hits in support of two competing ui designs for the list"
	| current actualPane |
	actualPane _ namePane renderedMorph.
	current _ (actualPane isKindOf: PluggableListMorph)
		ifTrue:
			[actualPane selection]
		ifFalse:
			[(actualPane isKindOf: StringMorph)
				ifTrue:	[actualPane contents]
				ifFalse:	[actualPane firstSubmorph contents]].
	^ current ifNil: [#basic]! !

!CategoryViewer methodsFor: 'header pane' stamp: 'sw 3/4/1999 16:15'!
addHeaderMorph
	| header aFont aButton wrpr |
	header _ AlignmentMorph newRow color: self color; centering: #center.
	aFont _ ScriptingSystem fontForScriptorButtons.
	header addMorph: (aButton _ SimpleButtonMorph new label: 'X' font: aFont).
	aButton target: self;
			color:  Color lightRed;
			actionSelector: #delete;
			setBalloonText: 'Delete this Viewer'.
	header addTransparentSpacerOfSize: 5@5.

	Preferences useCategoryListsInViewers
		ifFalse:
			[header addUpDownArrowsFor: self.
			(wrpr _ header submorphs last) submorphs second setBalloonText: 'previous category'.	
			wrpr submorphs first  setBalloonText: 'next category'].
	header beSticky.
	self addMorph: header.

	Preferences useCategoryListsInViewers
		ifTrue:
			[namePane _ PluggableListMorph on: self list: #categories selected: #selectedCategory changeSelected: #categoryIndex:
				menu: #categoryMenu: keystroke: #categoryListKey:from:.
			namePane scrollBarOnLeft: false; retractable: false; height: 60]
		ifFalse:
			[namePane _ RectangleMorph newSticky color: Color brown veryMuchLighter.
			namePane borderWidth: 0.
			aButton _ (StringButtonMorph contents: '-----' "font: ScriptingSystem fontForScriptorButtons") color: Color black.
			aButton target: self; arguments: Array new; actionSelector: #chooseCategory.
			aButton actWhen: #buttonDown.
			namePane addMorph: aButton.
			aButton position: namePane position].
	namePane align: namePane topLeft with: (bounds topLeft + (50 @ 0)).
	namePane setBalloonText: 'category (click here to choose a different one)'.

	header addMorphBack: namePane.
	(namePane isKindOf: RectangleMorph) ifTrue:
		[namePane addDropShadow.
		namePane owner color: Color gray].

	self categoryChoice: 'basic'
! !


!StandardViewer methodsFor: 'all' stamp: 'sw 3/5/1999 17:06'!
addHeaderMorphWithBarHeight: anInteger
	| header aFont aButton aTextMorph nail wrpr costs headWrapper |
	header _ AlignmentMorph newRow color: self color muchLighter; centering: #center.
	aFont _ ScriptingSystem fontForScriptorButtons.
	header addMorph: (aButton _ SimpleButtonMorph new label: 'X' font: aFont).
	aButton target: self;
			color:  Color lightRed;
			actionSelector: #dismiss;
			setBalloonText: 'Delete'.
	header addTransparentSpacerOfSize: 4@1.

	header addMorphBack: (aButton _ SimpleButtonMorph new label: '+' font: aFont).
	aButton target: self; beTransparent; borderWidth: 0;
			actionSelector: #addCategoryViewer;
			setBalloonText: 'click here to add
another viewer'.
	header addTransparentSpacerOfSize: 4@1.

	(((costs _ scriptedPlayer costumes) size > 1) or: [costs size == 1 and: [costs first ~~ scriptedPlayer costume]]) ifTrue:
		[header addUpDownArrowsFor: self.
		(wrpr _ header submorphs last) submorphs second setBalloonText: 'switch to previous costume'.	
		wrpr submorphs first  setBalloonText: 'switch to next costume'].	

	nail _ ThumbnailMorph new objectToView: scriptedPlayer viewSelector: #costume.
	nail on: #mouseDown send: #thumbnailMenuEvt:forMorph: to: scriptedPlayer.
	header addMorphBack: nail.
	nail setBalloonText: 'click here to get a menu
to specify new costume,
tear off a tile, etc..'.
	nail borderWidth: 3; borderColor: #raised.
	"nail addDropShadow.
	nail owner color: Color gray."

	header addTransparentSpacerOfSize: 5@5.

"	aButton _ SimpleButtonMorph new target: self; actionSelector: #newEmptyScript; label: 'S' font: (aFont _ StrikeFont familyName: #ComicBold size: 16);  color: Color transparent; borderWidth: 0; actWhen: #buttonDown.
	aButton setBalloonText: 'drag from here to
create a new script
for this object'.	
	header addMorphBack: aButton.

	header addTransparentSpacerOfSize: 8@5.

	aButton _ SimpleButtonMorph new target: scriptedPlayer; actionSelector: #addInstanceVariable; label: 'I' font: aFont;  color: Color transparent; borderWidth: 0; actWhen: #buttonUp.
	aButton setBalloonText: 'click here to add
an instance variable
to this object.'.
	header addMorphBack: aButton.

	header addTransparentSpacerOfSize: 5@5."

	scriptedPlayer costume assureExternalName.
	aTextMorph _ UpdatingStringMorph new
		useStringFormat;
		target:  scriptedPlayer;
		getSelector: #getName;
		putSelector: #setName:;
		setNameTo: 'name';
		font: ScriptingSystem fontForNameEditingInScriptor.
	aTextMorph setProperty: #okToTextEdit toValue: true.
	aTextMorph step.
	header  addMorphBack: aTextMorph.
	aTextMorph setBalloonText: 'Click here to edit the player''s name
use backspace to delete unwanted characters'.	

	header beSticky.
	anInteger > 0
		ifTrue:
			[headWrapper _ AlignmentMorph newColumn color: self color.
			headWrapper addTransparentSpacerOfSize: (0 @ anInteger).
			headWrapper addMorphBack: header.
			self addMorph: headWrapper]
		ifFalse:
			[self addMorph: header]! !


