'From Squeak 2.3 of January 14, 1999 on 2 April 1999 at 3:57:57 pm'!
"Change Set:		TimeStampFix
Date:			2 April 1999
Author:			Dan Ingalls

Made StringHolder timeStamp always return a string.  Undid a work-around for nil.
"!


!StringHolder methodsFor: 'message list menu' stamp: 'di 4/2/1999 15:54'!
timeStamp 
	|  selector  aMethod |
	(selector _ self selectedMessageName) ifNotNil:
		[aMethod _ self selectedClassOrMetaClass compiledMethodAt: selector ifAbsent: [nil].
		aMethod ifNotNil: [^ Utilities timeStampForMethod: aMethod]].
	^ String new! !

!StringHolder methodsFor: 'annotation pane' stamp: 'di 4/2/1999 15:56'!
annotation
	"Provide a line of annotation material for a middle pane."

	| stamp aMessage sendersCount implementorsCount toShow aCategory separator aString aList |

	(aMessage _ self selectedMessageName)
		ifNil: [^ '------'].
	toShow _ ReadWriteStream on: ''.
	separator _ '  '.
	self annotationRequests do:
		[:aRequest |
		(aRequest == #timeStamp) ifTrue:
			[stamp _ self timeStamp.
			toShow nextPutAll: (stamp size > 0
				ifTrue: [stamp, separator]
				ifFalse: ['no timeStamp', separator])].

		(aRequest == #messageCategory) ifTrue:
			[aCategory _ self selectedClassOrMetaClass organization categoryOfElement: self selectedMessageName.
			aCategory ifNotNil: "woud be nil for a method no longer present, e.g. in a recent-submissions browser"
				[toShow nextPutAll: aCategory, separator]].

		(aRequest == #sendersCount) ifTrue:
			[sendersCount _ (Smalltalk allCallsOn: aMessage) size.
			sendersCount _ sendersCount == 1
				ifTrue:
					['1 sender']
				ifFalse:
					[sendersCount printString, ' senders'].
			toShow nextPutAll: sendersCount, separator].

		(aRequest == #implementorsCount) ifTrue:
			[implementorsCount _ (Smalltalk allImplementorsOf: aMessage) size.
			implementorsCount _ implementorsCount == 1
				ifTrue:
					['1 implementor']
				ifFalse:
					[implementorsCount printString, ' implementors'].
			toShow nextPutAll: implementorsCount,  separator].

		(aRequest == #recentChangeSet) ifTrue:
			[aString _ ChangeSorter mostRecentChangeSetWithChangeForClass: self selectedClassOrMetaClass selector: self selectedMessageName.
			aString size > 0 ifTrue: [toShow nextPutAll: aString, separator]].

		(aRequest == #allChangeSets) ifTrue:
			[aList _ ChangeSorter allChangeSetsWithClass: self selectedClassOrMetaClass selector: self selectedMessageName.
			aList size > 0
				ifTrue:
					[aList size = 1
						ifTrue:
							[toShow nextPutAll: 'only in change set ']
						ifFalse:
							[toShow nextPutAll: 'in change sets: '].
					aList do:
						[:aChangeSet | toShow nextPutAll: aChangeSet name, ' ']]
				ifFalse:
					[toShow nextPutAll: 'in no change set'].
			toShow nextPutAll: separator]].
		
	^ toShow contents! !


