'From Squeak 2.3 of January 14, 1999 on 6 April 1999 at 10:11:09 am'!
"Change Set:		sqkPagePerf-tkJZ
Date:			6 April 1999
Author:			Ted Kaehler

	SqueakPages that are out are represented by a "MorphObjectOut".  It is class that does not understand anything.  In response to any message, it takes its URL, brings in the real object, and then performs the original message on it.
	We recently fixed a bug in perform:.  If you wanted to perform (super + 4), there was no way to prevent (+ 4) being sent to 'self' first.  Dan fixed this by supplying the lookupClass of the message to perform:.  
	The error is that the last lookupClass is MorphObjectOut, and the PasteUpMorph just brought in does not have that in its superclass chain.  This fix is to call the old kind of perform from MorphObjectOut and ObjectOut."!


!ObjectOut methodsFor: 'fetch from disk' stamp: 'tk 4/6/1999 10:01'!
doesNotUnderstand: aMessage 
	"Bring in the object, install, then resend aMessage"
	| realObject oldFlag response |
	oldFlag _ recursionFlag.
	recursionFlag _ true.
	"fetch the object"
	realObject _ self xxxFetch.		"watch out for the become!!"
			"Now we ARE the realObject"
	oldFlag == true ifTrue: [
		response _ (PopUpMenu labels: 'proceed normally\debug' withCRs)
			startUpWithCaption: 'Object being fetched for a second time.
Should not happen, and needs to be fixed later.'.
		response = 2 ifTrue: [self halt]].	"We are already the new object"

	"Can't be a super message, since this is the first message sent to this object"
	^ realObject perform: aMessage selector withArguments: aMessage arguments! !


!MorphObjectOut methodsFor: 'as yet unclassified' stamp: 'tk 4/6/1999 10:00'!
doesNotUnderstand: aMessage 
	"Bring in the object, install, then resend aMessage"
	| aMorph myUrl oldFlag response |
	"Transcript show: thisContext sender selector; cr." "useful for debugging"
	oldFlag _ recursionFlag.
	recursionFlag _ true.
	myUrl _ url.	"can't use inst vars after become"
	"fetch the object"
	aMorph _ self xxxFetch.		"watch out for the become!!"
			"Now we ARE a MORPH"
	oldFlag == true ifTrue: [
		response _ (PopUpMenu labels: 'proceed normally\debug' withCRs)
			startUpWithCaption: 'Object being fetched for a second time.
Should not happen, and needs to be fixed later.'.
		response = 2 ifTrue: [self halt]].	"We are already the new object"

	aMorph setProperty: #SqueakPage toValue: 
			(SqueakPageCache pageCache at: myUrl).
	"Can't be a super message, since this is the first message sent to this object"
	^ aMorph perform: aMessage selector withArguments: aMessage arguments
! !


