'From Squeak 2.3 of January 14, 1999 on 19 April 1999 at 4:14:24 am'!
"Change Set:		B3DMiscTweaks-ar
Date:			18 April 1999
Author:			Andreas Raab

Misc tweaks for Balloon 3D including a modified warning in Wonderland>>new, fixes to the rasterizer if a morph is contained by a hand and the removal of the old simulated rasterizer."!

B3DEnginePart subclass: #B3DRenderEngine
	instanceVariableNames: 'vertexBuffer transformer shader clipper rasterizer '
	classVariableNames: 'PreferOSMesa '
	poolDictionaries: ''
	category: 'Balloon-3D-Engine'!

!B3DPrimitiveRasterizer methodsFor: 'initialize' stamp: 'ar 4/19/1999 04:10'!
canvas: aCanvas
	| bb span sourceForm destForm |
	canvas _ aCanvas.
	span _ Bitmap new: 2048.
	sourceForm _ Form extent: span size@1 depth: 32 bits: span.
	destForm _ aCanvas form.
	bb _ BitBlt toForm: destForm.
	bb sourceForm: sourceForm.
	bb colorMap: (sourceForm colormapIfNeededForDepth: destForm depth).
	bb combinationRule: (destForm depth >= 8 ifTrue:[34] ifFalse:[Form paint]).
	bb clipRect: (aCanvas clipRect translateBy: aCanvas origin).
	bb destX: 0; destY: 0; sourceX: 0; sourceY: 0; width: 1; height: 1.
	state spanBuffer: span.
	state bitBlt: bb.! !

!B3DPrimitiveRasterizer methodsFor: 'processing' stamp: 'ar 4/18/1999 09:34'!
clearViewport: aColor
	canvas ifNotNil:[canvas fillRectangle: (viewport translateBy: canvas origin negated) color: aColor asColor]! !


!B3DRenderEngine class methodsFor: 'instance creation'!
defaultForPlatformOn: aForm
	"Return the render engine that is most appropriate for the current host platform.
	If aForm is nil, then the engine may render directly onto the host window.
	For now, we only have the choice between OSMesa (if preferred and available),
	a primitive accellerated and the fully simulated version"
	(self preferOSMesa and:[OSMesaRenderEngine isAvailableFor: aForm])
		ifTrue:[^OSMesaRenderEngine].
	(B3DPrimitiveEngine isAvailableFor: aForm) ifTrue:[^B3DPrimitiveEngine].
	^B3DRenderEngine! !

!B3DRenderEngine class methodsFor: 'accessing'!
preferOSMesa
	^PreferOSMesa == true! !

!B3DRenderEngine class methodsFor: 'accessing'!
preferOSMesa: aBool
	"B3DRenderEngine preferOSMesa: true"
	"B3DRenderEngine preferOSMesa: false"
	PreferOSMesa _ aBool.! !


!B3DSimulRasterizer methodsFor: 'processing' stamp: 'ar 4/19/1999 04:12'!
clearViewport: aColor
	canvas ifNotNil:[canvas fillRectangle: (viewport translateBy: canvas origin negated) color: aColor asColor]! !


!B3DSimulRasterizer class methodsFor: 'testing'!
isAvailable
	^true "Always"! !


!OSMesaRasterizer methodsFor: 'accessing' stamp: 'ar 4/18/1999 09:38'!
viewport: vp
	canvas == nil
		ifTrue:[super viewport: vp]
		ifFalse:[super viewport: (vp translateBy: canvas origin)].! !


!Wonderland class methodsFor: 'instance creation'!
new   "Wonderland new" 
	"Create and initialize a new Wonderland."
	B3DPrimitiveEngine isAvailable ifFalse:[
	(self confirm: 'Wonderland is a work in progress.
In the absence of 3D primitive display support,
it will probably be too slow to be interesting.
Do you want to try anyway?') ifFalse: [^ self]].
	Display depth < 8 ifTrue:
		[(self confirm: 'The display depth should at least be set to 8 bit.
Shall I do this now for you?') ifTrue: [Display newDepth: 8]].
	^ super new initialize
! !


Smalltalk removeClassNamed: #B3DSqueakFormRasterizer!
