'From Squeak3.1alpha of 7 February 2001 [latest update: #3570] on 12 February 2001 at 5:05:11 pm'!
"Change Set:		slightlyOpenFlap-sw
Date:			12 February 2001
Author:			Scott Wallace

A click on the tab of a flap that is only slightly open will now fully open it, rather than imperceptibly closing it."!


!FlapTab methodsFor: 'show & hide' stamp: 'sw 2/12/2001 16:49'!
lastReferentThickness: anInteger
	"Set the last remembered referent thickness to the given integer"

	lastReferentThickness _ anInteger! !

!FlapTab methodsFor: 'show & hide' stamp: 'sw 2/12/2001 16:59'!
openFully
	"Make an educated guess at how wide or tall we are to be, and open to that thickness"

	| thickness amt |
	thickness _ referent boundingBoxOfSubmorphs extent max: (100 @ 100).
	self applyThickness: (amt _ self orientation == #horizontal
			ifTrue:
				[thickness y]
			ifFalse:
				[thickness x]).
	self lastReferentThickness: amt.
	self showFlap! !

!FlapTab methodsFor: 'show & hide' stamp: 'sw 2/12/2001 17:04'!
tabSelected
	"The user clicked on the tab.  Show or hide the flap.  Try to be a little smart about a click on a tab whose flap is open but only just barely."

	dragged == true ifTrue:
		[^ dragged _ false].
	self flapShowing
		ifTrue:
			[self referentThickness < 23  "an attractive number"
				ifTrue:
					[self openFully]
				ifFalse:
					[self hideFlap]]
		ifFalse:
			[self showFlap]! !

