'From Squeak3.1alpha [latest update: #''Squeak3.1alpha'' of 28 February 2001 update 3921] on 10 April 2001 at 8:06:39 pm'!
"Change Set:		scriptFix-sw
Date:			10 April 2001
Author:			Scott Wallace

Fixes bug mentioned by Andreas relating to test/yes/no complexes."!


!MethodInterface methodsFor: 'initialization' stamp: 'sw 4/10/2001 16:36'!
conjuredUpFor: aSelector class: aClass
	"Initialize the receiver to have the given selector, obtaining whatever info one can from aClass.  This basically covers the situation where no formal definition has been made."

	| parts |
	self initializeFor: aSelector.
	elementWording _ aSelector.
	receiverType _ #unknown.
	parts _ aClass formalHeaderPartsFor: aSelector.
	argumentVariables _ (1 to: selector numArgs) collect:
		[:anIndex | Variable new name: (parts at: (4 * anIndex)) type: #object].
	parts last isEmptyOrNil ifFalse: [self documentation: parts last].
! !


!MethodWithInterface methodsFor: 'initialization' stamp: 'sw 4/10/2001 16:43'!
playerClass: aPlayerClass selector: aSelector
	"Set the playerClass and selector of the receiver"

	playerClass _ aPlayerClass.
	selector _ aSelector.
	elementWording _ aSelector! !


!Player class methodsFor: 'housekeeping' stamp: 'sw 4/10/2001 20:03'!
cleanseScriptsOfNilKeys
	"If, owing to an earlier bug, the receiver's scripts dictionary has a nil key, remove that offender before he causes more trouble"

	scripts ifNotNil:
		[scripts removeKey: nil ifAbsent: []]! !


!ScriptEditorMorph methodsFor: 'other' stamp: 'sw 4/10/2001 18:56'!
userScriptObject
	"Answer the user-script object associated with the receiver"

	| aPlayerScripted topEd |
	aPlayerScripted _ (topEd _ self topEditor) playerScripted.
	^ aPlayerScripted class userScriptForPlayer: aPlayerScripted selector: topEd scriptName ! !

"Postscript:"
Player class allSubInstancesDo:
	[:aUniclass | aUniclass cleanseScriptsOfNilKeys].!

