'From Squeak3.1alpha of 12 February 2001 [latest update: #3996] on 9 May 2001 at 6:23:57 pm'!
"Change Set:		loadActor-bf
Date:			9 May 2001
Author:			Bert Freudenberg

Adds a 'Load actor' menu entry for Wonderlands which pops up a file list. Accessible from the camera morph or from the wonderland browser's scene menu. Of course, you can also send #loadActor to the scene or the wonderland"!


!Wonderland methodsFor: 'creating' stamp: 'bf 5/9/2001 18:11'!
loadActor
	| strm filename |
	"Why does this open the file? Hrmpf."
	strm _ FileList2 modalFileSelectorForSuffixes: #('mdl' 'wrl' '3ds').
	strm ifNil: [^nil].
	filename _ strm name.
	strm close.
	(filename endsWith: 'mdl')
		ifTrue: [^ self makeActorFrom: filename].
	(filename endsWith: 'wrl')
		ifTrue: [^ self makeActorFromVRML: filename].
	(filename endsWith: '3ds')
		ifTrue: [^ self makeActorFrom3DS: filename].
	self error: 'Huh?'! !


!WonderlandActorBrowser methodsFor: 'actor list functions' stamp: 'bf 5/9/2001 17:29'!
actorMenu: aMenu
	"Builds the menu to display when the user right clicks on an actor"

 	selectedActor ifNil: [ ^ aMenu ].

	(selectedActor isKindOf: WonderlandScene)
		ifTrue: [ ^ aMenu addList: { { 'Load actor'. #loadActor } } ].

	(selectedActor isFirstClass)
		ifTrue: [
			^ aMenu addList: {
								{'Point camera at'. #pointAt}.
								{'Turn around once'. #turnAround}.
								{'Become part'. #becomePart }.
								{'Stand up'. #standUp}.
								{'Grow'. #grow}.
								{'Shrink'. #shrink}.
								{'Squash'. #squash}.
								{'Stretch'. #stretch}.
								{'Destroy'. #destroy}
							  }.
				]
		ifFalse: [
			^ aMenu addList: {
								{'Point camera at'. #pointAt}.
								{'Turn around once'. #turnAround}.
								{'Become first class'. #becomeFirstClass }.
								{'Stand up'. #standUp}.
								{'Grow'. #grow}.
								{'Shrink'. #shrink}.
								{'Squash'. #squash}.
								{'Stretch'. #stretch}.
								{'Destroy'. #destroy}
							  }.
				].
! !

!WonderlandActorBrowser methodsFor: 'actor menu functions' stamp: 'bf 5/9/2001 18:04'!
loadActor
	"Load an actor from file. Sent for WonderlandScenes"

	selectedActor loadActor.
! !


!WonderlandCameraMorph methodsFor: 'menu' stamp: 'bf 5/9/2001 18:07'!
addCustomMenuItems: aCustomMenu hand: aHandMorph 
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu addUpdating: #snapshotBackgroundString action: #toggleSnapshotBackground.
	aCustomMenu addUpdating: #getDragAndDropState action: #toggleDragAndDropState.
	(myControls == nil)
		ifTrue:[aCustomMenu add: 'showCameraControls' action: #showCameraControls]
		ifFalse:[aCustomMenu add: 'hideCameraControls' action: #deleteCameraControls].
	aCustomMenu add: 'Stop/Go button' action: #attachStopGoButtons.
	aCustomMenu add: 'Load actor' action: #loadActor.! !

!WonderlandCameraMorph methodsFor: 'menu' stamp: 'bf 5/9/2001 18:07'!
loadActor
	myWonderland loadActor! !


!WonderlandScene methodsFor: 'accessing' stamp: 'bf 5/9/2001 18:05'!
loadActor
	^ myWonderland loadActor! !

