'From Squeak3.1alpha of 28 February 2001 [latest update: #3998] on 9 May 2001 at 4:16:51 pm'!
"Change Set:		WnldGraphicSlot-ar
Date:			9 May 2001
Author:			Andreas Raab

Introduces a 'virtual graphic' slot for WonderlandActors. The slot can be used to assign textures to Wonderland objects; this in turn can be used to animate textures of Actors."!


!Vocabulary class methodsFor: 'access' stamp: 'ar 5/9/2001 16:15'!
removeVocabularyNamed: aVocabularyName
	"Add a vocabulary to the list of standard vocabularies"

	self allVocabularies.  "Assures initialization"
	AllVocabularies _ AllVocabularies reject:[:each| each vocabularyName = aVocabularyName].! !

!Vocabulary class methodsFor: 'testing and demo' stamp: 'ar 5/9/2001 15:49'!
newWonderlandVocabulary
	"Answer a Wonderland vocabulary -- highly experimental"
	| aVocabulary  |
	aVocabulary _ Vocabulary new vocabularyName: #WonderlandVocabulary.
	aVocabulary documentation: 'A simple vocabulary for scripting Alice objects'.
	aVocabulary initializeFromTable:  #(
		(color color: () color (basic color) 'The color of the object' unused updating)
		"--"
		(getX setX: () number (basic geometry) 'The x position' unused updating)
		(getY setY: () number (basic geometry) 'The y position' unused updating)
		(getZ setZ: () number (basic geometry) 'The z position' unused updating)
		"--"
		(width setWidth: () number (geometry) 'The width of the object' unused updating)
		(height setHeight: () number (geometry) 'The height of the object' unused updating)
		(depth setDepth: () number (geometry) 'The depth of the object' unused updating)
		"--"
		(heading setHeading: () number (basic geometry) 'The heading of the object' unused updating)
		(forwardBy: unused ((distance number)) none (basic motion) 'Moves the object by the specified distance' 'forward by')
		(turnBy: unused ((angle number)) none (basic motion) 'Turns the object by the specified number of degrees' 'turn by')
		(graphic setGraphic: () graphic (basic graphics) 'The picture currently being worn' unused updating)
		(emptyScript unused () none (scripts) 'The empty script')
	).
	^ aVocabulary
"Vocabulary initialize"
! !


!WonderlandActor methodsFor: 'eToy-basic' stamp: 'ar 5/9/2001 15:43'!
graphic
	| ff |
	ff _ self getTexturePointer.
	ff isForm ifTrue:[^ff].
	ff isMorph ifTrue:[^ff imageForm].
	^ScriptingSystem formAtKey: #Paint
! !

!WonderlandActor methodsFor: 'eToy-basic' stamp: 'ar 5/9/2001 15:45'!
setGraphic: aGraphicalObject
	aGraphicalObject isForm ifTrue:[
		^self setTexturePointer: aGraphicalObject.
	].
	aGraphicalObject isMorph ifTrue:[
		^aGraphicalObject installAsWonderlandTextureOn: self.
	].! !

"Postscript:
Dump the old Wonderland vocabulary."
Vocabulary removeVocabularyNamed: #WonderlandVocabulary.!

