'From Squeak3.1alpha of 28 February 2001 [latest update: #4202] on 16 July 2001 at 2:33:38 pm'!
"Change Set:		openViewer-sw
Date:			16 July 2001
Author:			Scott Wallace

Adds a new menu item, 'open this object's Viewer', to the line menu in the All-Scripts tool, affording the user immediate access to the Viewer of any object which has a script seen in the tool.
Also, a couple of minor appearance tweaks to the All-Scripts tool."!


!Morph methodsFor: 'menus' stamp: 'sw 7/16/2001 14:31'!
dismissButton
	"Answer a button whose action would be to dismiss the receiver, and whose action is to send #delete to the receiver"

	| aButton |
	aButton _ SimpleButtonMorph new.
	aButton
		target: self topRendererOrSelf;
		color:  Color tan;
		label: 'O' font: Preferences standardButtonFont;
		actionSelector: #delete;
		setBalloonText: 'dismiss'.
	^ aButton! !

!Morph methodsFor: 'menus' stamp: 'sw 7/16/2001 14:26'!
helpButton
	"Answer a button whose action would be to put up help concerning the receiver"

	| aButton |
	aButton _ SimpleButtonMorph new.
	aButton
		target: self;
		color:  Color magenta lighter lighter;
		label: '?' font: Preferences standardButtonFont;
		actionSelector: #presentHelp;
		setBalloonText: 'click here for help'.
	^ aButton! !


!ScriptInstantiation methodsFor: 'misc' stamp: 'sw 7/16/2001 13:54'!
offerMenuIn: aStatusViewer
	"Put up a menu."

	| aMenu |
	aMenu _ MenuMorph new defaultTarget: self.
	(player class instanceCount > 1) ifTrue:
		[aMenu add: 'propagate status to siblings' selector: #assignStatusToAllSiblingsIn: argument: aStatusViewer.
		aMenu balloonTextForLastItem: 'Make the status of this script in all of my sibling instances be the same as the status you see here'].
	aMenu add: 'grab this object' target: player selector: #grabPlayerIn: argument: self currentWorld.
	aMenu add: 'open this script''s scriptor' target: player selector: #grabScriptorForSelector:in: argumentList: {selector. aStatusViewer world}.
	aMenu add: 'open this object;''s Viewer' target: player selector: #beViewed.
	aMenu popUpInWorld: self currentWorld! !

Morph removeSelector: #ilmalmerhelpButton!
