'From Squeak3.1alpha of 7 March 2001 [latest update: #4332] on 15 September 2001 at 4:35:17 pm'!
"Change Set:		BrowserLabels-SD-dew
Date:			15 September 2001
Author:			Stephane Ducasse and Doug Way

Cleans up the titlebar labels of various non-system browsers when classes are selected (Hierarchy Browser, FileContentsBrowser)."!


!CodeHolder methodsFor: 'commands' stamp: 'dew 9/15/2001 16:24'!
spawnHierarchy
	"Create and schedule a new class hierarchy browser on the currently selected class or meta."
	| newBrowser aSymbol aBehavior messageCatIndex selectedClassOrMetaClass |
	(selectedClassOrMetaClass _ self selectedClassOrMetaClass) ifNil: [^ self].
	newBrowser _ HierarchyBrowser new initHierarchyForClass: selectedClassOrMetaClass.
	(aSymbol _ self selectedMessageName) ifNotNil:
		[aBehavior _ selectedClassOrMetaClass.
		messageCatIndex _ aBehavior organization numberOfCategoryOfElement: aSymbol.
		newBrowser messageCategoryListIndex: messageCatIndex + 1.
		newBrowser messageListIndex:
			((aBehavior organization listAtCategoryNumber: messageCatIndex)
						indexOf: aSymbol)].
	Browser openBrowserView: (newBrowser openSystemCatEditString: nil)
		label: newBrowser labelString! !


!Browser class methodsFor: 'instance creation' stamp: 'SD 9/15/2001 15:18'!
openBrowser
	"Create and schedule a BrowserView with default browser label. The
	view consists of five subviews, starting with the list view of system
	categories of SystemOrganization. The initial text view part is empty."

	| br |
	br := self new.
	self
		openBrowserView: (br openEditString: nil)
		label: br defaultBrowserTitle
! !


!FileContentsBrowser methodsFor: 'initialize-release' stamp: 'dew 9/15/2001 16:19'!
defaultBrowserTitle
	^ 'File Contents Browser'! !


!HierarchyBrowser methodsFor: 'initialization' stamp: 'dew 9/15/2001 16:19'!
defaultBrowserTitle
	^ 'Hierarchy Browser'! !


!HierarchyBrowser class methodsFor: 'as yet unclassified' stamp: 'dew 9/15/2001 16:19'!
newFor: aClass
	"Open a new HierarchyBrowser on the given class"
	|  newBrowser |
	newBrowser _ HierarchyBrowser new initHierarchyForClass: aClass.
	Browser openBrowserView: (newBrowser openSystemCatEditString: nil)
		label: newBrowser labelString

"HierarchyBrowser newFor: Boolean"! !

PackagePaneBrowser class removeSelector: #openBrowser!
