'From Squeak3.1alpha of 5 February 2001 [latest update: #4361] on 1 October 2001 at 10:54:54 pm'!
"Change Set:		PostHarvest
Date:			1 October 2001
Author:			Dan Ingalls

A couple of tweaks to the recent spate of harvested fixes and enhancements.  These were mostly suggested by Scott Wallace.

ChasePointersMenu-dew.cs
CodeHolder method #fieldListMenuForCollection:... was removed back in update 3871 as part of a menu refactoring, and it no longer has any senders.  Removed again, therefore.

FileContentBrowser-BJP.cs
The new #selectedBytecodes method added in this fileout is elevated to CodeHolder, and invoked by CodeHolder.contents and MessageSet.contents.

BrowseLocal-nk.cs
The following familiar foursome has been reinstated:
	senders of...
	implementors of...
	inheritance
	versions
with the new 'local' items moved to the shifted (more...) menu.  The 'tile scriptor' item has been similarly relegated to the (more...) menu.
"!


!CodeHolder methodsFor: 'contents' stamp: 'di 10/1/2001 22:25'!
contents
	"Answer the source code or documentation for the selected method"

	self showingByteCodes ifTrue:
		[^ self selectedBytecodes].

	self showingDocumentation ifTrue:
		[^ self commentContents].

	^ self selectedMessage! !

!CodeHolder methodsFor: 'message list' stamp: 'di 10/1/2001 22:16'!
selectedBytecodes
	^ (self selectedClassOrMetaClass compiledMethodAt: self selectedMessageName) symbolic asText! !


!Browser methodsFor: 'message functions' stamp: 'di 10/1/2001 22:45'!
messageListMenu: aMenu shifted: shifted
	"Answer the message-list menu"

	shifted ifTrue: [^ self shiftedMessageListMenu: aMenu].
	aMenu addList:#(
			('what to show...'						offerWhatToShowMenu)
			-
			('browse full (b)' 						browseMethodFull)
			('browse hierarchy (h)'					classHierarchy)
			('browse method (O)'					openSingleMessageBrowser)
			('browse protocol (p)'					browseFullProtocol)
			-
			('fileOut (o)'							fileOutMessage)
			('printOut'								printOutMessage)
			-
			('senders of... (n)'						browseSendersOfMessages)
			('implementors of... (m)'					browseMessages)
			('inheritance (i)'						methodHierarchy)
			('versions (v)'							browseVersions)
			-
			('inst var refs...'						browseInstVarRefs)
			('inst var defs...'						browseInstVarDefs)
			('class var refs...'						browseClassVarRefs)
			('class variables'						browseClassVariables)
			('class refs (N)'							browseClassRefs)
			-
			('remove method (x)'					removeMessage)
			-
			('more...'								shiftedYellowButtonActivity)).
	^ aMenu! !

!Browser methodsFor: 'message functions' stamp: 'di 10/1/2001 22:49'!
shiftedMessageListMenu: aMenu
	"Fill aMenu with the items appropriate when the shift key is held down"

	aMenu addList: #(
		('method pane' 							makeIsolatedCodePane)
		('tile scriptor'							openSyntaxView)
		"('make a scriptor'						makeScriptor)"
		('toggle diffing (D)'						toggleDiffing)
		('implementors of sent messages'			browseAllMessages)
		-
		('local senders of...'						browseLocalSendersOfMessages)
		('local implementors of...'				browseLocalImplementors)
		-
		('spawn sub-protocol'					spawnProtocol)
		('spawn full protocol'					spawnFullProtocol)
		-
		('sample instance'						makeSampleInstance)
		('inspect instances'						inspectInstances)
		('inspect subinstances'					inspectSubInstances)).

	self addExtraShiftedItemsTo: aMenu.
	aMenu addList: #(
		-
		('change category...'					changeCategory)
		-
		('change sets with this method'			findMethodInChangeSets)
		('revert to previous version'				revertToPreviousVersion)
		('remove from current change set'		removeFromCurrentChanges)
		('revert & remove from changes'		revertAndForget)
		('add to current change set'				adoptMessageInCurrentChangeset)
		('copy up or copy down...'				copyUpOrCopyDown)
		-
		('fetch documentation'					fetchDocPane)
		('more...' 								unshiftedYellowButtonActivity)).
	^ aMenu
! !


!MessageSet methodsFor: 'contents' stamp: 'di 10/1/2001 22:26'!
contents
	"Answer the contents of the receiver"

	^ contents == nil
		ifTrue: [currentCompiledMethod _ nil. '']
		ifFalse: [messageListIndex = 0 
			ifTrue: [currentCompiledMethod _ nil. contents]
			ifFalse: [self showingByteCodes
				ifTrue: [self selectedBytecodes]
				ifFalse: [self selectedMessage]]]! !

Inspector removeSelector: #fieldListMenuForCollection:!
Browser removeSelector: #selectedBytecodes!
