'From Squeak3.2gamma of 15 January 2002 [latest update: #4857] on 9 May 2002 at 4:07:37 pm'!
"Change Set:		archiveViewerFix-nk
Date:			9 May 2002
Author:			Ned Konz

If you have non-standard fonts installed, the button
font may be chosen incorrectly. This change set
fixes this problem.

It also sets the minimum width accordingly.
"!


!ArchiveViewer methodsFor: 'initialization' stamp: 'nk 5/9/2002 16:00'!
createButtonBar
	| bar button narrowFont |
	narrowFont _ StrikeFont allSubInstances detectMin: [ :ea | ea widthOfString: 'Contents' from: 1 to: 8 ].
	bar _ AlignmentMorph newRow.
	bar color: self backgroundColor;
		rubberBandCells: false;
		vResizing: #shrinkWrap;
		cellInset: 6@0.
	#(
	#( 'New\Archive' canCreateNewArchive createNewArchive 'Create a new, empty archive and discard this one' )
	#( 'Load\Archive' canOpenNewArchive openNewArchive 'Open another archive and discard this one' )
	#( 'Save\Archive As' canSaveArchive saveArchive 'Save this archive under a new name' )
	#( 'Extract\All' canExtractAll extractAll 'Extract all this archive''s members into a directory' )
	#( 'Add\File' canAddMember addMember 'Add a file to this archive' )
	#( 'Add from\Clipboard' canAddMember addMemberFromClipboard 'Add the contents of the clipboard as a new file' )
	#( 'Add\Directory' canAddMember addDirectory 'Add the entire contents of a directory, with all of its subdirectories' )
	#( 'Extract\Member As' canExtractMember extractMember 'Extract the selected member to a file' )
	#( 'Delete\Member' canDeleteMember deleteMember 'Remove the selected member from this archive' )
	#( 'Rename\Member' canRenameMember renameMember 'Rename the selected member' )
	#( 'View All\Contents' canViewAllContents changeViewAllContents 'Toggle the view of all the selected member''s contents' )
	) do: [:arr | | buttonLabel |
		buttonLabel _ (TextMorph new)
			string: arr first withCRs fontName: narrowFont familyName size: narrowFont pointSize wrap: false;
			hResizing: #shrinkWrap;
			lock;
			yourself.
		(button _ PluggableButtonMorph on: self getState: arr second action: arr third)
			vResizing: #shrinkWrap;
			hResizing: #spaceFill;
			onColor: self buttonOnColor offColor: self buttonOffColor;
			label: buttonLabel;
			setBalloonText: arr fourth;
			yourself.
		bar addMorphBack: button.
		buttonLabel composeToBounds].
	^ bar.
! !

!ArchiveViewer methodsFor: 'initialization' stamp: 'nk 5/9/2002 16:05'!
createWindow
	| list heading font text buttonBar |
	self color: self backgroundColor.

	font _ (TextStyle named: #DefaultFixedTextStyle)
		ifNotNilDo: [ :ts | ts fontArray first].

	buttonBar _ self createButtonBar.
	self addMorph: buttonBar
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1.0@0.0) offsets: (0@0 corner: 0@44)).

	self minimumExtent: (buttonBar fullBounds width + 20) @ 230.
	self extent: self minimumExtent.

	heading _ self createListHeadingUsingFont: font.
	self addMorph: heading
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1.0@0.0) offsets: (0@44 corner: 0@60)).

	(list _ PluggableListMorph new)
		on: self list: #memberList
		selected: #memberIndex changeSelected: #memberIndex:
		menu: #memberMenu:shifted: keystroke: nil.
	list color: self backgroundColor.
	font ifNotNil: [list font: font].
	self addMorph: list
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1.0@0.8) offsets: (0@60 corner: 0@0)).

	text _ PluggableTextMorph on: self 
			text: #contents accept: nil
			readSelection: nil menu: nil.
	self addMorph: text
		frame: (0@0.8 corner: 1.0@1.0).
	text lock.

	self setLabel: 'Ned''s Zip Viewer'! !

