'From Squeak3.2gamma of 15 January 2002 [latest update: #4889] on 27 June 2002 at 10:13:14 am'!
"Change Set:		selDropFix-nk
Date:			27 June 2002
Author:			Ned Konz

27 June: fixed dropping into translated coordinate systems.

This fixes some problems with SelectionMorphs and the TrashCan:

1. drops of SelectionMorphs always did addMorphFront: on their selection. This CS fixes drops to do individual drops on the selected items.

2. halo deletion of SelectionMorphs did not properly trash the selected items. This fix is from Masato Sumi.

3. SelectionMorph had a hard-coded reference to its class, which makes it hard to subclass.

"!


!HaloMorph methodsFor: 'events' stamp: 'nk 6/26/2002 07:19'!
handleListenEvent: anEvent
	"We listen for possible drop events here to add back those handles after a dup/grab operation"

	(anEvent isMouse and:[anEvent isMove not]) ifFalse:[^ self]. "not interested"
	anEvent hand removeMouseListener: self. "done listening"
	(self world ifNil: [target world]) ifNil: [^ self].
	self addHandles  "and get those handles back"! !


!SelectionMorph methodsFor: 'drag and drop' stamp: 'nk 6/27/2002 10:11'!
justDroppedInto: newOwner event: evt

	selectedItems isEmpty ifTrue:
		["Hand just clicked down to draw out a new selection"
		^ self extendByHand: evt hand].
	dupLoc ifNotNil: [dupDelta _ self position - dupLoc].
	selectedItems reverseDo: [:m | 
		WorldState addDeferredUIMessage:
			[m referencePosition: (newOwner localPointToGlobal: m referencePosition).
			newOwner handleDropMorph:
				(DropEvent new setPosition: evt cursorPoint contents: m hand: evt hand)] fixTemps].
	selectedItems _ nil.
	self removeHalo; delete.
	evt wasHandled: true! !

!SelectionMorph methodsFor: 'drag and drop' stamp: 'nk 6/26/2002 08:23'!
slideToTrash: evt
	self delete.
	selectedItems do: [:m | m slideToTrash: evt]! !

!SelectionMorph methodsFor: 'halo commands' stamp: 'nk 6/26/2002 08:26'!
addOrRemoveItems: handOrEvent
	"Make a new selection extending the current one."

	| oldOwner hand |
	hand _ (handOrEvent isKindOf: HandMorph)
			ifTrue: [handOrEvent]
			ifFalse: [handOrEvent hand].
	hand addMorphBack: ((self class newBounds: (hand lastEvent cursorPoint extent: 16@16))
							setOtherSelection: self).
	oldOwner _ owner.
	self world abandonAllHalos.  "Will delete me"
	oldOwner addMorph: self! !


!TrashCanMorph methodsFor: 'event handling' stamp: 'nk 6/26/2002 08:33'!
mouseEnter: event
	"Present feedback for potential deletion."
	| hand firstSub |
	hand _ event hand.
	(((hand submorphCount > 0) and: [(firstSub _ hand submorphs first) ~~ self]) and:
			[self wantsDroppedMorph: firstSub event: event])
		ifTrue: 
			[Preferences soundsEnabled ifTrue: [self class playMouseEnterSound].
			hand visible: false.
			"self world abandonAllHalos."
			"hand halo: nil."
			self state: #pressed]
		ifFalse:
			[self showStampIn: hand]! !

