'From Squeak3.3alpha of 18 January 2002 [latest update: #4915] on 11 July 2002 at 3:36 pm'!
"Change Set:		dupNavBar-sw
Date:			11 July 2002
Author:			Scott Wallace

Removes the old navigator bar on reloaded projects if the current image requests suppression of the navbar."!


!Project methodsFor: 'flaps support' stamp: 'sw 7/11/2002 15:35'!
assureFlapIntegrity
	"Make certain that the items on the disabled-global-flap list are actually global flaps, and if not, get rid of them.  Also, old (and damaging) parameters that held references to actual disabled flaps are cleansed"

	| disabledFlapIDs currentGlobalIDs oldList |
	Smalltalk isMorphic ifTrue:
		[disabledFlapIDs _ self parameterAt: #disabledGlobalFlapIDs ifAbsent: [Set new].
		currentGlobalIDs _ Flaps globalFlapTabsIfAny collect: [:f | f flapID].
		oldList _ Project current projectParameterAt: #disabledGlobalFlaps ifAbsent: [nil].
		oldList ifNotNil:
			[disabledFlapIDs _ oldList collect: [:aFlap | aFlap flapID].
			disabledFlapIDs addAll: #('Scripting' 'Stack Tools' 'Painting')].
		disabledFlapIDs _ disabledFlapIDs select: [:anID | currentGlobalIDs includes: anID].
		self projectParameterAt: #disabledGlobalFlapIDs put: disabledFlapIDs asSet.
		self assureNavigatorPresenceMatchesPreference].

	projectParameters ifNotNil:
		[projectParameters removeKey: #disabledGlobalFlaps ifAbsent: []]! !

