'From Squeak3.4gamma of ''7 January 2003'' [latest update: #5168] on 14 January 2003 at 10:57:34 pm'!
"Change Set:		commentFixFix-sw
Date:			14 January 2003
Author:			Scott Wallace

Fixes a glitch in update 5158 that could cause problems in certain class comments after a condenseChanges.

Restores correct class comments to a couple of classes whose comments may have been compromised if condenseChanges were run in an image after update 5158clsCommentFixes was loaded into it."!


!IdentityDictionary commentStamp: 'ls 06/15/02 22:35' prior: 0!
Like a Dictionary, except that keys are compared with #== instead of #= .

See the comment of IdentitySet for more information.!
]style[(94 11 22)f1,f1LIdentitySet Comment;,f1!


!Preference commentStamp: 'sw 1/14/2003 22:33' prior: 0!
Represents a true/false flag that is under user control and which can be interrogated by a call to Preferences

	name 				a symbol, the formal name of the preference.
	value				a boolean, the current value
	defaultValue		the default value of the preference
	helpString 			string or text, constituting the help message
	localToProject		boolean, whether each project holds its own version
	categoryList			list of categories under which to offer this
	changeInformee 	whom, if anyone, to inform if the value changes:
	changeSelector 		what selector to send to the changeInformee when the value changes!


!ClassDescription methodsFor: 'fileIn/Out' stamp: 'sw 1/14/2003 15:36'!
putClassCommentToCondensedChangesFile: aFileStream
	"Called when condensing changes.  If the receiver has a class comment, and if that class comment does not reside in the .sources file, then write it to the given filestream, with the resulting RemoteString being reachable from the source file #2.  Note that any existing backpointer into the .sources file is lost by this process -- a situation that maybe should be fixed someday."

	| header aStamp aCommentRemoteStr |
	self isMeta ifTrue: [^ self].  "bulletproofing only"
	((aCommentRemoteStr _ self organization commentRemoteStr) isNil or:
		[aCommentRemoteStr sourceFileNumber == 1]) ifTrue: [^ self].

	aFileStream cr; nextPut: $!!.
	header _ String streamContents: [:strm | strm nextPutAll: self name;
		nextPutAll: ' commentStamp: '.
		(aStamp _ self organization commentStamp ifNil: ['<historical>']) storeOn: strm.
		strm nextPutAll: ' prior: 0'].
	aFileStream nextChunkPut: header.
	aFileStream cr.
	organization classComment: (RemoteString newString: self organization classComment onFileNumber: 2 toFile: aFileStream) stamp: aStamp! !

