'From Squeak3.6beta of ''4 July 2003'' [latest update: #5331] on 7 July 2003 at 6:41:54 pm'!
"Change Set:		ImageReaderDepFix-nk
Date:			7 July 2003
Author:			Ned Konz

This is a fix for three deprecated methods in SystemDictionary (imageReaderClass, gifReaderClass, and jpegReaderClass) that offered no suggestion as to alternatives.

And it also fixes their callers to refer directly to the classes in question.
"!


!Form class methodsFor: 'instance creation' stamp: 'nk 7/7/2003 18:19'!
fromBinaryStream: aBinaryStream
	"Read a Form or ColorForm from given file, using the first byte of the file to guess its format. Currently handles: GIF, uncompressed BMP, and both old and new DisplayObject writeOn: formats, JPEG, and PCX. Return nil if the file could not be read or was of an unrecognized format."

	| firstByte |
	aBinaryStream binary.
	firstByte _ aBinaryStream next.
	firstByte = 1 ifTrue: [
		"old Squeakform format"
		^ self new readFromOldFormat: aBinaryStream].
	firstByte = 2 ifTrue: [
		"new Squeak form format"
		^ self new readFrom: aBinaryStream].

	"Try for JPG, GIF, or PCX..."
	"Note: The following call closes the stream."
	^ ImageReadWriter formFromStream: aBinaryStream
! !


!HTTPSocket class methodsFor: 'get the page' stamp: 'nk 7/7/2003 18:36'!
httpGif: url
	"Fetch the given URL, parse it using the GIF reader, and return the resulting Form."
	"	HTTPSocket httpShowGif: 'www.altavista.digital.com/av/pix/default/av-adv.gif'	 "
	"	HTTPSocket httpShowGif: 'www.webPage.com/~kaehler2/ainslie.gif'	 "

	| doc ggg |
	doc _ self httpGet: url accept: 'image/gif'.
	doc class == String ifTrue: [
		self inform: 'The server with that GIF is not responding'.
		^ ColorForm extent: 20@20 depth: 8].
	doc binary; reset.
	(ggg _ GIFReadWriter new) setStream: doc.
	^ ggg nextImage.
! !

!HTTPSocket class methodsFor: 'get the page' stamp: 'nk 7/7/2003 18:37'!
httpJpeg: url
	"Fetch the given URL, parse it using the JPEG reader, and return the resulting Form."

	| doc ggg |
	doc _ self httpGet: url.
	doc binary; reset.
	(ggg _ JPEGReadWriter new) setStream: doc.
	^ ggg nextImage.
! !


!SystemDictionary methodsFor: 'deprecated' stamp: 'nk 7/7/2003 18:36'!
gifReaderClass
	"Answer, if present, a class to handle the importing of GIF files from disk.
	If none, return nil."

	self deprecatedExplanation: 'refer directly to GIFReadWriter.'.
	^self at: #GIFReadWriter ifAbsent: [nil]! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'nk 7/7/2003 18:24'!
imageReaderClass
	"Answer, if present, a class to handle the importing of various graphic image files
	from disk. If none, return nil.
	It's not clear what the old logic that checked for ImageReader
	actually being a class was trying to fix."

	self deprecatedExplanation: 'refer directly to ImageReadWriter.'.
	^self at: #ImageReadWriter ifAbsent: [nil]! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'nk 7/7/2003 18:40'!
jpegReaderClass
	"Answer, if present, a class to handle the importing of JPEG files from disk.
	If none, return nil."

	self deprecatedExplanation: 'refer directly to JPEGReadWriter.'.
	^self at: #JPEGReadWriter ifAbsent: [nil]! !

