'From Squeak3.7alpha of ''11 September 2003'' [latest update: #5657] on 19 January 2004 at 9:29:54 pm'!
"Change Set:		KCP-148-moveBrowseUncommentedToSystemNavigation
Date:			19 January 2004
Author:			stephane ducasse

moveBrowseUncommentedToSystemNavigation"!


!SystemNavigation methodsFor: 'browse' stamp: 'sd 1/19/2004 21:16'!
browseUncommentedMethodsWithInitials: targetInitials
	"Browse uncommented methods whose initials (in the time-stamp, as logged to disk) match the given initials.  Present them in chronological order.  CAUTION: It will take several minutes for this to complete."
	"Time millisecondsToRun: [SystemNavigation default browseUncommentedMethodsWithInitials: 'jm']"

	| initials timeStamp methodReferences cm aMessageSet |
	methodReferences _ OrderedCollection new.
	self  allBehaviorsDo:
		[:aClass | aClass selectors do: [:sel |
			cm _ aClass compiledMethodAt: sel.
			timeStamp _ Utilities timeStampForMethod: cm.
			timeStamp isEmpty ifFalse:
				[initials _ timeStamp substrings first.
				initials first isDigit ifFalse:
					[((initials = targetInitials) and: [(aClass firstPrecodeCommentFor: sel) isNil])
						ifTrue:
							[methodReferences add: (MethodReference new
								setStandardClass: aClass 
								methodSymbol: sel)]]]]].

	aMessageSet _ MessageSet new initializeMessageList: methodReferences.
	aMessageSet sortByDate.
	MessageSet 
		openMessageList: aMessageSet 
		messageList name: 'Uncommented methods with initials ', targetInitials! !


!Utilities class methodsFor: 'identification' stamp: 'sd 1/19/2004 21:18'!
browseUncommentedMethodsWithInitials: targetInitials

	self deprecated: 'Use SystemNavigation default browseUncommentedMethodsWithInitials: targetInitials'. 
	SystemNavigation default browseUncommentedMethodsWithInitials: targetInitials! !

