'From Squeak3.7-m17n of 30 June 2004 [latest update: #0] on 30 June 2004 at 5:13 pm'!

!NewParagraph methodsFor: 'private' stamp: 'edc 6/18/2004 09:10'!
moveBy: delta
	lines do: [:line | line moveBy: delta].
	positionWhenComposed ifNotNil:[
	positionWhenComposed _ positionWhenComposed + delta].
	container _ container translateBy: delta! !


!Project methodsFor: 'language' stamp: 'yo 6/30/2004 17:01'!
naturalLanguage
	"Answer the natural language for the project"

	| prev |
	^ self projectParameterAt: #naturalLanguage
		ifAbsentPut: [
			(prev _ self previousProject) ifNotNil: [
				prev projectParameterAt: #naturalLanguage ifAbsent: [#EnglishEnvironment]
			] ifNil: [
				#EnglishEnvironment
			]
		].
! !

!Project methodsFor: 'language' stamp: 'yo 6/30/2004 17:04'!
setNaturalLanguageTo: aLanguageSymbol
	"Set the project's natural language as indicated"

	| className |
	Vocabulary assureTranslationsAvailableFor: aLanguageSymbol.
	aLanguageSymbol = self naturalLanguage ifFalse: [
		self projectParameterAt: #naturalLanguage put: aLanguageSymbol.
		ActiveWorld allTileScriptingElements do: [:viewerOrScriptor |
			viewerOrScriptor setNaturalLanguageTo: aLanguageSymbol.
			Language applyTranslations]].
	className _ Vocabulary languageClassNameForLanguageSymbol: aLanguageSymbol.
	(Smalltalk at: className ifAbsent: [EnglishEnvironment]) beCurrentNaturalLanguage.
	Smalltalk primaryLanguage: className.
	Smalltalk systemLanguage: className.
	#(PartsBin ParagraphEditor BitEditor FormEditor StandardSystemController) 
		do: [ :key | Smalltalk at: key ifPresent: [ :class | class initialize ]].
	"self setFlaps.
	self setPaletteFor: aLanguageSymbol."
! !


!Vocabulary class methodsFor: 'class initialization' stamp: 'yo 6/30/2004 16:57'!
initializeLanguageTable
	"Initialize the default set of natural langauges. Others can be added dynamically by sending #setTranslationInitializ:forLanguageSymbol:"

	LanguageTable _ Dictionary new.
	#(
		(English		addEnglishVocabulary EnglishEnvironment)
		(Deutsch	addGermanVocabulary GermanEnvironment)
		(Kiswahili	addKiswahiliVocabulary EnglishEnvironment)
		(Nederlands	addDutchVocabulary EnglishEnvironment)
		(Norsk		addNorwegianVocabulary EnglishEnvironment)
		(Svenska	addSwedishVocabulary EnglishEnvironment)
		"(Japanese	addJapaneseVocabulary JapaneseEnvironment)"
		(#'Japanese(children)'	addJapaneseChildrenVocabulary JapaneseEnvironment)
	) do: [:triplet | LanguageTable at: triplet first put: (triplet copyFrom: 2 to: 3)].

	"Vocabulary initializeLanguageTable"! !

"Postscript:
"
Vocabulary initializeLanguageTable.
!

