'From Squeak3.7-m17n of 21 July 2004 [latest update: #19] on 25 July 2004 at 3:48:07 pm'!
"Change Set:		e09UnifyBasic-sw
Date:			5 July 2004
Author:			Scott Wallace

Adapted from update 0218unifyBasic-sw.cs of Squeakland.

The 'stacks with universal tiles' work that resulted in the creation of the two numbered Basic categories in the Objects tool several years ago has long since seemingly been abandoned. 

This update undoes some of the now-obsolete and now-strange consequences of that work, by merging the former Basic-1 and Basic-2 categories back into one, and by removing from the Objects Tool the offerings that rely on SyntaxMorphs.  (But if the universalTiles flag is set, the SyntaxMorph-dependent items will be seen again.)"

!


!EllipseMorph class methodsFor: 'parts bin' stamp: 'sw 7/5/2004 18:19'!
descriptionForPartsBin
	^ self partName:	'Ellipse'
		categories:		#('Graphics' ' Basic')
		documentation:	'An elliptical or circular shape'! !


!ImageMorph class methodsFor: 'parts bin' stamp: 'sw 7/5/2004 18:18'!
descriptionForPartsBin
	^ self partName:	'Image'
		categories:		#('Graphics' ' Basic')
		documentation:	'A non-editable picture.  If you use the Paint palette to make a picture, you can edit it afterwards.'! !


!ObjectsTool methodsFor: 'miscellaneous' stamp: 'sw 7/5/2004 18:29'!
minimumWidth
	"Answer a width that assures that the alphabet fits in two rows"

	^ 267! !

!ObjectsTool methodsFor: 'miscellaneous' stamp: 'sw 7/5/2004 18:36'!
setExtentFromHalo: anExtent
	"The user has dragged the grow box such that the receiver's extent would be anExtent.  Do what's needed"

	| adjustedExtent |
	adjustedExtent _ (self minimumWidth max: anExtent x) @ anExtent y.
	modeSymbol == #search
		ifFalse:
			[submorphs second width: adjustedExtent x]
		ifTrue:
			[submorphs second firstSubmorph width: adjustedExtent x - 6].
	submorphs last height: (adjustedExtent y - (submorphs first height + submorphs second height))! !


!PaintInvokingMorph class methodsFor: 'parts bin' stamp: 'sw 7/5/2004 18:20'!
descriptionForPartsBin
	^ self partName:	'Paint'
		categories:		#(' Basic' 'Graphics')
		documentation:	'Drop this icon to start painting a new object.'! !


!PolygonMorph class methodsFor: 'instance creation' stamp: 'sw 7/5/2004 18:20'!
supplementaryPartsDescriptions
	^ {DescriptionForPartsBin
		formalName: 'Arrow'
		categoryList: #(' Basic' 'Graphics')
		documentation: 'A line with an arrowhead.  Shift-click to get handles and move the ends.'
		globalReceiverSymbol: #PolygonMorph
		nativitySelector: #arrowPrototype}
! !

!PolygonMorph class methodsFor: 'parts bin' stamp: 'sw 7/5/2004 18:21'!
descriptionForPartsBin
	^ self partName:	'Polygon'
		categories:		#('Graphics' ' Basic')
		documentation:	'A series of connected line segments, which may be a closed solid, or a zig-zag line.  Shift-click to get handles and move the points.'! !


!CurveMorph class methodsFor: 'parts bin' stamp: 'sw 7/5/2004 18:19'!
descriptionForPartsBin
	^ self partName:	'Curve'
		categories:		#('Graphics' ' Basic')
		documentation:	'A smooth wiggly curve, or a curved solid.  Shift-click to get handles and move the points.'! !

!CurveMorph class methodsFor: 'parts bin' stamp: 'sw 7/5/2004 18:19'!
supplementaryPartsDescriptions
	^ {DescriptionForPartsBin
		formalName: 'Curvy Arrow'
		categoryList: #(' Basic' 'Graphics')
		documentation: 'A curved line with an arrowhead.  Shift-click to get handles and move the points.'
		globalReceiverSymbol: #CurveMorph
		nativitySelector: #arrowPrototype}
! !


!LineMorph class methodsFor: 'parts bin' stamp: 'sw 7/5/2004 18:18'!
descriptionForPartsBin
	^ self partName:	'Line'
		categories:		#('Graphics' ' Basic')
		documentation:	'A straight line.  Shift-click to get handles and move the ends.'! !


!RectangleMorph class methodsFor: 'parts bin' stamp: 'sw 7/5/2004 18:20'!
descriptionForPartsBin
	^ self partName:	'Rectangle'
		categories:		#('Graphics' ' Basic')
		documentation:	'A rectangular shape, with border and fill style'! !

!RectangleMorph class methodsFor: 'parts bin' stamp: 'sw 7/5/2004 18:18'!
supplementaryPartsDescriptions
	^ {DescriptionForPartsBin
		formalName: 'RoundRect'
		categoryList: #('Graphics' ' Basic')
		documentation: 'A rectangle with rounded corners'
		globalReceiverSymbol: #RectangleMorph
		nativitySelector: #roundRectPrototype.

	DescriptionForPartsBin
		formalName: 'Gradient'
		categoryList: #('Graphics' ' Basic')
		documentation: 'A rectangle with a horizontal gradient'
		globalReceiverSymbol: #RectangleMorph
		nativitySelector: #gradientPrototype.

	DescriptionForPartsBin
		formalName: 'Gradient (slanted)'
		categoryList: #('Graphics' ' Basic')
		documentation: 'A rectangle with a diagonal gradient'
		globalReceiverSymbol: #RectangleMorph
		nativitySelector: #diagonalPrototype}! !


!NumericReadoutTile class methodsFor: 'instance creation' stamp: 'sw 7/5/2004 18:20'!
supplementaryPartsDescriptions
	"Answer additional items for the parts bin"

	Preferences universalTiles ifFalse: [^ #()].

	^ {DescriptionForPartsBin
		formalName: 'Number (fancy)'
		categoryList: #(' Basic')
		documentation: 'A number readout for a Stack.  Shows current value.  Click and type the value.  Shift-click on title to edit.'
		globalReceiverSymbol: #NumericReadoutTile
		nativitySelector: #authoringPrototype.

	   DescriptionForPartsBin
		formalName: 'Number (bare)'
		categoryList: #(' Basic')
		documentation: 'A number readout for a Stack.  Shows current value.  Click and type the value.'
		globalReceiverSymbol: #NumericReadoutTile
		nativitySelector: #simplePrototype.

	   DescriptionForPartsBin
		formalName: 'Number (mid)'
		categoryList: #(' Basic')
		documentation: 'A number readout for a Stack.  Shows current value.  Click and type the value.'
		globalReceiverSymbol: #NumericReadoutTile
		nativitySelector: #borderedPrototype}! !


!ScriptableButton class methodsFor: 'name' stamp: 'sw 7/5/2004 18:20'!
descriptionForPartsBin
	^ self partName:	'Button'
		categories:		#('Scripting' ' Basic')
		documentation:	'A button to use with tile scripting; its script will be a method of its containing playfield'! !


!TTSampleStringMorph class methodsFor: 'parts bin' stamp: 'sw 7/25/2004 03:51'!
descriptionForPartsBin
	^ self partName:	'TrueType banner'
		categories:		#('Text' ' Basic')
		documentation:	'A short text in a beautiful font.  Use the resize handle to change size.'! !


!TextMorph class methodsFor: 'parts bin' stamp: 'sw 7/5/2004 18:20'!
descriptionForPartsBin
	^ self partName:	'Text'
		categories:		#('Text' ' Basic')
		documentation:	'A raw piece of text which you can edit into anything you want'! !

!TextMorph class methodsFor: 'parts bin' stamp: 'sw 7/5/2004 18:20'!
supplementaryPartsDescriptions
	^ {DescriptionForPartsBin
		formalName: 'Text (border)'
		categoryList: #(' Basic' 'Text')
		documentation: 'A text field with border'
		globalReceiverSymbol: #TextMorph
		nativitySelector: #borderedPrototype.

	DescriptionForPartsBin
		formalName: 'Text (fancy)'
		categoryList: #(' Basic' 'Text')
		documentation: 'A text field with a rounded shadowed border, with a fancy font.'
		globalReceiverSymbol: #TextMorph
		nativitySelector: #fancyPrototype.}
! !


!TrashCanMorph class methodsFor: 'miscellaneous' stamp: 'sw 7/5/2004 18:21'!
descriptionForPartsBin
	^ self partName:	'Trash'
		categories:		#('Useful' ' Basic')
		documentation:	'a tool for discarding objects'! !

