'From Squeak3.7beta of ''1 April 2004'' [latest update: #5905] on 26 August 2004 at 11:26:54 am'!
"Change Set:		CommentChecker-dtl
Date:			26 August 2004
Author:			dtl

Check a package to make sure that it has a reasonable number
of class comments. Run this check prior to accepting a package for
inclusion in the image.

For a packaged identified by a category:
	SystemOrganization commentInventory: 'Morphic*'

Or, for any class in package of interest:
	Morph commentInventory

These queries answer a string such as this:
  'There are 411 classes in Morphic* of which 225 have comments and 186 do not yet have comments.'

For a list of uncommented classes in a category:
	SystemOrganization uncommentedClassesIn: 'Morphic*'

"!


!ClassDescription methodsFor: 'accessing class hierarchy' stamp: 'dtl 8/26/2004 11:02'!
commentInventory
	"Answer a string with a count of the classes with and without comments 
	for all the classes in the package of which this class is a member."

	"Morph commentInventory"

	^ SystemOrganization commentInventory: (self category copyUpTo: $-), '*'! !


!SystemOrganizer methodsFor: 'query' stamp: 'dtl 8/26/2004 11:18'!
commentInventory: categoryName

	"SystemOrganization commentInventory: 'Morphic*'"

	| classes commentedClasses |
	classes _ OrderedCollection new.
	self categories withIndexCollect: [:cat :idx |
		(categoryName match: cat)
			ifTrue: [classes addAll: (self listAtCategoryNumber: idx)]
			ifFalse: [nil]].
	commentedClasses _ classes select: [:catCls | (Smalltalk at: catCls) hasComment].
	^ 'There are ' , classes size asString , ' classes in ' , categoryName ,
		' of which ' , commentedClasses size asString , ' have comments and ',
		(classes size - commentedClasses size) asString , ' do not yet have comments.'
! !

!SystemOrganizer methodsFor: 'query' stamp: 'dtl 8/26/2004 11:23'!
uncommentedClassesIn: categoryName

	"SystemOrganization uncommentedClassesIn: 'Morphic*'"

	| classes |
	classes _ OrderedCollection new.
	self categories withIndexCollect: [:cat :idx |
		(categoryName match: cat)
			ifTrue: [classes addAll: (self listAtCategoryNumber: idx)]
			ifFalse: [nil]].
	^ (classes collect: [:clsName | Smalltalk at: clsName]
		thenSelect: [:cls | cls hasComment not]) asArray
! !


!SystemOrganizer reorganize!
('fileIn/Out' fileOut fileOutCategory: fileOutCategory:asHtml: fileOutCategory:on: fileOutCategory:on:initializing: objectForDataStream: superclassOrder:)
('remove' categoriesMatching: removeCategoriesMatching: removeMissingClasses removeSystemCategory:)
('query' commentInventory: uncommentedClassesIn:)
('private' ifClassOrganizerDo:)
!

