'From Squeak3.8 of ''5 May 2005'' [latest update: #6665] on 21 December 2005 at 10:36:03 am'!
"Change Set:		DebuggerFix-dgd
Date:			18 December 2005
Author:			Diego Gomez Deck <DiegoGomezDeck@consultar.com>

Fix an error in the incremental programming facilities providen by the Debugger.

Error: When a method is implemented using the [Create] button from the debugger, the method is called with only one parameter: The failed message

Fix: Moves the arguments from the message to the context temps.
"!


!ContextPart methodsFor: 'accessing' stamp: 'dgd 12/18/2005 11:05'!
temps: anArray
	"Store the arguments as the temporary variables"

	anArray
		withIndexDo:[:each :index | self tempAt: index put: each]
! !


!Debugger methodsFor: 'context stack menu' stamp: 'dgd 12/18/2005 11:05'!
implement: aMessage inClass: aClass
	
	| category |
	category := self askForCategoryIn: aClass default: 'as yet unclassified'.
	aClass compile: aMessage createStubMethod classified: category.

	self setContentsToForceRefetch.
	self selectedContext privRefreshWith: (aClass lookupSelector: aMessage selector).
	self selectedContext temps: aMessage arguments.
	self resetContext: self selectedContext.
	self debug.
! !

